;******************************************************************************
;* ByteKiller                                                                 *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.2-1.3

BYT13	dc.w	byt20-byt13,byt13t-byt13,CN_BytKil13,typenum
	dc.b	CRU_Address,0
	dc.w	$134
	dc.l	0
	dc.w	byt13d-byt13,_byt13-byt13,0

BYT13T	PSNAME	"ByteKiller 1.2-1.3"

BYT13D	dc.w	$5c,12-1
	dc.l	$6000ffd8,$72026100,$006a0c02,$00026d16
	dc.l	$0c020003,$67e67208,$61000058,$3602323c
	dc.l	$000c6000,$000c323c,$0009d242,$54423602

_BYT13
	move.l	$2a(a0),UI_Address(a4)
	move.l	$d0(a0),UI_JumpAdr(a4)

	moveq	#0,d5
	move.b	$49(a0),d5
	move.w	$a0(a0),d6
	move.w	$a8(a0),d7
	lea	$10c(a0),a0
	bra.w	bytchk
;------------------------------------------------------------------------------
; 2.0

BYT20	dc.w	byt30-byt20,byt20t-byt20,CN_BytKil20,typenum
	dc.b	CRU_Address,0
	dc.w	$112
	dc.l	0
	dc.w	byt20d-byt20,_byt20-byt20,0

BYT20T	PSNAME	"ByteKiller 2.0"

BYT20D	dc.w	$5c,12-1
	dc.l	$60de7202,$614ab43c,$00026d12,$b43c0003
	dc.l	$67ea7208,$613a3602,$323c000c,$600a323c
	dc.l	$0009d242,$54423602,$6126534a,$14b22000

_BYT20
	move.l	$34(a0),UI_Address(a4)
	move.l	$c0(a0),UI_JumpAdr(a4)

	moveq	#0,d5
	move.b	$51(a0),d5
	move.w	$9a(a0),d6
	move.w	$a0(a0),d7
	lea	$ea(a0),a0
	bra.w	bytchk
;------------------------------------------------------------------------------
; 3.0

BYT30	dc.w	bytp10-byt30,byt30t-byt30,CN_BytKil30,typenum
	dc.b	CRU_Address,0
	dc.w	$f0
	dc.l	0
	dc.w	byt30d-byt30,_byt30-byt30,0

BYT30T	PSNAME	"ByteKiller 3.0"

BYT30D	dc.w	$5c,12-1
	dc.l	$780860de,$72026142,$b4066d0e,$b40567ee
	dc.l	$72086136,$3602720c,$600a7209,$d2425442
	dc.l	$36021c83,$6124534a,$14b22000,$51cbfff8

_BYT30
	move.l	$2a(a0),UI_Address(a4)
	move.l	$b6(a0),UI_JumpAdr(a4)

	moveq	#8,d5
	moveq	#12,d6
	moveq	#9,d7
	lea	$dc(a0),a0
	bra.w	bytchk
;------------------------------------------------------------------------------
; Pro 1.0

BYTP10	dc.w	bytp10k-bytp10,bytp10t-bytp10,CN_BytKilPro10,typenum
	dc.b	CRU_Address,0
	dc.w	$138
	dc.l	0
	dc.w	bytp10d-bytp10,_bytp10-bytp10,0

BYTP10T	PSNAME	"ByteKiller Pro 1.0"

BYTP10D	dc.w	$20,12-1
	dc.l	$20102228,$00042a28,$000841e8,$000c2449
	dc.l	$d1c0d5c1,$2020b185,$e288660a,$2020b185
	dc.l	$44fc0010,$e2906542,$72087601,$e288660a


_BYTP10
	move.l	$40(a0),UI_Address(a4)
	move.l	$f2(a0),UI_JumpAdr(a4)

	moveq	#0,d5
	move.b	$6d(a0),d5
	moveq	#0,d6
	move.b	$c5(a0),d6
	moveq	#0,d7
	move.b	$c9(a0),d7
	lea	$110(a0),a0
	bra.w	bytchk
;------------------------------------------------------------------------------
; Pro 1.0 Killer

BYTP10K	dc.w	chry09-bytp10k,bytp10kt-bytp10k,CN_BytKilPro10K,typenum
	dc.b	CRU_Address,0
	dc.w	$15a
	dc.l	0
	dc.w	bytp10kd-bytp10k,_bytp10k-bytp10k,0

BYTP10KT PSNAME	"ByteKiller Pro 1.0 Killer"

BYTP10KD dc.w	$42,12-1
	dc.l	$20102228,$00042a28,$000841e8,$000c2449
	dc.l	$d1c0d5c1,$2020b185,$e288660a,$2020b185
	dc.l	$44fc0010,$e2906542,$72087601,$e288660a

_BYTP10K
	move.l	$62(a0),UI_Address(a4)
	move.l	$114(a0),UI_JumpAdr(a4)

	moveq	#0,d5
	move.b	$8f(a0),d5
	moveq	#0,d6
	move.b	$e7(a0),d6
	moveq	#0,d7
	move.b	$eb(a0),d7
	lea	$132(a0),a0
;;	bra.b	bytchk
;------------------------------------------------------------------------------
; ByteKiller Checksum Unpacker
;
; IN :	A0 = Pointer To Crunched Data
;	D5 = Crunch Value 1
;	D6 = Crunch Value 2
;	D7 = Crunch Value 3
;
; OUT:	D0 = Success (0=Error)
;

BYTCHK	move.l	4(a0),d0		;Number Of Bytes Decrunched
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	bytchko

	move.l	d0,a1
BYTCHK1	move.l	(a0)+,d0		;Crunched Size
	move.l	(a0)+,a2		;Decrunched Size
	move.l	(a0)+,d4		;Checksum
	bsr.b	bytunp
	tst.l	d0
	beq.b	.ok
	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	moveq	#0,d0
	bra.b	bytchko

.OK	moveq	#-1,d0
BYTCHKO	rts
;------------------------------------------------------------------------------
; ByteKiller Unpacker Routine
;
; IN :	D0 = Crunched Size
;	D4 = Checksum
;	D5 = Check Byte 1
;	D6 = Check Byte 2
;	D7 = Check Byte 3
;	A0 = Start Of Crunched Data
;	A1 = Start Of Decrunched Data
;	A2 = Decrunched Size
;
; OUT:	D0 = Success (0=Ok)
;

BYTUNP	add.l	a1,a2			;End Address Of Decrunched Data
	add.l	d0,a0			;End Address Of Crunched Data

BYTUNP1	move.l	-(a0),d0
	eor.l	d0,d4
BYTUNP2	lsr.l	#1,d0
	bne.b	bytunp3
	bsr.b	bytun15
BYTUNP3	bcs.b	bytun13

	move.w	d5,d1
	moveq	#1,d3
	lsr.l	#1,d0
	bne.b	bytunp4
	bsr.b	bytun15
BYTUNP4	bcs.b	bytunp9

	moveq	#3,d1
	bsr.b	bytun16
	move.w	d2,d3
BYTUNP5	moveq	#7,d1
BYTUNP6	lsr.l	#1,d0
	bne.b	bytunp7
	bsr.b	bytun15
BYTUNP7	roxl.l	#1,d2
	dbra	d1,bytunp6
	move.b	d2,-(a2)
	cmp.l	a1,a2
	dbeq	d3,bytunp5
	bra.b	bytun11

BYTUNP8	move.w	d7,d1
	add.w	d2,d1
	addq.w	#2,d2
	move.w	d2,d3
BYTUNP9	bsr.b	bytun16
BYTUN10	move.b	-1(a2,d2.w),-(a2)
	cmp.l	a1,a2
	dbeq	d3,bytun10
BYTUN11	cmp.w	#-1,d3
	beq.b	bytunp2
	move.l	d4,d0
	rts				;Get Out

BYTUN13	moveq	#2,d1
	bsr.b	bytun16
	cmp.b	#2,d2
	blt.b	bytunp8
	cmp.b	#3,d2
	bne.b	bytun14
	moveq	#8,d1
	bsr.b	bytun16
	move.w	d2,d3
	addq.w	#8,d3
	bra.b	bytunp5

BYTUN14	moveq	#8,d1
	bsr.b	bytun16
	move.w	d2,d3
	move.w	d6,d1
	bra.b	bytunp9

BYTUN15	move.l	-(a0),d0
	eor.l	d0,d4
	move.w	#$10,ccr
	roxr.l	#1,d0
	rts

BYTUN16	subq.w	#1,d1
	moveq	#0,d2
BYTUN17	lsr.l	#1,d0
	bne.b	bytun18
	bsr.b	bytun15
BYTUN18	roxl.l	#1,d2
	dbra	d1,bytun17
	rts
;------------------------------------------------------------------------------
