;******************************************************************************
;* Crunch-Mania                                                               *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.4-1.91

CMAN191	dc.w	cman191h-cman191,cman191t-cman191,CN_CrMania191,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$1d8
	dc.l	0
	dc.w	_cman191t-cman191,_cman191-cman191,0

CMAN191T PSNAME	"Crunch-Mania 1.4-1.91"

_CMAN191T
	lea	.tsttab(pc),a1
	bra.w	crmchk

.TSTTAB	dc.l	$76107800,$b3cd6f00,$00ce617e,$64207800
	dc.l	$72086100,$008e1300,$51ccfff6,$60e6780e
	dc.l	$72056166,$6502720e,$6178d840,$60e2615a

_CMAN191
	moveq	#0,d4
	bra.w	crmunp
;------------------------------------------------------------------------------
; 1.8t-1.91 Huffman

CMAN191H dc.w	cman191l-cman191h,cman191ht-cman191h,CN_CrMania191H,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$1d8
	dc.l	0
	dc.w	_cman191ht-cman191h,_cman191h-cman191h,0

CMAN191HT PSNAME "Crunch-Mania 1.8t-1.91 Huffman"

_CMAN191HT
	lea	.tsttab(pc),a1
	bra.w	crmchk

.TSTTAB	dc.l	$7e109e40,$eeae3e00,$761041ee,$049e740f
	dc.l	$429851ca,$fffc41ee,$04be49ee,$009e7409
	dc.l	$610000de,$41ee049e,$49ee0080,$74046100

_CMAN191H
	moveq	#1,d4
	bra.w	crmunp
;------------------------------------------------------------------------------
; 1.8t-1.91 Library

CMAN191L dc.w	cman191lh-cman191l,cman191lt-cman191l,CN_CrMania191L,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$74
	dc.l	0
	dc.w	_cman191lt-cman191l,_cman191l-cman191l,0

CMAN191LT PSNAME "Crunch-Mania 1.8t-1.91 Library"

_CMAN191LT
	moveq	#0,d0
	cmp.l	#$3f3,(a0)
	bne.b	.out
	move.l	16(a0),d1
	sub.l	12(a0),d1
	lsl.l	#2,d1
	lea	32(a0,d1.l),a0

	tst.b	$32(a0)
	bne.b	.out
	lea	tsttab(pc),a1
	moveq	#8-1,d1
	bsr.w	crmchkt
.OUT	rts

TSTTAB	dc.l	$48e7ffff,$43fa0014,$2c780004,$4eaefe68
	dc.l	$2c40200e,$67ee4eae,$ffe24372,$4d2e6c69

_CMAN191L
	moveq	#0,d4
	bra.w	crmunp1
;------------------------------------------------------------------------------
; 1.8t-1.91 Library/Huffman

CMAN191LH dc.w	cman191s-cman191lh,cman191lht-cman191lh,CN_CrMania191LH,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$74
	dc.l	0
	dc.w	_cman191lht-cman191lh,_cman191lh-cman191lh,0

CMAN191LHT PSNAME "Crunch-Mania 1.8t-1.91 Library/Huffman"

_CMAN191LHT
	moveq	#0,d0
	cmp.l	#$3f3,(a0)
	bne.b	.out
	move.l	16(a0),d1
	sub.l	12(a0),d1
	lsl.l	#2,d1
	lea	32(a0,d1.l),a0

	cmp.b	#1,$32(a0)
	bne.b	.out
	lea	tsttab(pc),a1
	moveq	#8-1,d1
	bsr.w	crmchkt
.OUT	rts

_CMAN191LH
	moveq	#1,d4
	bra.w	crmunp1
;------------------------------------------------------------------------------
; 1.4-1.91 Simple

CMAN191S dc.w	cman191a-cman191s,cman191st-cman191s,CN_CrMania191S,typenum
	dc.b	CRU_Object,0
	dc.w	$1aa
	dc.l	0
	dc.w	cman191sd-cman191s,_cman191s-cman191s,0

CMAN191ST PSNAME "Crunch-Mania 1.4-1.91 Simple"

CMAN191SD dc.w	$30,12-1
	dc.l	$00ce617e,$64207800,$72086100,$008e1300
	dc.l	$51ccfff6,$60e6780e,$72056166,$6502720e
	dc.l	$6178d840,$60e2615a,$65067201,$78016018

_CMAN191S
	moveq	#0,d4
	bra.w	crmunp2
;------------------------------------------------------------------------------
; 1.4-1.91 Address

CMAN191A dc.w	cman191ah-cman191a,cman191at-cman191a,CN_CrMania191A,typenum
	dc.b	CRU_Address,0
	dc.w	$15a
	dc.l	0
	dc.w	cman191ad-cman191a,_cman191a-cman191a,0

CMAN191AT PSNAME "Crunch-Mania 1.4-1.91 Address"

CMAN191AD dc.w	$30,12-1
	dc.l	$28db5387,$66fa2a49,$d3c1d5c2,$30222c22
	dc.l	$7e109e40,$eeae3e00,$76107800,$b3cd6f00
	dc.l	$00ce617e,$64207800,$72086100,$008e1300

_CMAN191A
	move.l	$2a(a0),UI_Address(a4)
	move.l	$144(a0),UI_JumpAdr(a4)

	lea	$148(a0),a2
	lea	FastDecruncher(pc),a5
	bra.w	ucrm
;------------------------------------------------------------------------------
; 1.9t-1.91 Address/Huffman

CMAN191AH
	dc.w	cman18ap-cman191ah,cman191aht-cman191ah,CN_CrMania191AH,typenum
	dc.b	CRU_Address,0
	dc.w	$15a
	dc.l	0
	dc.w	cman191ahd-cman191ah,_cman191ah-cman191ah,0

CMAN191AHT PSNAME "Crunch-Mania 1.9t-1.91 Address/Huffman"

CMAN191AHD dc.w	$54,12-1
	dc.l	$41ee049e,$740f4298,$51cafffc,$41ee04be
	dc.l	$49ee009e,$74096100,$00de41ee,$049e49ee
	dc.l	$00807404,$610000d0,$47ee04be,$49eefffe

_CMAN191AH
	move.l	$2a(a0),UI_Address(a4)
	move.l	$1e0(a0),UI_JumpAdr(a4)

	lea	$1e4(a0),a2
	lea	FastDecruncherHuff(pc),a5
	bra.w	ucrm
;------------------------------------------------------------------------------
; 1.4-1.8t Address/Professional

CMAN18AP
	dc.w	cman191ap-cman18ap,cman18apt-cman18ap,CN_CrMania18AP,typenum
	dc.b	CRU_Address,0
	dc.w	$15a
	dc.l	0
	dc.w	cman18apd-cman18ap,_cman18ap-cman18ap,0

CMAN18APT PSNAME "Crunch-Mania 1.4-1.8t Address/Pro"

CMAN18APD dc.w	$30,12-1
	dc.l	$0000b7c9,$6f1c2649,$d7c1b7ca,$6f14264a
	dc.l	$49e90000,$2e02e48f,$5287244c,$28db5387
	dc.l	$66fa2a49,$d3c1d5c2,$30222c22,$7e109e40

_CMAN18AP
	move.l	$46(a0),UI_Address(a4)
	move.l	$180(a0),UI_JumpAdr(a4)

	lea	$184(a0),a2
	lea	FastDecruncher(pc),a5
	bra.w	ucrm
;------------------------------------------------------------------------------
; 1.9t-1.91 Address/Professional

CMAN191AP
	dc.w	cman19aph-cman191ap,cman191apt-cman191ap,CN_CrMania191AP,typenum
	dc.b	CRU_Address,0
	dc.w	$15a
	dc.l	0
	dc.w	cman191apd-cman191ap,_cman191ap-cman191ap,0

CMAN191APT PSNAME "Crunch-Mania 1.9t-1.91 Address/Pro"

CMAN191APD dc.w	$4a,12-1
	dc.l	$0000b7c9,$6f1c2649,$d7c1b7ca,$6f14264a
	dc.l	$49e90000,$2e02e48f,$5287244c,$28db5387
	dc.l	$66fa2a49,$d3c1d5c2,$30222c22,$7e109e40

_CMAN191AP
	move.l	$60(a0),UI_Address(a4)
	move.l	$1b4(a0),UI_JumpAdr(a4)

	lea	$1b8(a0),a2
	lea	FastDecruncher(pc),a5
	bra.w	ucrm
;------------------------------------------------------------------------------
; 1.9t Address/Professional/Huffman

CMAN19APH dc.w	cman191aph-cman19aph,cman19apht-cman19aph,CN_CrMania19APH,typenum
	dc.b	CRU_Address,0
	dc.w	$15a
	dc.l	0
	dc.w	cman19aphd-cman19aph,_cman191aph-cman19aph,0

CMAN19APHT PSNAME "Crunch-Mania 1.9t Address/Pro/Huffman"

CMAN19APHD dc.w	$44,12-1
	dc.l	$221a241a,$47ea0000,$b7c96f1c,$2649d7c1
	dc.l	$b7ca6f14,$264a49e9,$00002e02,$e48f5287
	dc.l	$244c28db,$538766fa,$2a4948e7,$040cd3c1
;------------------------------------------------------------------------------
; 1.91 Address/Professional/Huffman

CMAN191APH dc.w	cman191d-cman191aph,cman191apht-cman191aph,CN_CrMania191APH,typenum
	dc.b	CRU_Address,0
	dc.w	$15a
	dc.l	0
	dc.w	cman191aphd-cman191aph,_cman191aph-cman191aph,0

CMAN191APHT PSNAME "Crunch-Mania 1.91 Address/Pro/Huffman"

CMAN191APHD dc.w $44,12-1
	dc.l	$221a241a,$47ea0010,$b7c96f1c,$2649d7c1
	dc.l	$b7ca6f14,$264a49e9,$fff02e02,$e48f5287
	dc.l	$244c28db,$538766fa,$2a4948e7,$040cd3c1

_CMAN191APH
	move.l	$60(a0),UI_Address(a4)
	move.l	$250(a0),UI_JumpAdr(a4)

	lea	$254(a0),a2
	lea	FastDecruncherHuff(pc),a5
	bra.w	ucrm
;------------------------------------------------------------------------------
; 1.4-1.91 Data

CMAN191D dc.w	cman191de-cman191d,cman191dt-cman191d,CN_CrMania191D,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	20
	dc.l	"CrM!"
	dc.w	0,_cman191d-cman191d,0

CMAN191DT PSNAME "Crunch-Mania 1.4-1.91 Data"

_CMAN191D
	lea	6(a0),a2
	lea	FastDecruncher(pc),a5
	bra.w	ucrm
;------------------------------------------------------------------------------
; 1.9t-1.91 Encrypted Data

CMAN191DE
	dc.w	cman191ds-cman191de,cman191det-cman191de,CN_CrMania191DE,typenum
	dc.b	CRU_Data,PSF_Data!PSF_Encrypted
	dc.w	20
	dc.l	"crM!"
	dc.w	0,_cman191de-cman191de,0

CMAN191DET PSNAME "Crunch-Mania 1.9t-1.91 Encrypted Data"

_CMAN191DE
	lea	14(a0),a1
	add.l	10(a0),a1
	bsr.w	crmpass			;Test Password
	beq.b	.out

	lea	4(a0),a2
	lea	FastDecruncher(pc),a5
	bsr.w	ucrme
.OUT	rts
;------------------------------------------------------------------------------
; 1.8t-1.91 Sample Data

CMAN191DS
	dc.w	cman191dse-cman191ds,cman191dst-cman191ds,CN_CrMania191DS,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	20
	dc.l	"Crm!"
	dc.w	0,_cman191ds-cman191ds,0

CMAN191DST PSNAME "Crunch-Mania 1.8t-1.91 Sample Data"

_CMAN191DS
	lea	6(a0),a2
	lea	crmsdec(pc),a5
	lea	FastDecruncher(pc),a6
	bra.w	ucrm
;------------------------------------------------------------------------------
; 1.9t-1.91 Encrypted Sample Data

CMAN191DSE
	dc.w	cman191dh-cman191dse,cman191dset-cman191dse,CN_CrMania191DSE,typenum
	dc.b	CRU_Data,PSF_Data!PSF_Encrypted
	dc.w	20
	dc.l	"crm!"
	dc.w	0,_cman191dse-cman191dse,0

CMAN191DSET PSNAME "Crunch-Mania 1.9t-1.91 Encrypted Sample Data"

_CMAN191DSE
	lea	14(a0),a1
	add.l	10(a0),a1
	bsr.w	crmpass			;Test Password
	beq.b	.out

	lea	4(a0),a2
	lea	crmsdec(pc),a5
	lea	FastDecruncher(pc),a6
	bsr.w	ucrme
.OUT	rts
;------------------------------------------------------------------------------
; 1.8t-1.91 Data/Huffman

CMAN191DH
	dc.w	cman191dhe-cman191dh,cman191dht-cman191dh,CN_CrMania191DH,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	20
	dc.l	"CrM2"
	dc.w	0,_cman191dh-cman191dh,0

CMAN191DHT PSNAME "Crunch-Mania 1.8t-1.91 Data/Huffman"

_CMAN191DH
	lea	6(a0),a2
	lea	FastDecruncherHuff(pc),a5
	bra.w	ucrm
;------------------------------------------------------------------------------
; 1.9t-1.91 Encrypted Data/Huffman

CMAN191DHE
	dc.w	cman191dhs-cman191dhe,cman191dhet-cman191dhe,CN_CrMania191DHE,typenum
	dc.b	CRU_Data,PSF_Data!PSF_Encrypted
	dc.w	20
	dc.l	"crM2"
	dc.w	0,_cman191dhe-cman191dhe,0

CMAN191DHET PSNAME "Crunch-Mania 1.9t-1.91 Encrypted Data/Huffman"

_CMAN191DHE
	lea	14(a0),a1
	add.l	10(a0),a1
	bsr.w	crmpass			;Test Password
	beq.b	.out

	lea	4(a0),a2
	lea	FastDecruncherHuff(pc),a5
	bsr.w	ucrme
.OUT	rts
;------------------------------------------------------------------------------
; 1.8t-1.91 Sample Data/Huffman

CMAN191DHS
	dc.w	cman191dhse-cman191dhs,cman191dhst-cman191dhs,CN_CrMania191DHS,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	20
	dc.l	"Crm2"
	dc.w	0,_cman191dhs-cman191dhs,0

CMAN191DHST PSNAME "Crunch-Mania 1.8t-1.91 Sample Data/Huffman"

_CMAN191DHS
	lea	6(a0),a2
	lea	crmsdec(pc),a5
	lea	FastDecruncherHuff(pc),a6
	bra.w	ucrm
;------------------------------------------------------------------------------
; 1.9t-1.91 Encrypted Sample Data/Huffman

CMAN191DHSE
	dc.w	cmat10d-cman191dhse,cman191dhset-cman191dhse,CN_CrMania191DHSE,typenum
	dc.b	CRU_Data,PSF_Data!PSF_Encrypted
	dc.w	20
	dc.l	"crm2"
	dc.w	0,_cman191dhse-cman191dhse,0

CMAN191DHSET PSNAME "Crunch-Mania 1.9t-1.91 Encrypted Sample Data/Huffman"

_CMAN191DHSE
	lea	14(a0),a1
	add.l	10(a0),a1
	bsr.w	crmpass			;Test Password
	beq.b	.out

	lea	4(a0),a2
	lea	crmsdec(pc),a5
	lea	FastDecruncherHuff(pc),a6
	bsr.w	ucrme
.OUT	rts
;------------------------------------------------------------------------------
; Check File
;
; IN :	A1 = Pointer To Check Table
;
; OUT:	D0 = Success (0=Error)
;

CRMCHK	moveq	#0,d0
	cmp.l	#$3f3,(a0)
	bne.b	crmchko
	lea	startload-12*4-32(a0),a2

	move.l	16(a0),d1
	sub.l	12(a0),d1
	move.l	d1,d2
	lsl.l	#2,d1
	lea	32(a0,d1.l),a0

	move.l	-4(a0),d1
	and.l	#$3fffffff,d1
	lsl.l	#2,d1
	add.l	d1,a0

	lsl.l	#3,d2
	add.l	d2,a0
	cmp.l	a2,a0
	bhi.b	crmchko			;Out Of Range

	cmp.l	#$3e9,-8(a0)
	beq.b	crmchk1
	subq.l	#8,a0

CRMCHK1	lea	32(a0),a0
	moveq	#12-1,d1
;------------------------------------------------------------------------------
; Check With Table
;
; IN :	A0 = Pointer To Data
;	A1 = Pointer To Check Table
;	D1 = Number Of Longwords - 1
;
; OUT:	D0 = Success (0=Error)
;

CRMCHKT	cmpm.l	(a1)+,(a0)+
	bne.b	crmchko
	dbra	d1,crmchkt
	moveq	#-1,d0
CRMCHKO	tst.w	d0
	rts
;------------------------------------------------------------------------------
; Unpack & Rebuild File
;

CRMUNP	move.l	8(a0),d7
	subq.l	#2,d7			;Number Of Hunks

	move.l	16(a0),d0
	sub.l	12(a0),d0
	lsl.l	#2,d0
	lea	32(a0,d0.l),a0		;Start Of First Hunk Data

	move.l	-4(a0),d0
	lsl.l	#2,d0
	add.l	d0,a0
	move.l	a0,a5			;Start Of Hunks

	move.l	d7,d0
	lsl.l	#3,d0
	lea	8(a0,d0.l),a0		;Last Hunk Data
	move.w	2(a0),d0
	lea	2(a0,d0.w),a2		;Start Of Crunched Data

	move.l	d7,d0
	lsl.l	#2,d0
	move.l	a2,a3
	sub.l	d0,a3			;Hunk Lengths
	moveq	#24,d3
	bra.b	crmunp0


CRMUNP1	move.l	8(a0),d7
	subq.l	#1,d7			;Number Of Hunks

	move.l	16(a0),d0
	sub.l	12(a0),d0
	lsl.l	#2,d0
	lea	32(a0,d0.l),a0		;Start Of First Hunk Data

	lea	$34(a0),a3		;Hunk Lengths

	move.l	-4(a0),d0
	lsl.l	#2,d0
	add.l	d0,a0
	move.l	a0,a5			;Start Of Hunks

	move.l	d7,d0
	subq.l	#1,d0
	lsl.l	#3,d0
	lea	8(a0,d0.l),a0		;Last Hunk Data
	move.l	a0,a2			;Start Of Crunched Data
	moveq	#20,d3
	bra.b	crmunp0


CRMUNP2	move.l	8(a0),d7		;Number Of Hunks
	subq.l	#1,d7

	move.l	16(a0),d0
	sub.l	12(a0),d0
	lsl.l	#2,d0
	lea	32(a0,d0.l),a0		;Start Of First Hunk Data

	move.w	6(a0),d0
	lea	6(a0,d0.w),a2		;Start Of Crunched Data

	move.l	d7,d0
	lsl.l	#2,d0
	move.l	a2,a3
	sub.l	d0,a3			;Hunk Lengths
	moveq	#24,d3


CRMUNP0	clr.l	-(sp)

	move.l	a3,a0
	move.l	d7,d0
	subq.l	#1,d0
	moveq	#0,d1
UCRMAN1	add.l	(a0)+,d1
	dbra	d0,ucrman1
	lsl.l	#2,d1
	move.l	d1,d5

	move.l	-12(a3),d0		;Decrunched Length
	cmp.w	#CN_CrMania191L,UI_CrunchNum(a4)
	beq.b	ucrma1a
	cmp.w	#CN_CrMania191LH,UI_CrunchNum(a4)
	beq.b	ucrma1a
	move.l	(a2),d0			;Decrunched Length

UCRMA1a	sub.l	d1,d0
	move.l	d0,d6			;Extra Mem
	lsl.l	#2,d0
	add.l	d0,d1

	move.l	d7,d0
	lsl.l	#4,d0
	add.l	d1,d0
	add.l	#20,d0			;Destination Buffer Length
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	ucrmano

	move.l	d6,d0
	beq.b	ucrman2			;No Extra Mem
	bsr.w	alcmem
	move.l	d0,(sp)
	bne.b	ucrman2
	move.l	UI_DecrunchAdr(a4),a1
	bsr.w	fremem
	clr.l	UI_DecrunchAdr(a4)
	bra.w	ucrmano

UCRMAN2	move.l	UI_DecrunchAdr(a4),a1
	move.l	d7,d0
	lsl.l	#2,d0
	lea	20(a1,d0.l),a1
	move.l	a1,a6
	add.l	d5,a6			;Add Hunk Length

	movem.l	d3/d5-d7/a2-a6,-(sp)
	cmp.w	#CN_CrMania191L,UI_CrunchNum(a4)
	beq.b	ucrma2a
	cmp.w	#CN_CrMania191LH,UI_CrunchNum(a4)
	beq.b	ucrma2a
	move.l	(a2)+,d1		;Unpacked Length
	move.l	(a2)+,d2		;Packed Length
	bra.b	ucrma2b

UCRMA2a	move.l	-12(a3),d1
	move.l	-8(a3),d2

UCRMA2b	tst.b	d4
	beq.b	ucrman3
	bsr.w	FastDecruncherHuff
	bra.b	ucrman4

UCRMAN3	bsr.w	FastDecruncher
UCRMAN4	movem.l	(sp)+,d3/d5-d7/a2-a6

; Rebuild Object File

	cmp.w	#CN_CrMania191S,UI_CrunchNum(a4)
	beq.b	ucrma4a
	move.l	a5,a2			;Start Of Hunks
	bra.b	ucrma4b

UCRMA4a	addq.l	#4,a2
	move.l	(a2)+,d0
	addq.l	#3,d0
	and.w	#$fffc,d0
	add.l	d0,a2

UCRMA4b	move.l	UI_DecrunchAdr(a4),a0
	move.l	#$3f3,(a0)+
	clr.l	(a0)+
	move.l	d7,(a0)+
	clr.l	(a0)+
	move.l	d7,d0
	subq.l	#1,d0
	move.l	d0,(a0)+

	move.l	UI_CrunchAdrTemp(a4),a1
	lea	(a1,d3.w),a1		;Hunk Lengths
UCRMAN5	move.l	(a1)+,(a0)+		;Copy Lengths
	dbra	d0,ucrman5

	move.l	(sp),d0
	beq.b	ucrman7
	move.l	d0,a1
	movem.l	a0-a1,-(sp)
	lea	(a0,d5.l),a0
	move.l	d6,d0
UCRMAN6	move.b	(a0)+,(a1)+		;Copy Last Block In Safe Memory
	subq.l	#1,d0
	bne.b	ucrman6
	movem.l	(sp)+,a0-a1

UCRMAN7	moveq	#0,d4
UCRMAN8	cmp.w	#CN_CrMania191,UI_CrunchNum(a4)
	beq.b	ucrma8a
	cmp.w	#CN_CrMania191H,UI_CrunchNum(a4)
	beq.b	ucrma8a
	cmp.w	#CN_CrMania191S,UI_CrunchNum(a4)
	beq.b	ucrma8a
	bsr.b	crmcop
	move.l	#$3e9,(a0)+
	bsr.b	crmcop
	bra.b	ucrma9a

UCRMA8a	bsr.b	crmcop
	move.l	(a2)+,d0
	move.l	d0,(a0)+
	bsr.b	crmcop
	cmp.w	#$3eb,d0
	bne.b	ucrman9
	move.l	(a2)+,(a0)+
	move.l	(a3)+,d0
	bra.b	ucrma10

UCRMAN9	addq.l	#4,a2
UCRMA9a	move.l	(a3)+,d0
	move.l	d0,(a0)+
UCRMA10	lsl.l	#2,d0
	add.l	d0,a0
	tst.l	(sp)
	beq.b	ucrma11
	bsr.b	crmrel

UCRMA11	bsr.b	crmcop
	move.l	#$3f2,(a0)+
	addq.w	#1,d4
	cmp.w	d7,d4
	bne.b	ucrma8a

	sub.l	UI_DecrunchAdr(a4),a0
	move.l	a0,UI_DecrunchLen(a4)

	move.l	(sp),d0
	beq.b	ucrma12
	move.l	d0,a1
	bsr.w	fremem			;Free Extra Memory
UCRMA12	addq.l	#4,sp
	moveq	#-1,d0
UCRMANO	rts

; Copy Routine

CRMCOP	move.l	a1,-(sp)
	move.l	a6,a1
	cmp.l	a0,a1
	beq.b	crmcop2
CRMCOP1	move.l	-(a1),4(a1)
	cmp.l	a1,a0
	bne.b	crmcop1
CRMCOP2	addq.l	#4,a6
	move.l	(sp)+,a1
	rts

; Reloc Routine

CRMREL	move.l	a1,-(sp)
	moveq	#0,d2
CRMREL1	move.w	(a1)+,d0
	bmi.b	crmre11
	cmp.w	d4,d0
	beq.b	crmrel5
CRMREL2	move.w	(a1)+,d0
	beq.b	crmrel1
	subq.w	#1,d0
	addq.l	#2,a1
CRMREL3	tst.w	(a1)+
	bne.b	crmrel4
	tst.l	(a1)+
CRMREL4	dbra	d0,crmrel3
	bra.b	crmrel2

CRMREL5	moveq	#1,d2
	bsr.b	crmcop
	move.l	#$3ec,(a0)+
CRMREL6	moveq	#0,d0
	move.w	(a1)+,d0
	beq.b	crmrel1
	bsr.b	crmcop
	move.l	d0,(a0)+
	move.w	d0,d1
	move.w	(a1)+,d0
	bsr.b	crmcop
	move.l	d0,(a0)+
	move.l	a1,-(sp)
	moveq	#0,d0
	move.w	d1,d0
	lsl.l	#2,d0
	move.l	a6,a1
	cmp.l	a0,a1
	beq.b	crmrel8
CRMREL7	move.l	-(a1),(a1,d0.l)
	cmp.l	a1,a0
	bne.b	crmrel7
CRMREL8	add.l	d0,a6
	move.l	(sp)+,a1
	moveq	#0,d3
	subq.w	#1,d1
CRMREL9	moveq	#0,d0
	move.w	(a1)+,d0
	bne.b	crmre10
	move.l	(a1)+,d0
CRMRE10	add.l	d0,d0
	add.l	d0,d3
	move.l	d3,(a0)+
	dbra	d1,crmrel9
	bra.b	crmrel6

CRMRE11	tst.w	d2
	beq.b	crmre12
	bsr.w	crmcop
	clr.l	(a0)+
CRMRE12	move.l	(sp)+,a1
	rts
;------------------------------------------------------------------------------
; Unpack Data
;
; IN :	A2 = Pointer To Data
;	A5 = Pointer To Decrunching Routine
;
; OUT:	D0 = Success (0=Error)
;

UCRM	move.l	(a2),d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	ucrmo

	move.l	d0,a1
	move.l	(a2)+,d1
	move.l	(a2)+,d2
	jsr	(a5)
	moveq	#-1,d0
UCRMO	rts
;------------------------------------------------------------------------------
; Unpack Encrypted Data
;
; IN :	A2 = Pointer To Data
;	A5 = Pointer To Decrunching Routine
;
; OUT:	D0 = Success (0=Error)
;

UCRME	moveq	#0,d7
	move.w	(a2),d7
	move.l	2(a2),d0
	move.l	d0,UI_DecrunchLen(a4)
	add.l	d7,d0
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	ucrmeo

	move.l	d0,a3
	lea	10(a2),a0
	lea	UI_PasswordStr(a4),a1
	move.l	6(a2),d0
	bsr.w	crmdcod

	move.l	d7,-(sp)
	move.l	a3,a1
	add.l	d7,a1
	move.l	2(a2),d1
	move.l	6(a2),d2
	move.l	a3,a2
	jsr	(a5)

	move.l	(sp)+,d7
	beq.b	ucrme2
	move.l	UI_DecrunchAdr(a4),a0
	move.l	a0,a1
	add.l	d7,a0
	move.l	UI_DecrunchLen(a4),d0
UCRME1	move.b	(a0)+,(a1)+
	subq.l	#1,d0
	bne.b	ucrme1

UCRME2	moveq	#-1,d0
UCRMEO	rts
;------------------------------------------------------------------------------
**-------------------------------------------------------------------
** This is the pure Decrunch-Routine
** The Registers have to be loaded with the following values:
** a1: Adr of Destination (normal)	** a2: Adr of Source (packed)
** d1: Len of Destination		** d2: Len of Source
**-------------------------------------------------------------------
FastDecruncher:
	move.l	a1,a5			;Decrunched Anfang (hier Ende des Decrunchens)
	add.l	d1,a1
	add.l	d2,a2
	move.w	-(a2),d0		;Anz Bits in letztem Wort
	move.l	-(a2),d6		;1.LW
	moveq	#16,d7			;Anz Bits
	sub.w	d0,d7			;Anz Bits, die rotiert werden mssen
	lsr.l	d7,d6			;1.Bits an Anfang bringen
	move.w	d0,d7			;Anz Bits, die noch im Wort sind
	moveq	#16,d3
	moveq	#0,d4
.DecrLoop:
	bsr.w	.BitTest
	bcc.s	.InsertSeq		;1.Bit 0: Sequenz
	moveq	#0,d4
** einzelne Bytes einfgen **
.InsertBytes:
	moveq	#8,d1
	bsr.w	.GetBits
	move.b	d0,-(a1)
	cmp.l	a5,a1
	dbeq	d4,.InsertBytes
.More	cmp.w	#-1,d4
	beq.b	.DecrLoop
	rts
*------------
.SpecialInsert:
	moveq	#14,d4
	moveq	#5,d1
	bsr.s	.BitTest
	bcs.s	.IB1
	moveq	#14,d1
.IB1:	bsr.s	.GetBits
	add.w	d0,d4
	bra.s	.InsertBytes
*------------
.InsertSeq:
** Anzahl der gleichen Bits holen **
	bsr.s	.BitTest
	bcs.s	.AB1
	moveq	#1,d1			;Maske: 0 (1 AB)
	moveq	#1,d4			;normal: Summe 1
	bra.s	.ABGet
.AB1:
	bsr.s	.BitTest
	bcs.s	.AB2
	moveq	#2,d1			;Maske: 01 (2 ABs)
	moveq	#3,d4			;ab hier: Summe mindestens 3
	bra.s	.ABGet
.AB2:
	bsr.s	.BitTest
	bcs.s	.AB3
	moveq	#4,d1			;Maske: 011 (4 ABs)
	moveq	#7,d4			;hier: Summe 11
	bra.s	.ABGet
.AB3:
	moveq	#8,d1			;Maske: 111 (8 ABs)
	moveq	#$17,d4			;hier: Summe 11
.ABGet:
	bsr.s	.GetBits
	add.w	d0,d4			;d0: Lnge der Sequenz - 1
	cmp.w	#22,d4
	beq.s	.SpecialInsert
	blt.s	.Cont
	subq.w	#1,d4
.Cont:
** SequenzAnbstand holen **
	bsr.s	.BitTest
	bcs.s	.DB1
	moveq	#9,d1			;Maske: 0 (9 DBs)
	moveq	#$20,d2
	bra.s	.DBGet
.DB1:
	bsr.s	.BitTest
	bcs.s	.DB2
	moveq	#5,d1			;Maske: 01 (5 DBs)
	moveq	#0,d2
	bra.s	.DBGet
.DB2:
	moveq	#14,d1			;Maske: 11 (12 DBs)
	move.w	#$220,d2
.DBGet:
	bsr.s	.GetBits
	add.w	d2,d0
	lea	0(a1,d0.w),a3		;a3 auf Anf zu kopierender Seq setzten
.InsSeqLoop:
	move.b	-(a3),-(a1)		;Byte kopieren
	cmp.l	a5,a1
	dbeq	d4,.InsSeqLoop
	bra.b	.More
*------------
.BitTest:
	subq.w	#1,d7
	bne.s	.BTNoLoop
	moveq	#16,d7			;hier kein add notwendig: d7 vorher 0
	move.w	d6,d0
	lsr.l	#1,d6			;Bit rausschieben und Flags setzen
	swap	d6			;ror.l	#16,d6
	move.w	-(a2),d6		;nchstes Wort holen
	swap	d6			;rol.l	#16,d6
	lsr.w	#1,d0			;Bit rausschieben und Flags setzen
	rts
.BTNoLoop:
	lsr.l	#1,d6			;Bit rausschieben und Flags setzen
	rts
*----------
.GetBits:				;d1:AnzBits->d0:Bits
	move.w	d6,d0			;d6:Akt Wort
	lsr.l	d1,d6			;nchste Bits nach vorne bringen
	sub.w	d1,d7			;d7:Anz Bits, die noch im Wort sind
	bgt.s	.GBNoLoop
;	add.w	#16,d7			;BitCounter korrigieren
	add.w	d3,d7			;BitCounter korrigieren
	ror.l	d7,d6			;restliche Bits re rausschieben
	move.w	-(a2),d6		;nchstes Wort holen
	rol.l	d7,d6			;und zurckrotieren
.GBNoLoop:
	add.w	d1,d1			;*2 (in Tab sind Ws)
	and.w	.AndData-2(pc,d1.w),d0	;unerwnschte Bits rausschmeien
.DecrEnd:
	rts		;a5: Start of decrunched Data
*----------
.AndData:
	dc.w	%1,%11,%111,%1111,%11111,%111111,%1111111
	dc.w	%11111111,%111111111,%1111111111
	dc.w	%11111111111,%111111111111
	dc.w	%1111111111111,%11111111111111
*-----------
;------------------------------------------------------------------------------
; Crunch Mania Decruncher Huffman
;
; IN :	A1 = Adr of Destination (normal)
;	A2 = Adr of Source (packed)
;	D1 = Len of Destination
;	D2 = Len of Source
;
; OUT:	D0 = Success (0=Error)
;

FastDecruncherHuff
	move.l	a4,-(sp)
	move.l	#$4e0,d0
	bsr.w	alcmem			;Allocate Huffman Decode Table
	move.l	d0,UI_Temp(a4)
	beq.w	fdehu6a

	move.l	d0,a6
	addq.l	#2,a6

	move.l	a1,d3
	add.l	d1,a1
	add.l	d2,a2
	move.w	-(a2),d0
	move.l	-(a2),d6
	moveq	#16,d7
	sub.w	d0,d7
	lsr.l	d7,d6
	move.w	d0,d7

FDEHU1	lea	$49e(a6),a0
	moveq	#15,d2
FDEHU2	clr.l	(a0)+
	dbra	d2,fdehu2

	lea	$4be(a6),a0
	lea	$9e(a6),a4
	moveq	#9,d2
	bsr.w	fdehu14
	lea	$49e(a6),a0
	lea	$80(a6),a4
	moveq	#4,d2
	bsr.w	fdehu14
	lea	$4be(a6),a3
	lea	-2(a6),a4
	bsr.w	fdehu18
	lea	$49e(a6),a3
	lea	$1e(a6),a4
	bsr.w	fdehu18
	moveq	#16,d1
	bsr.w	fdehu11
	move.w	d0,d5
	lea	$9e(a6),a0
	lea	-$1e(a0),a5

FDEHU3	move.l	a6,a4
	bsr.b	fdehu7
	btst	#8,d0
	bne.b	fdehu6
	move.w	d0,d4
	lea	$20(a6),a4
	exg	a0,a5
	bsr.b	fdehu7
	exg	a0,a5
	move.w	d0,d1
	move.w	d0,d2
	bne.b	fdehu4
	moveq	#1,d1
	moveq	#16,d2
FDEHU4	bsr.b	fdehu11
	bset	d2,d0
	lea	1(a1,d0.w),a3
FDEHU5	move.b	-(a3),-(a1)
	cmp.l	d3,a1
	dbeq	d4,fdehu5
	cmp.w	#-1,d4
	bne.b	fdehu6a
	move.b	-(a3),-(a1)
	cmp.l	d3,a1
	beq.b	fdehu6a
	move.b	-(a3),d0
FDEHU6	move.b	d0,-(a1)
	cmp.l	d3,a1
	dbeq	d5,fdehu3
	cmp.w	#-1,d5
	bne.b	fdehu6a
	moveq	#1,d1
	bsr.b	fdehu11
	bne.w	fdehu1

FDEHU6a	move.l	(sp)+,a4
	move.l	UI_Temp(a4),a1
	bsr.w	fremem
	clr.l	UI_Temp(a4)
	rts				;Get Out Of Decruncher

FDEHU7	moveq	#0,d1
FDEHU8	subq.w	#1,d7
	beq.b	fdehu9
	lsr.l	#1,d6
	bra.b	fdehu10

FDEHU9	moveq	#16,d7
	move.w	d6,d0
	lsr.l	#1,d6
	swap	d6
	move.w	-(a2),d6
	swap	d6
	lsr.w	#1,d0
FDEHU10	roxl.w	#1,d1
	move.w	(a4)+,d0
	cmp.w	d1,d0
	bls.b	fdehu8
	add.w	$3e(a4),d1
	add.w	d1,d1
	move.w	(a0,d1.w),d0
	rts

FDEHU11	move.w	d6,d0
	lsr.l	d1,d6
	sub.w	d1,d7
	bgt.b	fdehu12
	add.w	#16,d7
	ror.l	d7,d6
	move.w	-(a2),d6
	rol.l	d7,d6
FDEHU12	add.w	d1,d1
	and.w	fdehu13-2(pc,d1.w),d0
	rts

FDEHU13	dc.w	$0001,$0003,$0007,$000f,$001f,$003f,$007f,$00ff
	dc.w	$01ff,$03ff,$07ff,$0fff,$1fff,$3fff,$7fff,$ffff

FDEHU14	movem.l	d1-d5/a3,-(sp)
	moveq	#4,d1
	bsr.b	fdehu11
	move.w	d0,d5
	subq.w	#1,d5
	moveq	#0,d4
	sub.l	a3,a3
FDEHU15	addq.w	#1,d4
	move.w	d4,d1
	cmp.w	d2,d1
	ble.b	fdehu16
	move.w	d2,d1
FDEHU16	bsr.b	fdehu11
	move.w	d0,(a0)+
	add.w	d0,a3
	dbra	d5,fdehu15
	move.w	a3,d5
	subq.w	#1,d5
FDEHU17	move.w	d2,d1
	bsr.b	fdehu11
	move.w	d0,(a4)+
	dbra	d5,fdehu17
	movem.l	(sp)+,d1-d5/a3
	rts

FDEHU18	movem.l	d0-d7,-(sp)
	clr.w	(a4)+
	moveq	#14,d7
	moveq	#-1,d4
	moveq	#0,d3
	moveq	#0,d2
	moveq	#1,d1
FDEHU19	move.w	(a3)+,d6
	move.w	d3,$40(a4)
	move.w	-2(a4),d0
	add.w	d0,d0
	sub.w	d0,$40(a4)
	add.w	d6,d3
	mulu	d1,d6
	add.w	d6,d2
	move.w	d2,(a4)+
	lsl.w	#1,d2
	dbra	d7,fdehu19
	movem.l	(sp)+,d0-d7
	rts
;------------------------------------------------------------------------------
; Sample Decoder
;
; IN :	A6 = Pointer To Decruncher
;
; OUT:	D0 = Success (0=Error)
;

CRMSDEC	jsr	(a6)

	move.l	UI_DecrunchLen(a4),d1
	move.l	UI_DecrunchAdr(a4),a0
	move.b	(a0)+,d2
	subq.l	#1,d1
CRMSDE1	add.b	(a0),d2
	move.b	d2,(a0)+
	subq.l	#1,d1
	bne.b	crmsde1

	moveq	#-1,d0
	rts
;------------------------------------------------------------------------------
; Test Password
;
; IN :	A1 = Pointer To End Of Data
;
; OUT:	D0 = Success (0=Error)
;

CRMPASS	move.w	-(a1),d2
	and.w	#$fff0,d2
	lea	UI_PasswordStr(a4),a2
	moveq	#0,d0
	moveq	#0,d1
CRMPAS1	move.b	(a2)+,d0
	beq.b	crmpas2
	add.w	d0,d1
	add.w	d1,d1
	add.w	d1,d1
	bra.b	crmpas1

CRMPAS2	move.w	d1,d0
	and.w	#$fff0,d0
	and.w	#15,d1
	lsl.w	#4,d1
	add.w	d1,d0
	cmp.w	d0,d2
	beq.b	crmpaso
	move.w	#UERR_Password,UI_ErrorNum(a4)
	moveq	#0,d0
	rts

CRMPASO	moveq	#-1,d0
	rts
;------------------------------------------------------------------------------
; Decode Crunched Data
;
; IN :	A0 = Pointer To Crunched Data
;	A1 = Pointer To Password
;	A3 = Pointer To Destination Buffer
;	D0 = Length Of Crunched Data
;
; OUT:	Nothing
;

CRMDCOD	movem.l	d0-d3/a0-a4,-(sp)
	move.l	sp,a2
	lea	-256(sp),sp
	lsr.l	#1,d0
	subq.l	#2,d0
	bmi.b	crmdco6
	move.w	d0,d1
	swap	d0
	move.l	a1,a4
CRMDCO1	clr.b	-(a2)
	tst.b	(a1)+
	bne.b	crmdco1
	clr.b	-(a2)
	move.l	a2,d2
	btst	#0,d2
	beq.b	crmdco2
	clr.b	-(a2)

CRMDCO2	move.l	a2,a1
CRMDCO3	move.b	(a4)+,(a1)+
	bne.b	crmdco3

	move.l	a2,a1
	move.l	a1,a4
CRMDCO4	move.w	(a1),d2
	bne.b	crmdco5
	move.l	a4,a1
	move.w	(a1),d2
CRMDCO5	move.w	(a0)+,d3
	eor.w	d3,d2
	move.w	d2,(a3)+
	add.w	d2,(a1)+
	dbra	d1,crmdco4
	dbra	d0,crmdco4

	move.w	(a0),d0
	and.w	#15,d0
	move.w	d0,(a3)

CRMDCO6	lea	256(sp),sp
	movem.l	(sp)+,d0-d3/a0-a4
	rts
;------------------------------------------------------------------------------
