;******************************************************************************
;* Crunch-o-Matic                                                             *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0 Data

CMAT10D	dc.w	cmat10e-cmat10d,cmat10dt-cmat10d,CN_CrMatic10D,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	$18
	dc.l	$43ba4f4d
	dc.w	0,_cmat10d-cmat10d,0

CMAT10DT PSNAME "Crunch-o-Matic 1.0 Data"

_CMAT10D
	lea	4(a0),a5
	lea	14(a0),a0
	bra.w	ucmat
;------------------------------------------------------------------------------
; 1.0 Execute

CMAT10E	dc.w	cmat10m-cmat10e,cmat10et-cmat10e,CN_CrMatic10E,typenum
	dc.b	CRU_Object,0
	dc.w	$28a
	dc.l	0
	dc.w	cmat10ed-cmat10e,_cmat10e-cmat10e,0

CMAT10ET PSNAME "Crunch-o-Matic 1.0 Execute"

CMAT10ED dc.w	$142,12-1
	dc.l	$201b6784,$221b610e,$26092442,$d5dbd792
	dc.l	$538066f6,$60ea2255,$59895341,$65082251
	dc.l	$d3c9d3c9,$60f45889,$4e757680,$612e6448

_CMAT10E
	lea	$c6(a0),a5
	bsr.w	nhunk
	subq.l	#2,a0
	bra.w	ucmat
;------------------------------------------------------------------------------
; 1.0 Module

CMAT10M	dc.w	cmat10p-cmat10m,cmat10mt-cmat10m,CN_CrMatic10M,typenum
	dc.b	CRU_Object,0
	dc.w	$28a
	dc.l	0
	dc.w	cmat10md-cmat10m,_cmat10m-cmat10m,0

CMAT10MT PSNAME "Crunch-o-Matic 1.0 Module"

CMAT10MD dc.w	$142,12-1
	dc.l	$6100005e,$41fa0056,$43fa0044,$20b8006c
	dc.l	$21c9006c,$08390002,$00dff016,$66f60839
	dc.l	$000600bf,$e00166ec,$21fa0032,$006c6100

_CMAT10M
	bsr.w	nhunk
	move.l	a0,a5
	lea	10(a0),a0
	bra.w	ucmat
;------------------------------------------------------------------------------
; 1.0 Picture

CMAT10P	dc.w	cmat10t-cmat10p,cmat10pt-cmat10p,CN_CrMatic10P,typenum
	dc.b	CRU_Object,0
	dc.w	$28a
	dc.l	0
	dc.w	cmat10pd-cmat10p,_cmat10p-cmat10p,0

CMAT10PT PSNAME "Crunch-o-Matic 1.0 Picture"

CMAT10PD dc.w	$142,12-1
	dc.l	$43fa0288,$4eaefe68,$41fa025a,$208043fa
	dc.l	$02684eae,$fe6841fa,$02502080,$207a0252
	dc.l	$588843fa,$021c2298,$58885991,$43fa020e

_CMAT10P
	bsr.w	nhunk
	move.l	a0,a5
	lea	10(a0),a0
	bra.w	ucmat
;------------------------------------------------------------------------------
; 1.0 Text

CMAT10T	dc.w	def36-cmat10t,cmat10tt-cmat10t,CN_CrMatic10T,typenum
	dc.b	CRU_Object,0
	dc.w	$28a
	dc.l	0
	dc.w	cmat10td-cmat10t,_cmat10t-cmat10t,0

CMAT10TT PSNAME "Crunch-o-Matic 1.0 Text"

CMAT10TD dc.w	$142,12-1
	dc.l	$4bfa00b8,$2b7a00c4,$00042b7a,$00c20008
	dc.l	$04ad0000,$10000008,$43fa0078,$4eaefe68
	dc.l	$2c404eae,$ffc42a80,$2215242d,$0004262d

_CMAT10T
	bsr.w	nhunk
	move.l	a0,a5
	lea	10(a0),a0
	bra.b	ucmat
;------------------------------------------------------------------------------
; Find Next Hunk
;
; IN :	A0 = Start Of Data
;
; OUT:	A0 = Pointer To Next Hunk
;

NHUNK	bsr.w	nxthunk
	move.l	-4(a0),d0
	lsl.l	#2,d0
	lea	10(a0,d0.l),a0
	rts
;------------------------------------------------------------------------------
; Unpacking Routine
;
; IN :	A0 = Crunch Address
;	A5 = Length Address
;
; OUT:	D0 = Success (0=Error)
;

UCMAT	move.l	(a5),d0
	move.l	d0,UI_DecrunchLen(a4)
	add.l	#$1000,d0
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	ucmato

	move.l	d0,a1
	move.l	d0,a2
	add.l	4(a5),a2
	move.l	d0,a6
	add.l	UI_DecrunchLen(a4),a6

	pea	ucmat13(pc)
	moveq	#-$80,d3
UCMAT1	bsr.w	ucmat4
	bcc.b	ucmat8
	moveq	#0,d2
	bsr.w	ucmat4
	bcc.b	ucmat3
	moveq	#3,d0
	moveq	#8,d2
UCMAT2	subq.w	#2,d2
	move.b	ucmatt1(pc,d0.w),d4
	bsr.w	ucmat6
	cmp.w	ucmatt2(pc,d2.w),d1
	dbne	d0,ucmat2
	move.b	ucmatt3(pc,d0.w),d2
	add.w	d1,d2
UCMAT3	cmp.l	a6,a1
	beq.w	ucmate
	move.b	(a0)+,(a1)+
	dbra	d2,ucmat3
	cmp.l	a1,a2
	ble.b	ucmato

UCMAT8	moveq	#4,d0
UCMAT9	bsr.b	ucmat4
	bcc.b	ucmat10
	subq.w	#1,d0
	bne.b	ucmat9
UCMAT10	clr.w	d1
	move.b	ucmatt4(pc,d0.w),d4
	bmi.b	ucmat11
	bsr.b	ucmat6
UCMAT11	move.b	ucmatt5(pc,d0.w),d0
	add.w	d1,d0
	moveq	#2,d4
	bsr.b	ucmat6
	move.l	d1,d2
	move.b	ucmatt6(pc,d2.w),d4
	add.w	d2,d2
	bsr.b	ucmat6
	add.w	ucmatt7(pc,d2.w),d1
	move.l	a1,a3
	sub.l	d1,a3
UCMAT12	cmp.l	a6,a1
	beq.b	ucmate
	move.b	(a3)+,(a1)+
	dbra	d0,ucmat12
	cmp.l	a1,a2
	bgt.b	ucmat1
UCMATO	rts

UCMATT1	dc.b	9,2,1,0
UCMATT2	dc.w	$3ff,7,3,1
UCMATT3	dc.b	12,5,2,1
UCMATT4	dc.b	9,1,0,-1,-1
UCMATT5	dc.b	9,5,3,2,1
UCMATT6	dc.b	3,5,5,6,7,8,9,10
UCMATT7	dc.w	$1,$11,$51,$91,$111,$211,$411,$811

UCMAT4	add.b	d3,d3
	bne.b	ucmat5
	move.b	(a0)+,d3
	addx.b	d3,d3
UCMAT5	rts

UCMAT6	moveq	#0,d1
UCMAT7	bsr.b	ucmat4
	addx.w	d1,d1
	subq.b	#1,d4
	bpl.b	ucmat7
	rts

UCMATE	cmp.l	a1,a2
	beq.b	ucmato
	addq.l	#4,sp
UCMATE1	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	moveq	#0,d0
	rts

; Pass 2

UCMAT13	move.l	UI_DecrunchAdr(a4),a0
	move.l	a0,a2
	add.l	(a5),a2			;Decrunch End
	move.l	4(a5),d1
	move.w	8(a5),d0
	lea	$1000(a2),a1
	add.l	d1,a0
UCMAT14	move.b	-(a0),-(a1)
	subq.l	#1,d1
	bne.b	ucmat14

	moveq	#0,d1
UCMAT15	move.b	(a1)+,d1
	cmp.w	d0,d1
	bne.b	ucmat17
	moveq	#0,d2
	move.b	(a1)+,d2
	beq.b	ucmat17
	move.b	(a1)+,d1
UCMAT16	cmp.l	a6,a0
	beq.b	ucmate1
	move.b	d1,(a0)+
	dbra	d2,ucmat16
	cmp.l	a6,a0
	beq.b	ucmate1
	move.b	d1,(a0)+
UCMAT17	cmp.l	a6,a0
	beq.b	ucmate1
	move.b	d1,(a0)+
	cmp.l	a0,a2
	bgt.b	ucmat15
	moveq	#-1,d0
	rts
;------------------------------------------------------------------------------
