;******************************************************************************
;* Discovery File Imploder                                                    *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0

DFIMP10	dc.w	dms-dfimp10,dfimp10t-dfimp10,CN_DisImp10,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	$42
	dc.l	"IMP!"
	dc.w	0,_dfimp10-dfimp10,0

DFIMP10T PSNAME "Discovery File Imploder 1.0"

_DFIMP10
	move.l	4(a0),d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	udimpo

	move.l	LIB_SysBase(a6),a6
	move.l	d0,a1
	move.l	UI_CrunchLenTemp(a4),d0
	jsr	CopyMem(a6)		;Copy Crunched Data To Destination

	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	move.l	UI_DecrunchAdr(a4),a0
	bsr.b	undimp
UDIMPO	rts
;------------------------------------------------------------------------------
; Discovery File Imploder Unpacking Routine
;
; IN :	A0 = Pointer To Destination Buffer
;
; OUT:	D0 = Success (0=Error)
;

UNDIMP	move.l	a0,a3
	move.l	a0,a4
	addq.l	#4,a0
	add.l	(a0)+,a4
	add.l	(a0)+,a3
	move.l	a3,a2
	move.l	(a2)+,-(a0)
	move.l	(a2)+,-(a0)
	move.l	(a2)+,-(a0)
	move.l	(a2)+,d2
	move.w	(a2)+,d3
	bmi.b	unimp1
	subq.l	#1,a3

UNIMP1	lea	-$1c(sp),sp
	move.l	sp,a1
	moveq	#7-1,d0
UNIMP2	move.l	(a2)+,(a1)+
	dbra	d0,unimp2

	move.l	sp,a1
	moveq	#0,d4
UNIMP3	tst.l	d2
	beq.b	unimp5
UNIMP4	move.b	-(a3),-(a4)
	subq.l	#1,d2
	bne.b	unimp4

UNIMP5	cmp.l	a4,a0
	bcs.b	unimp8
	lea	$1c(sp),sp
	moveq	#-1,d0
	cmp.l	a3,a0
	beq.b	unimp7
UNIMP6	moveq	#0,d0
UNIMP7	rts


UNIMPM	MACRO
	add.b	d3,d3
	bne.b	.unimp\@
	move.b	-(a3),d3
	addx.b	d3,d3
.UNIMP\@
	bcc.b	\1
	ENDM

UNIMPM1	MACRO
	add.b	d3,d3
	bne.b	.unimp\@
	move.b	-(a3),d3
	addx.b	d3,d3
.UNIMP\@
	addx.b	d4,d4
	ENDM


UNIMP8	UNIMPM	unimp13
	UNIMPM	unimp12
	UNIMPM	unimp11
	UNIMPM	unimp10
	UNIMPM	unimp9
	move.b	-(a3),d4
	moveq	#3,d0
	bra.b	unimp14

UNIMP9	REPT	3
	UNIMPM1
	ENDR
	addq.b	#6,d4
	moveq	#3,d0
	bra.b	unimp14

UNIMP10	moveq	#5,d4
	moveq	#3,d0
	bra.b	unimp14

UNIMP11	moveq	#4,d4
	moveq	#2,d0
	bra.b	unimp14

UNIMP12	moveq	#3,d4
	moveq	#1,d0
	bra.b	unimp14

UNIMP13	moveq	#2,d4
	moveq	#0,d0
UNIMP14	moveq	#0,d5
	move.w	d0,d1
	UNIMPM	unimp16
	UNIMPM	unimp15
	move.b	unimp24(pc,d0.w),d5
	addq.b	#8,d0
	bra.b	unimp16

UNIMP15	moveq	#2,d5
	addq.b	#4,d0
UNIMP16	move.b	unimp25(pc,d0.w),d0
UNIMP17	add.b	d3,d3
	bne.b	unimp18
	move.b	-(a3),d3
	addx.b	d3,d3
UNIMP18	addx.w	d2,d2
	subq.b	#1,d0
	bne.b	unimp17
	add.w	d5,d2
	moveq	#0,d5
	move.l	d5,a2
	move.w	d1,d0
	UNIMPM	unimp20
	add.w	d1,d1
	UNIMPM	unimp19
	move.w	8(a1,d1.w),a2
	addq.b	#8,d0
	bra.b	unimp20

UNIMP19	move.w	(a1,d1.w),a2
	addq.b	#4,d0
UNIMP20	move.b	16(a1,d0.w),d0
UNIMP21	add.b	d3,d3
	bne.b	unimp22
	move.b	-(a3),d3
	addx.b	d3,d3
UNIMP22	addx.l	d5,d5
	subq.b	#1,d0
	bne.b	unimp21
	addq.w	#1,a2
	add.l	d5,a2
	add.l	a4,a2
UNIMP23	move.b	-(a2),-(a4)
	subq.b	#1,d4
	bne.b	unimp23
	bra.w	unimp3

UNIMP24	dc.b	6,10,10,18
UNIMP25	dc.b	1,1,1,1,2,3,3,4,4,5,7,14
;------------------------------------------------------------------------------
