;******************************************************************************
;* Double Action                                                              *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0

DOAC10	dc.w	drag10-doac10,doac10t-doac10,CN_DoubAction10,typenum
	dc.b	CRU_Address,0
	dc.w	$290
	dc.l	0
	dc.w	doac10d-doac10,_doac10-doac10,0

DOAC10T	PSNAME "Double Action 1.0"

DOAC10D	dc.w	$00,10-1
	dc.l	$47f900df,$f000377c,$4000009a,$377c0200
	dc.l	$009643f9,$00bfd100,$12bc00fd,$12bc0087
	dc.l	$12bc00fd,$08e90001

_DOAC10
	moveq	#0,d7
	cmp.l	#$343c0082,$196(a0)	;Mode 1
	beq.b	udouac1
	moveq	#2,d7
	cmp.l	#$343c0302,$1a8(a0)	;Mode 2
	beq.b	udouac1
	moveq	#4,d7
	cmp.l	#$343c0502,$1a8(a0)	;Mode 3
	beq.b	udouac1
	moveq	#6,d7
	cmp.l	#$343c1102,$1aa(a0)	;Mode 4
	beq.b	udouac1
UDOUACE	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
UDOUACO	moveq	#0,d0
	rts

PAROFF	dc.w	$0000,$0010,$0010,$001a

UDOUAC1	moveq	#0,d0
	move.w	paroff(pc,d7.w),d0
	lea	$24c(a0),a5
	add.l	d0,a5			;Start Address Of Parameters

	move.l	$12(a5),UI_JumpAdr(a4)
	move.l	$0a(a5),d0
	add.l	$1a(a5),d0
	move.l	d0,UI_Address(a4)

	move.l	$0e(a5),d0
	sub.l	$0a(a5),d0
	move.l	d0,UI_Temp(a4)
	move.l	d0,d1
	sub.l	$1a(a5),d1
	move.l	d1,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	udouaco

	move.l	d0,a1
	move.l	a1,a2
	move.l	(a5),d1
	sub.l	$0a(a5),d1
	add.l	d1,a2
	move.l	a2,a3
	move.l	$04(a5),d0
	sub.l	$0a(a5),d0
	lea	$22(a5),a0
	move.l	a0,-(sp)
	add.l	d0,a0

	move.w	doacjmp(pc,d7.w),d0
	jsr	doacjmp(pc,d0.w)

	cmp.l	(sp)+,a0
	bne.b	udouace
	tst.w	d3
	bne.b	udouace

	move.l	a3,a0
	add.l	UI_Temp(a4),a1
	move.l	a1,a2
	sub.l	UI_DecrunchLen(a4),a2

	move.b	8(a5),d5
	move.b	9(a5),d6
UDOUAC4	move.b	-(a0),d0
	cmp.b	d5,d0
	bne.b	udouac6
	move.b	-(a0),d2
	move.b	-(a0),d1
UDOUAC5	move.b	d1,-(a1)
	cmp.l	a2,a1
	beq.b	udouac8
	subq.b	#1,d2
	bne.b	udouac5
	bra.b	udouac4

UDOUAC6	cmp.b	d6,d0
	bne.b	udouac7
	moveq	#0,d1
	move.b	-(a0),d2
	bra.b	udouac5

UDOUAC7	move.b	d0,-(a1)
	cmp.l	a2,a1
	bne.b	udouac4
UDOUAC8	cmp.l	UI_DecrunchAdr(a4),a0
	bne.w	udouace
	move.l	a0,a1
	add.l	$1a(a5),a0
	move.l	a0,a2
	add.l	UI_Temp(a4),a2
UDOUAC9	move.b	(a0)+,(a1)+
	cmp.l	a0,a2
	bne.b	udouac9

	clr.l	UI_Temp(a4)
	moveq	#-1,d0
	rts

DOACJMP	dc.w	udoac10-doacjmp,udoac33-doacjmp
	dc.w	udoac33-doacjmp,udoac33-doacjmp
;------------------------------------------------------------------------------
; Pack Mode #1

UDOAC10	move.l	-(a0),d5
	moveq	#0,d2
UDOAC11	moveq	#3,d4
	bsr.b	udoac21
	cmp.b	#6,d6
	bcs.b	udoac18
	bne.b	udoac20
UDOAC12	moveq	#2,d4
	bsr.b	udoac21
	cmp.b	#2,d6
	bcs.b	udoac13
	bne.b	udoac14
	moveq	#3,d3
	bra.w	udoac28

UDOAC13	moveq	#1,d3
	tst.b	d6
	beq.w	udoac28
	bra.w	udoac29

UDOAC14	moveq	#1,d4
	bsr.b	udoac21
	tst.b	d6
	bne.b	udoac15
	moveq	#3,d4
	bsr.b	udoac21
	addq.w	#6,d6
	bra.b	udoac18

UDOAC15	moveq	#1,d4
	bsr.b	udoac21
	tst.b	d6
	beq.b	udoac16
	moveq	#16,d4
	bra.b	udoac17

UDOAC16	moveq	#10,d4
UDOAC17	bsr.b	udoac21
	subq.w	#1,d6
UDOAC18	move.w	d6,d3
UDOAC19	moveq	#8,d4
	bsr.b	udoac21
	move.b	d6,-(a2)
	cmp.l	a1,a2
	dbeq	d3,udoac19
	cmp.w	#-1,d3
	bne.w	udoac32
	moveq	#1,d4
	bsr.b	udoac21
	tst.b	d6
	beq.b	udoac12
UDOAC20	moveq	#2,d4
	bsr.b	udoac21
	cmp.b	#3,d6
	beq.b	udoac24
	moveq	#2,d3
	cmp.b	#1,d6
	bcs.b	udoac28
	beq.b	udoac29
	moveq	#3,d3
	bra.b	udoac29

UDOAC21	subq.w	#1,d4
	moveq	#0,d6
UDOAC22	lsl.l	#1,d5
	bne.b	udoac23
	move.l	-(a0),d5
	roxl.l	#1,d5
UDOAC23	roxl.w	#1,d6
	dbra	d4,udoac22
	rts

UDOAC24	moveq	#2,d4
	bsr.b	udoac21
	cmp.b	#3,d6
	beq.b	udoac25
	moveq	#4,d3
	bra.b	udoac27

UDOAC25	moveq	#2,d4
	bsr.b	udoac21
	cmp.b	#3,d6
	beq.b	udoac26
	moveq	#7,d3
	bra.b	udoac27

UDOAC26	moveq	#8,d4
	moveq	#10,d3
	bsr.b	udoac21
UDOAC27	add.w	d6,d3
	moveq	#1,d4
	bsr.b	udoac21
	tst.b	d6
	bne.b	udoac29
UDOAC28	moveq	#7,d4
	moveq	#2,d2
	bra.w	udoac30

UDOAC29	moveq	#8,d4
	move.w	#$82,d2
UDOAC30	bsr.b	udoac21
	add.l	d2,d6
UDOAC31	move.b	-1(a2,d6.l),-(a2)
	cmp.l	a1,a2
	dbeq	d3,udoac31
	cmp.w	#-1,d3
	beq.w	udoac11
UDOAC32	rts

; Pack Mode #2, #3 and #4

UDOAC33	move.l	-(a0),d5
	moveq	#0,d2
UDOAC34	moveq	#3,d4
	bsr.b	udoac21
	cmp.b	#6,d6
	bcs.b	udoac41
	bne.b	udoac43
UDOAC35	moveq	#2,d4
	bsr.b	udoac21
	cmp.b	#2,d6
	bcs.b	udoac36
	bne.b	udoac37
	moveq	#3,d3
	bra.w	udoac49

UDOAC36	moveq	#1,d3
	tst.b	d6
	beq.w	udoac50
	moveq	#9,d4
	bra.w	udoac53

UDOAC37	moveq	#1,d4
	bsr.w	udoac21
	tst.b	d6
	bne.b	udoac38
	moveq	#3,d4
	bsr.w	udoac21
	addq.w	#6,d6
	bra.b	udoac41

UDOAC38	moveq	#1,d4
	bsr.w	udoac21
	tst.b	d6
	beq.b	udoac39
	moveq	#16,d4
	bra.b	udoac40

UDOAC39	moveq	#10,d4
UDOAC40	bsr.w	udoac21
	subq.w	#1,d6
UDOAC41	move.w	d6,d3
UDOAC42	moveq	#8,d4
	bsr.w	udoac21
	move.b	d6,-(a2)
	cmp.l	a1,a2
	dbeq	d3,udoac42
	cmp.w	#-1,d3
	bne.w	udoac57
	moveq	#1,d4
	bsr.w	udoac21
	tst.b	d6
	beq.b	udoac35
UDOAC43	moveq	#2,d4
	bsr.w	udoac21
	cmp.b	#3,d6
	beq.b	udoac45
	moveq	#2,d3
	cmp.b	#1,d6
	bcs.b	udoac50
	beq.b	udoac44
	cmp.w	#6,d7
	bne.b	udoac54
	moveq	#14,d4
	move.w	#$902,d2
	bra.b	udoac55

UDOAC44	cmp.w	#6,d7
	bne.b	udoac52
	moveq	#11,d4
	bra.b	udoac53

UDOAC45	moveq	#2,d4
	bsr.w	udoac21
	cmp.b	#3,d6
	beq.b	udoac46
	moveq	#4,d3
	bra.b	udoac48

UDOAC46	moveq	#2,d4
	bsr.w	udoac21
	cmp.b	#3,d6
	beq.b	udoac47
	moveq	#7,d3
	bra.b	udoac48

UDOAC47	moveq	#8,d4
	moveq	#10,d3
	bsr.w	udoac21
UDOAC48	add.w	d6,d3
UDOAC49	moveq	#1,d4
	bsr.w	udoac21
	tst.b	d6
	bne.b	udoac51
UDOAC50	moveq	#8,d4
	moveq	#2,d2
	bra.b	udoac55

UDOAC51	moveq	#1,d4
	bsr.w	udoac21
	tst.b	d6
	bne.b	udoac54
UDOAC52	move.w	doacta1-2(pc,d7.w),d4
UDOAC53	move.w	#$102,d2
	bra.b	udoac55

UDOAC54	move.w	doacta2-2(pc,d7.w),d4
	move.w	doacta3-2(pc,d7.w),d2
UDOAC55	bsr.w	udoac21
	add.l	d2,d6
UDOAC56	move.b	-1(a2,d6.l),-(a2)
	cmp.l	a1,a2
	dbeq	d3,udoac56
	cmp.w	#-1,d3
	beq.w	udoac34
UDOAC57	rts

DOACTA1	dc.w	$0009,$000a,$000c
DOACTA2	dc.w	$000a,$000c,$0010
DOACTA3	dc.w	$0302,$0502,$1102
;------------------------------------------------------------------------------
