;******************************************************************************
;* DragPack                                                                   *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0

DRAG10	dc.w	drag252-drag10,drag10t-drag10,CN_DragPack10,typenum
	dc.b	CRU_Object,0
	dc.w	$334
	dc.l	0
	dc.w	drag10d-drag10,_drag10-drag10,0

DRAG10T	PSNAME "DragPack 1.0"

DRAG10D	dc.w	$40,12-1
	dc.l	$72034244,$6100007e,$3602d644,$7207e288
	dc.l	$66000006,$6100008a,$e39251c9,$fff21502
	dc.l	$51cbffea,$33c200df,$f1026000,$001a323c

_DRAG10
	moveq	#0,d5
	move.b	$57(a0),d5
	move.w	$e8(a0),d6
	move.w	$98(a0),d7
	lea	$314(a0),a0
	bra.w	bytchk
;------------------------------------------------------------------------------
; 2.52

DRAG252	dc.w	drag252d-drag252,drag252t-drag252,CN_DragPack252,typenum
	dc.b	CRU_Object,0
	dc.w	$198
	dc.l	0
	dc.w	drag252da-drag252,_drag252-drag252,0

DRAG252T PSNAME "DragPack 2.52"

DRAG252DA dc.w	$68,12-1
	dc.l	$130051cb,$fff8bbc9,$6c307202,$61c01232
	dc.l	$00003600,$61b8d643,$d0723008,$76003800
	dc.l	$720061aa,$d680b07c,$000167f4,$52831331

_DRAG252
	move.l	a0,a3
	lea	$34(a3),a2
	add.w	(a2),a2
	move.l	$40(a3),d2		;Decrunched Length
	move.l	$46(a3),d3		;Crunched Length
	move.w	$3c(a3),d4
	moveq	#0,d5
	move.b	$a3(a3),d5
	move.l	$52(a3),d0		;Decrunched & Relocated Length
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem			;Allocate Memory
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out
	move.l	d0,a1
	move.w	#UERR_Corrupt,UI_ErrorNum(a4)

	move.l	#$3f3,(a1)+
	move.l	a2,a0
	move.l	a1,a5
	sub.w	d4,a1
	add.l	d2,a1
	move.l	a1,d7
	move.l	d7,-(sp)
	moveq	#0,d6
	move.b	$79(a3),d6
	move.w	$80(a3),d7

	subq.l	#4,sp
	clr.l	(sp)
	move.b	$a9(a3),1(sp)
	move.w	$b0(a3),2(sp)
	move.l	sp,a6

	moveq	#0,d0
	move.b	$93(a3),d0
	lea	(a2,d5.w),a3
	move.w	d0,d5
	add.l	d3,a0
	bsr.w	udrpa2			;Unpack Data

	addq.l	#4,sp
	move.l	(sp)+,d7
	bsr.w	rdrpa1			;Reloc Data
.OUT	rts
;------------------------------------------------------------------------------
; 2.52 Data

DRAG252D dc.w	fspd10-drag252d,drag252dt-drag252d,CN_DragPack252D,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	$22
	dc.l	0
	dc.w	_drag252dt-drag252d,_drag252d-drag252d,0

DRAG252DT PSNAME "DragPack 2.52 Data"

_DRAG252DT
	moveq	#0,d0			;Unknown
	cmp.w	#"BH",(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_DRAG252D
	move.l	a0,a3
	move.l	2(a3),d0
	and.l	#$00ffffff,d0		;Decrunched Length
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out
	move.l	d0,a1
	move.l	a1,a5
	add.l	UI_DecrunchLen(a4),a1

	subq.l	#4,sp
	moveq	#0,d0
	move.b	10(a3),d0
	move.w	d0,(sp)
	moveq	#2,d1
	lsl.w	d0,d1
	subq.w	#1,d1
	move.w	d1,2(sp)
	moveq	#0,d6
	move.b	11(a3),d6
	moveq	#2,d7
	lsl.w	d6,d7
	subq.w	#1,d7
	moveq	#0,d5
	move.b	2(a3),d5
	moveq	#2,d0
	lsl.w	d5,d0
	lea	12(a3),a2

	lea	-32(sp),sp
	move.l	sp,a3
	move.l	a3,a6
	clr.w	(a6)+
	subq.w	#1,d0
	move.l	a2,a0
	moveq	#0,d1
.LOOP	move.b	(a0)+,d2
	addq.b	#1,d2
	moveq	#1,d3
	lsl.l	d2,d3
	move.w	d3,(a6)
	add.w	d1,(a6)+
	add.w	d3,d1
	subq.w	#1,d0
	bne.b	.loop

	move.l	UI_CrunchAdr(a4),a0
	add.l	6(a0),a0
	lea	32(sp),a6
	bsr.b	udrpa2			;Unpack Data
	lea	32+4(sp),sp
	moveq	#-1,d0
.OUT	rts
;------------------------------------------------------------------------------
; Unpack Routine For DragPack 2.52
;

UDRPA1	add.w	d2,d2
	bne.b	udrpa3
UDRPA2	move.w	-(a0),d2
	move.w	#$10,ccr
	addx.w	d2,d2
UDRPA3	bcs.b	udrpa6
	moveq	#0,d3
UDRPA4	move.w	d6,d1
	bsr.b	udrpa10
	add.l	d0,d3
	cmp.w	d7,d0
	beq.b	udrpa4
UDRPA5	moveq	#7,d1
	bsr.b	udrpa11
	move.b	d0,-(a1)
	cmp.l	a5,a1
	dbeq	d3,udrpa5
	cmp.w	#-1,d3
	bne.b	udrpa9
UDRPA6	move.w	d5,d1
	bsr.b	udrpa10
	move.b	(a2,d0.w),d1
	move.w	d0,d3
	bsr.b	udrpa10
	add.w	d3,d3
	add.w	(a3,d3.w),d0
	moveq	#0,d3
	move.w	d0,d4
UDRPA7	move.w	(a6),d1
	bsr.b	udrpa10
	add.l	d0,d3
	cmp.w	2(a6),d0
	beq.b	udrpa7
	addq.l	#1,d3
UDRPA8	move.b	(a1,d4.w),-(a1)
	cmp.l	a5,a1
	dbeq	d3,udrpa8
	cmp.w	#-1,d3
	beq.b	udrpa1
UDRPA9	rts

UDRPA10	moveq	#0,d0
UDRPA11	add.w	d2,d2
	bne.b	udrpa12
	move.w	-(a0),d2
	move.w	#$10,ccr
	addx.w	d2,d2
UDRPA12	addx.w	d0,d0
	subq.b	#1,d1
	bge.b	udrpa11
	rts
;------------------------------------------------------------------------------
; Reloc Routine
;

RDRPA1	move.l	UI_DecrunchAdr(a4),a0
	move.l	8(a0),d0
	lsl.l	#2,d0
	lea	$14(a0,d0.l),a0
RDRPA2	lea	rdrpa14(pc),a1
	move.w	(a0)+,d2
	cmp.b	(a1)+,d2
	beq.b	rdrpa6
	cmp.b	(a1)+,d2
	beq.b	rdrpa6a
	cmp.b	(a1)+,d2
	beq.b	rdrpa5
	cmp.b	(a1)+,d2
	beq.b	rdrpa7
	cmp.b	(a1)+,d2
	beq.b	rdrpa12
	cmp.b	(a1)+,d2
	beq.b	rdrpa3
	moveq	#0,d0
	rts

RDRPA3	move.l	#$3f2,d0
	cmp.l	d7,a0
	beq.b	rdrpa4
	bsr.b	rdrpa10
	move.l	d0,(a0)+
	bra.b	rdrpa2

RDRPA4	move.l	d0,-2(a0)
	moveq	#-1,d0
	rts

RDRPA5	bsr.b	rdrpa10
	move.l	#$3eb,(a0)+
	addq.l	#4,a0
	bra.b	rdrpa2

RDRPA6	move.l	#$3e9,d0
	bra.b	rdrpa6b

RDRPA6a	move.l	#$3ea,d0
RDRPA6b	bsr.b	rdrpa10
	move.l	d0,(a0)+
	move.l	(a0)+,d0
	lsl.l	#2,d0
	add.l	d0,a0
	bra.b	rdrpa2

RDRPA7	bsr.b	rdrpa10
	move.l	#$3ec,(a0)+
	moveq	#0,d2
RDRPA8	move.l	(a0)+,d0
	beq.b	rdrpa2
	moveq	#0,d1
	move.w	(a0),d2
	bsr.b	rdrpa10
	addq.l	#2,a0
	move.l	d2,(a0)+
RDRPA9	move.w	(a0),d2
	add.l	d2,d1
	bsr.b	rdrpa10
	addq.l	#2,a0
	move.l	d1,(a0)+
	subq.l	#1,d0
	bne.b	rdrpa9
	bra.b	rdrpa8

RDRPA10	move.l	d7,a2
RDRPA11	move.w	-(a2),2(a2)
	cmp.l	a2,a0
	bne.b	rdrpa11
	subq.l	#2,a0
	addq.l	#2,d7
	rts

RDRPA12	bsr.b	rdrpa10
	move.l	#$3f0,(a0)+
RDRPA13	move.l	(a0)+,d0
	beq.w	rdrpa2
	lsl.l	#2,d0
	lea	4(a0,d0.l),a0
	bra.b	rdrpa13

RDRPA14	dc.b	$e9,$ea,$eb,$ec,$f0,$f2
;------------------------------------------------------------------------------
