;******************************************************************************
;* FlashSpeed                                                                 *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0

FSPD10	dc.w	gnu12o1-fspd10,fspd10t-fspd10,CN_FlashSpeed10,typenum
	dc.b	CRU_Address,PSF_RecogFunc
	dc.w	$78
	dc.l	0
	dc.w	_fspd10t-fspd10,_fspd10-fspd10,0

FSPD10T	PSNAME "FlashSpeed 1.0"

_FSPD10T
	moveq	#0,d0			;Unknown
	cmp.l	#$4ed34144,$68(a0)
	beq.b	.ok
	cmp.l	#$4ed34144,$6c(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#"EPTR",$6c(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_FSPD10
	move.l	$2a(a0),d0
	move.l	d0,UI_Address(a4)
	move.l	d0,UI_JumpAdr(a4)

	move.l	a0,a2
	moveq	#-1,d7
	bsr.b	uflsp0			;Count Length
	addq.l	#8,d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out
	move.l	d0,a1
	moveq	#0,d7
	bsr.b	uflsp0			;Decrunch It
	moveq	#-1,d0
.OUT	rts
;------------------------------------------------------------------------------
; FlashSpeed 1.0 Unpacker Routine
;
; IN :	A1 = Pointer To Decrunched Data
;	A2 = Pointer To Crunched Data
;	D7 = Count Or Depack (0=Depack)
;
; OUT:	D0 = Length Of Decrunched Data
;

UFLSP0	lea	$70(a2),a0
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#1,d3
UFLSP1	addq.l	#1,d2
	tst.w	d7
	bne.b	uflsp2
	move.b	(a0),(a1)+
UFLSP2	cmp.b	(a0)+,d3
	bne.b	uflsp1
	cmp.b	(a0),d3
	bne.b	uflsp1
	cmp.b	1(a0),d3
	beq.b	uflsp3
	subq.l	#1,d2
	subq.l	#1,a1
	addq.l	#1,a0
	bra.b	uflsp4

UFLSP3	addq.l	#2,a0
UFLSP4	move.b	(a0)+,d1
	beq.b	uflsp7
	move.b	(a0)+,d0
	subq.w	#1,d1
UFLSP5	addq.l	#1,d2
	tst.w	d7
	bne.b	uflsp6
	move.b	d0,(a1)+
UFLSP6	dbra	d1,uflsp5
	moveq	#0,d1
	bra.b	uflsp1

UFLSP7	move.l	d2,d0
	rts
;------------------------------------------------------------------------------
