;******************************************************************************
;* GnuPacker                                                                  *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0 Object

GNU10O	dc.w	gnu10d-gnu10o,gnu10ot-gnu10o,CN_GnuPack10,typenum
	dc.b	CRU_Address,0
	dc.w	$172
	dc.l	0
	dc.w	gnu10od-gnu10o,_gnu10o-gnu10o,0

GNU10OT	PSNAME	"GnuPacker 1.0 Object"

GNU10OD	dc.w	$54,12-1
	dc.l	$266d0012,$244b95c1,$611e653e,$74007001
	dc.l	$6124d441,$b24667f6,$7007611a,$170151ca
	dc.l	$fff8b5cb,$65244e75,$e8ad6702,$4e752a20

_GNU10O
	move.l	$5a(a0),UI_JumpAdr(a4)
	move.l	$146(a0),UI_Address(a4)
	lea	$13e(a0),a0
	add.l	#$170,6(a0)
	bra.w	gnuunp0
;------------------------------------------------------------------------------
; 1.0 Data

GNU10D	dc.w	gnu12o1-gnu10d,gnu10dt-gnu10d,CN_GnuPack10D,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	22
	dc.l	"GP10"
	dc.w	0,_gnu10d-gnu10d,0

GNU10DT	PSNAME	"GnuPacker 1.0 Data"

_GNU10D
	lea	4(a0),a0
	bra.w	gnuunp0
;------------------------------------------------------------------------------
; 1.1-1.2 Object1

GNU12O1	dc.w	gnu12o2-gnu12o1,gnu12o1t-gnu12o1,CN_GnuPack12,typenum
	dc.b	CRU_Address,0
	dc.w	$26e
	dc.l	0
	dc.w	gnu12o1d-gnu12o1,_gnu12o1-gnu12o1,0

GNU12O1T PSNAME	"GnuPacker 1.1-1.2 One Segment"

GNU12O1D dc.w	$54,12-1
	dc.l	$2a20e8b5,$9284e2ad,$e089266d,$0010244b
	dc.l	$95c1e8ad,$66042a20,$e8b56500,$00ea7400
	dc.l	$70017200,$e8ad6604,$2a20e8b5,$e9b151c8

_GNU12O1
	move.l	$58(a0),UI_JumpAdr(a4)
	move.l	$264(a0),UI_Address(a4)
	lea	$25c(a0),a0
	add.l	#$270,4(a0)
	bra.w	gnuunp
;------------------------------------------------------------------------------
; 1.1-1.2 Object2

GNU12O2	dc.w	gnu12d-gnu12o2,gnu12o2t-gnu12o2,CN_GnuPack12Two,typenum
	dc.b	CRU_Address,0
	dc.w	$274
	dc.l	0
	dc.w	gnu12o2d-gnu12o2,_gnu12o2-gnu12o2,0

GNU12O2T PSNAME	"GnuPacker 1.1-1.2 Two Segment"

GNU12O2D dc.w	$50,12-1
	dc.l	$670ce8ad,$66042a20,$e8b59284,$e2ade089
	dc.l	$266d0010,$244b95c1,$e8ad6604,$2a20e8b5
	dc.l	$650000ea,$74007001,$7200e8ad,$66042a20

_GNU12O2
	move.l	$5e(a0),UI_JumpAdr(a4)
	move.l	$268(a0),UI_Address(a4)
	lea	$260(a0),a0
	add.l	#$294,4(a0)
	bra.b	gnuunp
;------------------------------------------------------------------------------
; 1.1-1.2 Data

GNU12D	dc.w	hpc-gnu12d,gnu12dt-gnu12d,CN_GnuPack12D,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	22
	dc.l	"GP11"
	dc.w	0,_gnu12d-gnu12d,0

GNU12DT	PSNAME	"GnuPacker 1.1-1.2 Data"

_GNU12D
	lea	4(a0),a0
	bra.b	gnuunp
;------------------------------------------------------------------------------
; 1.0 Unpacker Routine
;

GNUUNP0	lea	-18(sp),sp
	move.l	sp,a1
	move.l	(a0)+,(a1)
	move.w	(a0)+,16(a1)
	move.l	(a0)+,4(a1)
	move.l	(a0)+,8(a1)
	move.l	(a0)+,12(a1)

	move.l	sp,a5
	move.l	a0,a6
	bsr.b	gpdecru			;Unpack Data
	lea	18(sp),sp
	rts
;------------------------------------------------------------------------------
; 1.1-1.2 Unpacker Routine
;

GNUUNP	lea	-18(sp),sp
	move.l	sp,a1
	moveq	#18/2-1,d7
GNUUNP1	move.w	(a0)+,(a1)+		;Copy Data Buffer
	dbra	d7,gnuunp1

	move.l	sp,a5
	move.l	a0,a6
	bsr.b	gpdecru			;Unpack Data
	lea	18(sp),sp
	rts
;------------------------------------------------------------------------------
; Gnu Packer 1.1-1.2 Data Decruncher
;
; IN :	A5 = Pointer To Info
;	A6 = Pointer To Crunched Data
;
; OUT:	Nothing
;
; Crunch Header:
;
;  0	Mark (GP11)
;  4	Efficient
;  8	Length Of Final Crunched Data
; 12	Start Address Of Decrunched Data
; 16	End Address Of Decrunched Data
; 20	Cruncher Byte #1
; 21	Cruncher Byte #2
; 22	Crunched data
;

GPDECRU	subq.l	#4,a5

	move.l	16(a5),d0
	sub.l	12(a5),d0
	move.l	d0,UI_DecrunchLen(a4)
	addq.l	#1,d0
	bsr.w	alcdmem			;Allocate Decrunch Buffer
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	gpdecro

	move.l	d0,12(a5)
	add.l	UI_DecrunchLen(a4),d0
	move.l	d0,16(a5)

	move.l	a5,-(sp)
	move.l	UI_CrunchAdrTemp(a4),a0
	add.l	8(a5),a0		;End Of Crunched Data
	move.l	16(a5),a3		;End Of Decrunched Data
	addq.l	#4,a5
	moveq	#-1,d3

	moveq	#7,d7
	moveq	#3,d6
	moveq	#1,d5
	moveq	#1,d4
	move.l	-(a0),d1
	tst.b	d1
	beq.b	gpdecr1
	bsr.w	ppdat1l
	subq.l	#1,d1
	lsr.l	d1,d5
GPDECR1	lsr.l	#8,d1
	move.l	a3,a2
	sub.l	d1,a2
	bsr.w	ppdat1b			;Pass #1 (PowerPacker)
	move.l	(sp)+,a5

;	moveq	#0,d0
;	sub.l	a6,a0
;	cmp.l	d0,a0
;	bne	gpdecre
;	tst.w	d2
;	bne	gpdecre

	bsr.b	p2dcr			;Pass #2
GPDECRO	rts

GPDECRE	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
; Pass 2 Decruncher
;
; IN :	A3 = Start Address Of Crunched Data To Pass #2
;
; OUT:	D0 = Success (0=Error)
;

P2DCR	move.l	12(a5),a0		;Start Address Of Decrunched Data
	move.l	16(a5),a1		;End Of Decrunched Data
	addq.l	#1,a1
	move.b	20(a5),d0		;Cruncher Byte #1
	move.b	21(a5),d1		;Cruncher Byte #2
	cmp.b	d0,d1
	beq.b	p2dcr6
	moveq	#0,d3
P2DCR1	cmp.l	16(a5),a3		;End Address Of Decrunched Data
	beq.b	p2dcr6
	cmp.l	a1,a0
	beq.b	p2dcr7
	move.b	(a3)+,d2
	cmp.b	d0,d2
	beq.b	p2dcr3
	cmp.b	d1,d2
	beq.b	p2dcr4
P2DCR2	move.b	d2,(a0)+		;Store Byte
	bra.b	p2dcr1

P2DCR3	move.b	(a3)+,d3		;Number Of Bytes
	beq.b	p2dcr2
	move.b	(a3)+,d2		;The Byte
	bra.b	p2dcr5

P2DCR4	move.b	(a3)+,d3
	beq.b	p2dcr2
	moveq	#0,d2
P2DCR5	move.b	d2,(a0)+		;Store Bytes
	cmp.l	a1,a0
	dbeq	d3,p2dcr5
	cmp.w	#-1,d3
	bne.b	p2dcr7
	moveq	#0,d3
	bra.b	p2dcr1

P2DCR6	moveq	#-1,d0
	rts

P2DCR7	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
