;******************************************************************************
;* ISC                                                                        *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.5 Pass 1

ISC15P1	dc.w	isc15p2-isc15p1,isc15p1t-isc15p1,CN_ISC15P1,typenum
	dc.b	CRU_Address,PSF_RecogFunc
	dc.w	$114
	dc.l	0
	dc.w	_isc15p1t-isc15p1,_isc15p1-isc15p1,0

ISC15P1T PSNAME	"ISC Pass 1"

_ISC15P1T
	move.w	#$92,d1
TISC1	moveq	#12-1,d2
	lea	isc1tab(pc),a1
	bsr.w	chktab
ISCOUT	rts


_ISC15P1
	moveq	#32,d7
UISC1	add.l	d7,a0
	move.l	2(a0),UI_Address(a4)
	move.l	$68(a0),UI_JumpAdr(a4)

	lea	$e4(a0),a1
	move.l	a1,a5
	moveq	#0,d7
	moveq	#0,d5
	bsr.w	isc1p			;Count Length

	move.l	d7,UI_DecrunchLen(a4)
	move.l	d7,d0
	bsr.w	alcdmem			;Allocate Memory
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	iscout

	move.l	d0,a2
	move.l	a5,a1
	moveq	#-1,d5
	bsr.w	isc1p			;Decrunch
	bra.w	tisc
;------------------------------------------------------------------------------
; 1.5 Pass 2

ISC15P2	dc.w	isc15p3-isc15p2,isc15p2t-isc15p2,CN_ISC15P2,typenum
	dc.b	CRU_Address,PSF_RecogFunc
	dc.w	$1a8
	dc.l	0
	dc.w	_isc15p2t-isc15p2,_isc15p2-isc15p2,0

ISC15P2T PSNAME	"ISC Pass 2"

_ISC15P2T
	move.w	#$92,d1
TISC2	moveq	#12-1,d2
	lea	isc2tab(pc),a1
	bra.w	chktab


_ISC15P2
	moveq	#32,d7
UISC2	add.l	d7,a0
	move.l	2(a0),UI_Address(a4)
	move.l	$fa(a0),UI_JumpAdr(a4)

	lea	$178(a0),a1
	move.l	a1,a5
	moveq	#0,d4
	moveq	#0,d3
	bsr.w	isc2p			;Count Length

	move.l	d3,UI_DecrunchLen(a4)
	move.l	d3,d0
	bsr.w	alcdmem			;Allocate Memory
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	iscout

	move.l	d0,a2
	move.l	a5,a1
	moveq	#-1,d4
	bsr.w	isc2p			;Decrunch
	bra.w	tisc
;------------------------------------------------------------------------------
; 1.5 Pass 3

ISC15P3	dc.w	lha-isc15p3,isc15p3t-isc15p3,CN_ISC15P3,typenum
	dc.b	CRU_Address,PSF_RecogFunc
	dc.w	$114
	dc.l	0
	dc.w	_isc15p3t-isc15p3,_isc15p3-isc15p3,0

ISC15P3T PSNAME	"ISC Pass 3"

_ISC15P3T
	move.w	#$92,d1
TISC3	moveq	#12-1,d2
	lea	isc3tab(pc),a1
	bra.w	chktab


_ISC15P3
	moveq	#32,d7
UISC3	add.l	d7,a0
	move.l	8(a0),UI_Address(a4)
	move.l	$e0(a0),UI_JumpAdr(a4)

	lea	$1e4(a0),a1
	moveq	#0,d6
	moveq	#0,d7
	bsr.w	isc3p			;Count Length

	move.l	d7,UI_DecrunchLen(a4)
	move.l	d7,d0
	bsr.w	alcdmem			;Allocate Memory
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	iscout

	move.l	d0,a2
	lea	$1e4(a0),a1
	moveq	#-1,d6
	bsr.w	isc3p			;Decrunch

	moveq	#-1,d0
	move.l	UI_DecrunchAdr(a4),a0
	cmp.l	#$03f3,(a0)
	bne.b	tisc
	move.l	UI_DecrunchLen(a4),d1
	lsr.l	#2,d1
	lsl.l	#2,d1
	move.l	d1,UI_DecrunchLen(a4)

; Test For Extra ISC Passes

TISC	move.l	UI_DecrunchAdr(a4),a0
	moveq	#32,d7
	pea	uisc1(pc)
	bsr.w	_isc15p1t
	tst.w	d0
	bne.b	.tisc1
	lea	uisc2(pc),a1
	move.l	a1,(sp)
	bsr.w	_isc15p2t
	tst.w	d0
	bne.b	.tisc1
	lea	uisc3(pc),a1
	move.l	a1,(sp)
	bsr.w	_isc15p3t
	tst.w	d0
	bne.b	.tisc1

; Test Without Hunks

	moveq	#8,d7
	move.w	#$7a,d1
	lea	uisc1(pc),a1
	move.l	a1,(sp)
	bsr.w	tisc1
	tst.w	d0
	bne.b	.tisc1
	lea	uisc2(pc),a1
	move.l	a1,(sp)
	bsr.w	tisc2
	tst.w	d0
	bne.b	.tisc1
	lea	uisc3(pc),a1
	move.l	a1,(sp)
	bsr.w	tisc3
	tst.w	d0
	bne.b	.tisc1
	addq.l	#4,sp
	moveq	#-1,d0
	bra.b	.out

; Unpacking Again

.TISC1	move.l	UI_CrunchAdr(a4),a1
	bsr.w	fremem
	move.l	UI_DecrunchAdr(a4),UI_CrunchAdr(a4)
	move.l	UI_DecrunchLen(a4),UI_CrunchLen(a4)
	clr.l	UI_DecrunchAdr(a4)
	clr.l	UI_DecrunchLen(a4)
.OUT	rts
;------------------------------------------------------------------------------
ISC1TAB	dc.l	$12000200,$001f0201,$00e0e809,$47fa0008
	dc.l	$d7c14e93,$60d46020,$604c6036,$603a600e
	dc.l	$60086046,$123c0000,$6006e148,$10191219

ISC2TAB	dc.l	$66200880,$00026700,$00743200,$6100009a
	dc.l	$14c051c9,$fff860dc,$e1486100,$008c5840
	dc.l	$60e813c0,$00dff181,$12006100,$0096e309

ISC3TAB	dc.l	$4cdf000f,$2e4048e7,$70004280,$4e753323
	dc.l	$b7c866fa,$183c0080,$47fa0058,$49fa0154
	dc.l	$2a4cdbc0,$d3c0d3c0,$4280323c,$00ff5201
;------------------------------------------------------------------------------
; ISC Pass 1 Decruncher
;
; IN :	A1 = Pointer To Crunched Data
;	A2 = Pointer To Destination
;	D5 = Count Mode (0=On)
;	D7 = If Count Mode: 0, Else Anything
;
; OUT:	D7 = Length Of Decrunched Data
;

ISC1P	moveq	#0,d0
	moveq	#0,d1
	move.b	(a1)+,d0
	bne.b	isc1p1
	rts				;Get Out

ISC1P1	move.b	d0,d1
	and.b	#$1f,d0
	and.b	#$e0,d1
	lsr.b	#4,d1
	lea	isc1p2(pc),a3
	add.l	d1,a3
	jsr	(a3)
	bra.b	isc1p

ISC1P2	bra.b	isc1p6
	bra.b	isc1p14
	bra.b	isc1p10
	bra.b	isc1p11
	bra.b	isc1p4
	bra.b	isc1p3
	bra.b	isc1p15
	clr.b	d1
	bra.b	isc1p5

ISC1P3	lsl.w	#8,d0
	move.b	(a1)+,d0
ISC1P4	move.b	(a1)+,d1
ISC1P5	addq.l	#1,d7
	tst.w	d5
	beq.b	isc1p5a
	move.b	d1,(a2)+
ISC1P5a	dbra	d0,isc1p5
	rts

ISC1P6	move.b	(a1)+,d1
ISC1P7	moveq	#0,d6
ISC1P8	addq.l	#1,d7
	tst.w	d5
	beq.b	isc1p8a
	move.b	(a1,d6.w),(a2)+
ISC1P8a	addq.b	#1,d6
	cmp.b	d6,d0
	bne.b	isc1p8
	dbra	d1,isc1p7
ISC1P9	move.b	(a1)+,d0
	subq.b	#1,d6
	bne.b	isc1p9
	rts

ISC1P10	move.b	#1,d2
	bra.b	isc1p12

ISC1P11	move.b	(a1)+,d2
ISC1P12	move.b	(a1)+,d3
ISC1P13	addq.l	#1,d7
	tst.w	d5
	beq.b	isc113a
	move.b	d3,(a2)+
ISC113a	add.b	d2,d3
	dbra	d0,isc1p13
	rts

ISC1P14	lsl.w	#8,d0
	move.b	(a1)+,d0
ISC1P15	move.b	(a1)+,d1
	addq.l	#1,d7
	tst.w	d5
	beq.b	isc115a
	move.b	d1,(a2)+
ISC115a	dbra	d0,isc1p15
	rts
;------------------------------------------------------------------------------
; ISC Pass 2 Decruncher
;
; IN :	A1 = Pointer To Crunched Data
;	A2 = Pointer To Destination
;	D4 = Count Mode (0=On)
;	D3 = If Count Mode: 0, Else Anything
;
; OUT:	D3 = Length Of Decrunched Data
;

ISC2P	lea	isc2p7(pc),a3
	moveq	#0,d6
	moveq	#0,d7
ISC2P1	moveq	#0,d0
	moveq	#0,d1
	bsr.w	isc2p26
	bclr	#3,d0
	bne.b	isc2p6
	bclr	#2,d0
	beq.b	isc2p17
ISC2P2	move.w	d0,d1
ISC2P3	bsr.w	isc2p24
	addq.l	#1,d3
	tst.w	d4
	beq.b	isc2p3a
	move.b	d0,(a2)+
ISC2P3a	dbra	d1,isc2p3
	bra.b	isc2p1

ISC2P4	lsl.w	#8,d0
	bsr.b	isc2p24
ISC2P5	addq.w	#4,d0
	bra.b	isc2p2

ISC2P6	move.b	d0,d1
	bsr.w	isc2p26
	lsl.b	#1,d1
	jmp	(a3,d1.w)

ISC2P7	bra.b	isc2p5
	bra.b	isc2p4
	bra.b	isc2p23
	bra.b	isc2p10
	bra.b	isc2p20
	bra.b	isc2p21
	bra.b	isc2p22

	bclr	#3,d0
	beq.b	isc2p8
	moveq	#1,d1
	bra.b	isc2p9

ISC2P8	moveq	#2,d1
ISC2P9	bsr.b	isc2p16
	bra.b	isc2p19

ISC2P10	bclr	#3,d0
	beq.b	isc2p13
	bclr	#2,d0
	beq.b	isc2p11
	moveq	#3,d1
	bra.b	isc2p12

ISC2P11	moveq	#2,d1
ISC2P12	bsr.b	isc2p14
	bra.b	isc2p19

ISC2P13	bclr	#2,d0
	bne.b	isc2p18
	bsr.b	isc2p16
	bra.b	isc2p29

ISC2P14	lsl.w	#8,d0
ISC2P15	bsr.b	isc2p24
ISC2P16	lsl.l	#8,d0
	bra.b	isc2p24

ISC2P17	bsr.b	isc2p16
	moveq	#0,d1
	tst.w	d0
	bne.b	isc2p33
	rts				;Get Out

ISC2P18	bsr.b	isc2p16
	add.w	#$800,d0
	moveq	#1,d1
ISC2P19	bra.b	isc2p33

ISC2P20	move.b	d0,d1
	bsr.b	isc2p15
	bra.b	isc2p32

ISC2P21	bsr.b	isc2p16
	bra.b	isc2p30

ISC2P22	move.b	d0,d1
	bsr.b	isc2p24
	bra.b	isc2p32

ISC2P23	bra.b	isc2p28

ISC2P24	tst.b	d7
	bne.b	isc2p25
	move.b	(a1)+,d0
	rts

ISC2P25	move.b	d6,d0
	lsl.b	#4,d0
	move.b	(a1)+,d6
	move.b	d6,d5
	lsr.b	#4,d5
	or.b	d5,d0
	and.b	#15,d6
	rts

ISC2P26	tst.b	d7
	bne.b	isc2p27
	moveq	#1,d7
	move.b	(a1)+,d6
	move.b	d6,d0
	and.b	#15,d6
	lsr.b	#4,d0
	rts

ISC2P27	moveq	#0,d7
	move.b	d6,d0
	rts

ISC2P28	bsr.b	isc2p14
	bclr	#$13,d0
	beq.b	isc2p30
ISC2P29	move.l	d0,d2
	bsr.b	isc2p15
	bra.b	isc2p31

ISC2P30	move.l	d0,d2
	moveq	#0,d0
	bsr.b	isc2p24
ISC2P31	move.w	d0,d1
	move.l	d2,d0
ISC2P32	addq.l	#1,d1
ISC2P33	move.l	a2,a0
	sub.l	d0,a0
	addq.w	#1,d1
ISC2P34	move.b	(a0)+,d0
	addq.l	#1,d3
	tst.w	d4
	beq.b	isc234a
	move.b	d0,(a2)+
ISC234a	dbra	d1,isc2p34
	bra.w	isc2p1
;------------------------------------------------------------------------------
; ISC Pass 3 Decruncher
;
; IN :	A1 = Pointer To Crunched Data
;	A2 = Pointer To Destination
;	D5 = Count Mode (0=On)
;	D7 = If Count Mode: 0, Else Anything
;
; OUT:	D7 = Length Of Decrunched Data
;

ISC3P	move.l	a4,-(sp)
	move.l	UI_CrunchAdrTemp(a4),a6
	move.l	UI_CrunchLenTemp(a4),d0
	subq.l	#4+1,d0
	add.l	d0,a6

	moveq	#0,d0
	move.b	$6b(a0),d0
	move.b	#$80,d4

	lea	$e4(a0),a3
	lea	$100(a3),a4
	move.l	a4,a5
	add.l	d0,a5
	add.l	d0,a1
	add.l	d0,a1

ISC3P1	moveq	#0,d0
	move.w	#$00ff,d1
ISC3P2	addq.b	#1,d1
	lsl.b	#1,d4
	bne.b	isc3p4
	move.b	(a1)+,d4
	bne.b	isc3p3
	cmp.l	a6,a1
	bcc.b	isc3p5
ISC3P3	roxl.b	#1,d4
ISC3P4	roxl.b	#1,d0
	cmp.b	(a4,d1.w),d0
	bcs.b	isc3p2
	add.b	(a5,d1.w),d0
	addq.l	#1,d7
	tst.w	d6
	beq.b	isc3p1
	move.b	(a3,d0.w),(a2)+
	bra.b	isc3p1

ISC3P5	move.l	(sp)+,a4
	rts				;Get Out
;------------------------------------------------------------------------------
