;******************************************************************************
;* Imploder                                                                   *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; Imploder 1.0-3.1

IMP31	dc.w	imp31p-imp31,imp31t-imp31,CN_Imploder31,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$2bc
	dc.l	0
	dc.w	_imp31t-imp31,_imp31-imp31,0

IMP31T	PSNAME "Imploder 1.0-3.1"

_IMP31T
	bsr.w	nxthunk
	beq.b	.out
	moveq	#0,d0			;Unknown
	cmp.l	#$49fa0036,4(a0)
	bne.b	.out
	cmp.l	#$4e913c3c,14(a0)
	bne.b	.out
	cmp.l	#$51892011,22(a0)
	bne.b	.out
	cmp.w	#$612e,12(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_IMP31	moveq	#0,d6
	bra.w	uimp
;------------------------------------------------------------------------------
; Imploder 1.0-3.1 Protected

IMP31P	dc.w	imp31o-imp31p,imp31pt-imp31p,CN_Imploder31P,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$2c4
	dc.l	0
	dc.w	_imp31pt-imp31p,_imp31-imp31p,0

IMP31PT	PSNAME "Imploder 1.0-3.1 Protected"

_IMP31PT
	bsr.w	nxthunk
	beq.b	.out
	moveq	#0,d0			;Unknown
	cmp.l	#$49fa0036,4(a0)
	bne.b	.out
	cmp.l	#$4e913c3c,14(a0)
	bne.b	.out
	cmp.l	#$51892011,22(a0)
	bne.b	.out
	cmp.w	#$4e94,12(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; Imploder 1.0-3.1 Overlayed

IMP31O	dc.w	imp31op-imp31o,imp31ot-imp31o,CN_Imploder31O,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$304
	dc.l	0
	dc.w	_imp31ot-imp31o,_imp31o-imp31o,0

IMP31OT	PSNAME "Imploder 1.0-3.1 Overlayed"

_IMP31OT
	move.l	16(a0),d2
	sub.l	12(a0),d2
	subq.l	#4,d2

	bsr.w	nxthunk
	beq.b	.out
	moveq	#0,d0			;Unknown
	cmp.l	#$60000016,(a0)
	bne.b	.out
	cmp.w	#$abcd,6(a0)
	bne.b	.out
	cmp.l	#$49fa005e,28(a0)
	bne.b	.out
	cmp.l	#$4e913c3c,38(a0)
	bne.b	.out
	cmp.w	#$6156,36(a0)
	bne.b	.out

	move.l	-4(a0),d1
	lsl.l	#2,d1
	lea	4(a0,d1.l),a0
.TST	lea	12(a0),a0
	dbra	d2,.tst

	cmp.w	#$4e75,54(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_IMP31O
	moveq	#0,d6
	bra.w	uimpov
;------------------------------------------------------------------------------
; Imploder 1.0-3.1 Overlayed Protected

IMP31OP	dc.w	imp31l-imp31op,imp31opt-imp31op,CN_Imploder31OP,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$304
	dc.l	0
	dc.w	_imp31opt-imp31op,_imp31o-imp31op,0

IMP31OPT PSNAME "Imploder 1.0-3.1 Overlayed Protected"

_IMP31OPT
	bsr.w	nxthunk
	beq.b	.out
	moveq	#0,d0			;Unknown
	cmp.l	#$60000016,(a0)
	bne.b	.out
	cmp.w	#$abcd,6(a0)
	bne.b	.out
	cmp.l	#$49fa005e,28(a0)
	bne.b	.out
	cmp.l	#$4e913c3c,38(a0)
	bne.b	.out
	cmp.w	#$4e94,36(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; Imploder 1.0-3.1 Library

IMP31L	dc.w	imp31lp-imp31l,imp31lt-imp31l,CN_Imploder31L,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$98
	dc.l	0
	dc.w	_imp31lt-imp31l,uimlib-imp31l,0

IMP31LT	PSNAME "Imploder 1.0-3.1 Library"

_IMP31LT
	bsr.w	nxthunk
	beq.b	.out
	moveq	#0,d0			;Unknown
	cmp.l	#$43fa001c,6(a0)
	bne.b	.out
	cmp.l	#$4eaefdd8,14(a0)
	bne.b	.out
	cmp.l	#$4eaeffe2,24(a0)
	bne.b	.out
	cmp.l	#$48e7ffff,(a0)
	bne.b	.out
	btst	#7,32(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; Imploder 1.0-3.1 Library Protected

IMP31LP	dc.w	imp40-imp31lp,imp31lpt-imp31lp,CN_Imploder31LP,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$98
	dc.l	0
	dc.w	_imp31lpt-imp31lp,uimlib-imp31lp,0

IMP31LPT PSNAME "Imploder 1.0-3.1 Library Protected"

_IMP31LPT
	bsr.w	nxthunk
	beq.b	.out
	moveq	#0,d0			;Unknown
	cmp.l	#$43fa001c,6(a0)
	bne.b	.out
	cmp.l	#$4eaefdd8,14(a0)
	bne.b	.out
	cmp.l	#$4eaeffe2,24(a0)
	bne.b	.out
	cmp.l	#$48e7ffff,(a0)
	bne.b	.out
	btst	#7,32(a0)
	beq.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; Imploder 4.0

IMP40	dc.w	imp40o-imp40,imp40t-imp40,CN_Imploder40,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$31c
	dc.l	0
	dc.w	_imp40t-imp40,_imp40-imp40,0

IMP40T	PSNAME "Imploder 4.0"

_IMP40T
	bsr.w	nxthunk
	beq.b	.out
	moveq	#0,d0			;Unknown
	cmp.l	#$49fa005e,4(a0)
	bne.b	.out
	cmp.w	#$4e91,14(a0)
	bne.b	.out
	cmp.l	#$51892011,30(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_IMP40	moveq	#16,d6
	bra.w	uimp
;------------------------------------------------------------------------------
; Imploder 4.0 Overlayed

IMP40O	dc.w	imp40l-imp40o,imp40ot-imp40o,CN_Imploder40O,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$314
	dc.l	0
	dc.w	_imp40ot-imp40o,_imp40o-imp40o,0

IMP40OT	PSNAME "Imploder 4.0 Overlayed"

_IMP40OT
	move.l	16(a0),d2
	sub.l	12(a0),d2
	subq.l	#4,d2

	bsr.w	nxthunk
	beq.b	.out
	moveq	#0,d0			;Unknown
	cmp.l	#$60000016,(a0)
	bne.b	.out
	cmp.w	#$abcd,6(a0)
	bne.b	.out
	cmp.l	#$49fa005e,28(a0)
	bne.b	.out
	cmp.l	#$4e913c3c,38(a0)
	bne.b	.out
	cmp.w	#$6156,36(a0)
	bne.b	.out

	move.l	-4(a0),d1
	lsl.l	#2,d1
	lea	4(a0,d1.l),a0
.TST	lea	12(a0),a0
	dbra	d2,.tst

	cmp.w	#$2c78,54(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_IMP40O
	moveq	#16,d6
	bra.w	uimpov
;------------------------------------------------------------------------------
; Imploder 4.0 Library

IMP40L	dc.w	isc15p1-imp40l,imp40lt-imp40l,CN_Imploder40L,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$158
	dc.l	0
	dc.w	_imp40lt-imp40l,uimlib-imp40l,0

IMP40LT	PSNAME "Imploder 4.0 Library"

_IMP40LT
	bsr.w	nxthunk
	beq.b	.out
	moveq	#0,d0			;Unknown
	cmp.l	#$43fa001f,10(a0)
	bne.b	.out
	cmp.l	#$4eaefdd8,14(a0)
	bne.b	.out
	cmp.l	#$4eaeffe2,24(a0)
	bne.b	.out
	cmp.l	#$48e7ffff,(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; Unpack Imploder
;
; IN :	D6 = Type (0=1.0-3.1, 16=4.0)
;
; OUT:	D0 = Success (0=Error)
;

UIMP	lea	-$1c(sp),sp
	move.l	sp,a5
	clr.l	-(sp)			;Exit Code

	move.l	UI_CrunchAdrTemp(a4),a0
	move.l	8(a0),d0		;Highest Hunk Number+1
	subq.l	#4,d0
	move.w	d0,d5
	subq.l	#1,d0
	lea	$18(a0),a2
	move.l	a2,$18(a5)

	moveq	#0,d1
UIMP1	move.l	(a2)+,d2
	and.l	#$3fffffff,d2
	add.l	d2,d1
	addq.l	#4,d1
	dbra	d0,uimp1

	move.l	d1,d0
	lsl.l	#2,d1
	add.l	d0,d0
	add.l	d1,d0
	move.l	d0,(a5)
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,4(a5)
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	uimpo

	addq.l	#8,a2
	move.l	(a2)+,d0
	lsl.l	#2,d0
	move.l	d0,8(a5)
	bsr.w	alcmem
	move.l	d0,12(a5)
	beq.w	uimpo

	addq.l	#4,a2
	move.w	d5,d0
	subq.w	#1,d0
	move.l	(a2)+,d1
	lsl.l	#2,d1
	lea	4(a2,d1.l),a2
UIMP2	lea	12(a2),a2
	dbra	d0,uimp2

	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	cmp.l	#$3e9,(a2)+		;Hunk_Code
	bne.w	uimpo1
	addq.l	#4,a2
	cmp.w	#$d3fc,6(a2)
	bne.w	uimpo1

	sf	UI_Temp1(a4)
	lea	(a2,d6.l),a0
	cmp.w	#$3607,$106(a0)
	beq.b	uimp3
	st	UI_Temp1(a4)

UIMP3	move.l	8(a2),16(a5)
	move.l	-4(a2),d0
	lsl.l	#2,d0
	lea	4(a2,d0.l),a3
	cmp.l	#$3ea,(a3)+		;Hunk_Data
	bne.w	uimpo1
	addq.l	#4,a3
	add.l	16(a5),a3
	move.l	a3,20(a5)

	add.l	d6,a2
	move.l	a4,-(sp)
	tst.b	UI_Temp1(a4)
	bne.b	uimp4
	lea	-$36(sp),sp
	move.l	sp,a4
	lea	$126(a2),a0

	lea	8(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)+
	lea	$188(a2),a0
	lea	$24(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)+
	lea	$1d6(a2),a0
	move.l	(a0)+,(a4)
	move.l	(a0),4(a4)
	lea	$178(a2),a0
	lea	$14(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)
	move.l	4(a4),d0
	bclr	#31,d0
	move.l	d0,4(a4)
	move.w	d5,$34(a4)

	move.l	12(a5),a6
	move.l	8(a5),d0
	move.l	d0,d4
	add.l	d0,a6
	move.l	a6,a2
	move.l	20(a5),a0
	move.l	4(a5),a1
	move.w	$34(a4),d0
	lsl.w	#2,d0
	lea	$14(a1,d0.w),a1
	bsr.w	uimpl			;Unpack Data
	lea	$36(sp),sp
	bra.b	uimp4a

UIMP4	lea	-$3e(sp),sp
	move.l	sp,a4
	lea	$126(a2),a0

	lea	8(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)+
	lea	$188(a2),a0
	lea	$2c(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)+
	lea	$1d6(a2),a0
	move.l	(a0)+,(a4)
	move.l	(a0),4(a4)
	lea	$178(a2),a0
	lea	$1c(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)
	move.l	4(a4),d0
	bclr	#31,d0
	move.l	d0,4(a4)
	move.w	d5,$3c(a4)

	move.l	12(a5),a6
	move.l	8(a5),d0
	move.l	d0,d4
	add.l	d0,a6
	move.l	a6,a2
	move.l	20(a5),a0
	move.l	4(a5),a1
	move.w	$3c(a4),d0
	lsl.w	#2,d0
	lea	$14(a1,d0.w),a1
	bsr.w	uiml			;Unpack Data
	lea	$3e(sp),sp

UIMP4a	move.l	(sp)+,a4
	sub.l	4(a5),a1
	move.l	a1,UI_DecrunchLen(a4)
	move.l	4(a5),a0
	move.l	UI_CrunchAdrTemp(a4),a1

	move.l	#$3f3,(a0)+		;Hunk_Header
	clr.l	(a0)+
	move.l	8(a1),d0
	subq.l	#4,d0
	move.l	d0,(a0)+
	clr.l	(a0)+
	subq.l	#1,d0
	move.l	d0,(a0)+

	lea	$18(a1),a1
UIMP5	move.l	(a1)+,(a0)+
	dbra	d0,uimp5
	move.l	#-1,(sp)

UIMPO1	move.l	12(a5),a1
	bsr.w	fremem
UIMPO	move.l	(sp)+,d0
	lea	$1c(sp),sp
	rts
;------------------------------------------------------------------------------
; Unpack Imploder Overlayed
;
; IN :	D6 = Type (0=1.0-3.1, 16=4.0)
;
; OUT:	D0 = Success (0=Error)
;

UIMPOV	lea	-$24(sp),sp
	move.l	sp,a5
	clr.l	-(sp)			;Exit Code

	move.l	UI_CrunchAdrTemp(a4),a0
	move.l	16(a0),d0
	sub.l	12(a0),d0		;Highest Hunk Number+1
	subq.l	#3,d0
	move.w	d0,d5
	subq.l	#1,d0
	lea	$18(a0),a2
	move.l	a2,$18(a5)

	moveq	#0,d1
UIMPOV1	move.l	(a2)+,d2
	and.l	#$3fffffff,d2
	add.l	d2,d1
	addq.l	#4,d1
	dbra	d0,uimpov1

	move.l	d1,d0
	lsl.l	#2,d1
	add.l	d0,d0
	add.l	d1,d0
	move.l	d0,(a5)

	addq.l	#8,a2
	move.l	(a2)+,d0
	lsl.l	#2,d0
	move.l	d0,8(a5)
	bsr.w	alcmem
	move.l	d0,12(a5)
	beq.w	uimpovo

	addq.l	#4,a2
	move.w	d5,d0
	subq.w	#1,d0
	move.l	(a2)+,d1
	lsl.l	#2,d1
	lea	4(a2,d1.l),a2
UIMPOV2	lea	12(a2),a2
	dbra	d0,uimpov2

	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	cmp.l	#$3e9,(a2)+		;Hunk_Code
	bne.w	uimovo1
	addq.l	#4,a2
	cmp.w	#$d3fc,6(a2)
	bne.w	uimovo1

	move.l	8(a2),16(a5)
	move.l	-4(a2),d0
	lsl.l	#2,d0
	lea	4(a2,d0.l),a3
	cmp.l	#$3ea,(a3)+		;Hunk_Data
	bne.w	uimovo1
	addq.l	#4,a3
	move.l	a3,a0
	add.l	16(a5),a3
	move.l	a3,20(a5)

; Calculate Overlayed Size

	move.l	-4(a0),d0
	lsl.l	#2,d0
	lea	16(a0,d0.l),a0		;Start Of Overlayed Data
	move.l	a0,$1c(a5)
	cmp.l	#$3f5,(a0)+
	bne.w	uimovo1
	moveq	#0,d2
	moveq	#4,d0
UIMPOV3	addq.l	#4,d0
	move.l	(a0)+,d1
	beq.b	uimov3a
	add.l	(a0),d2
	lsl.l	#2,d1
	add.l	d1,d0
	lea	(a0,d1.l),a0
	bra.b	uimpov3

UIMOV3a	subq.l	#1,d2
UIMPOV4	cmp.l	#$3f3,(a0)
	bne.w	uimovo1
	move.l	16(a0),d1
	sub.l	12(a0),d1
	move.l	d1,d3
	lsl.l	#2,d1
	lea	$18(a0,d1.l),a0
	add.l	d3,d0
	add.l	#24,d0

UIMOV4a	addq.l	#8,d0
	addq.l	#4,d0
	cmp.w	#$3eb,2(a0)
	beq.b	uimov4c
	cmp.w	#$3e9,2(a0)
	beq.b	uimov4b
	cmp.w	#$3ea,2(a0)
	bne.w	uimovo1

UIMOV4b	move.l	4(a0),d1
	lsl.l	#2,d1
	add.l	d1,d0
	lea	12(a0,d1.l),a0
UIMOV4c	dbra	d3,uimov4a
	addq.l	#4,d0
	addq.l	#4,a0
	dbra	d2,uimpov4
	move.l	d0,$20(a5)

	move.w	#UERR_Memory,UI_ErrorNum(a4)
	add.l	(a5),d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,4(a5)
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	uimovo1

	add.l	d6,a2
	move.l	a4,-(sp)
	lea	-$36(sp),sp
	move.l	sp,a4
	lea	$126(a2),a0

	lea	8(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	lea	$188(a2),a0
	lea	$24(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	lea	$1d6(a2),a0
	move.l	(a0)+,(a4)
	move.l	(a0),4(a4)
	lea	$178(a2),a0
	lea	$14(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0),(a1)
	move.l	4(a4),d0
	bclr	#31,d0
	move.l	d0,4(a4)
	move.w	d5,$34(a4)

	move.l	12(a5),a6
	move.l	8(a5),d0
	move.l	d0,d4
	add.l	d0,a6
	move.l	a6,a2
	move.l	20(a5),a0
	move.l	4(a5),a1
	move.w	$34(a4),d0
	lsl.w	#2,d0
	lea	$14(a1,d0.w),a1
	bsr.w	uimpl			;Unpack Data
	lea	$36(sp),sp
	move.l	(sp)+,a4

	sub.l	4(a5),a1
	move.l	a1,UI_Temp(a4)
	add.l	$20(a5),a1
	move.l	a1,UI_DecrunchLen(a4)

	move.l	4(a5),a0
	move.l	UI_CrunchAdrTemp(a4),a1
	move.l	#$3f3,(a0)+		;Hunk_Header
	clr.l	(a0)+
	move.l	8(a1),d0
	subq.l	#1,d0
	move.l	d0,(a0)+
	clr.l	(a0)+
	move.l	16(a1),d0
	sub.l	12(a1),d0
	subq.l	#4,d0
	move.l	d0,(a0)+

	lea	$18(a1),a1
UIMPOV5	move.l	(a1)+,(a0)+
	dbra	d0,uimpov5

; Rebuild Overlayed Part

	move.l	4.w,a6
	move.l	$1c(a5),a0
	move.l	4(a5),a1
	add.l	UI_Temp(a4),a1		;End Of Decrunched Data
	move.l	$20(a5),d0
	jsr	CopyMem(a6)

	move.l	UI_Temp(a4),d1
	sub.l	$1c(a5),d1
	add.l	UI_CrunchAdrTemp(a4),d1	;Offset

	move.l	4(a5),a0
	add.l	UI_Temp(a4),a0
	addq.l	#8,a0
	move.l	(a0)+,d0
UIMPOV6	add.l	d1,(a0)+
	addq.l	#4,a0
	subq.l	#1,d0
	bne.b	uimpov6
	move.l	#-1,(sp)

UIMOVO1	move.l	12(a5),a1
	bsr.w	fremem
UIMPOVO	move.l	(sp)+,d0
	lea	$24(sp),sp
	rts
;------------------------------------------------------------------------------
; Unpack Imploder Library
;

UIMLIB	clr.l	-(sp)
	lea	-$1c(sp),sp
	move.l	sp,a5
	move.l	UI_CrunchAdrTemp(a4),a0
	move.l	8(a0),d0
	subq.w	#2,d0
	move.w	d0,d5
	subq.w	#1,d0
	lea	$14(a0),a2
	move.l	a2,$18(a5)

	moveq	#0,d1
UIMLIB1	move.l	(a2)+,d2
	and.l	#$3fffffff,d2
	add.l	d2,d1
	addq.l	#4,d1
	dbra	d0,uimlib1

	move.l	d1,d0
	lsl.l	#2,d1
	add.l	d0,d0
	add.l	d1,d0
	move.l	d0,(a5)
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,4(a5)
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	uimlibo

	move.l	(a2)+,d2
	lsl.l	#2,d2
	move.l	(a2)+,d0
	lsl.l	#2,d0
	move.l	d0,8(a5)
	bsr.w	alcmem
	move.l	d0,12(a5)
	beq.w	uimlibo

	addq.l	#8,a2
	tst.b	5(a2)
	beq.b	uimlib3
	subq.l	#4,d2
	or.b	5(a2),d2
UIMLIB3	move.l	d2,16(a5)

	lea	$1c(a2),a3
	move.l	-4(a2),d1
	lsl.l	#2,d1
	add.l	d1,a2
	addq.l	#4,a2
	move.w	d5,d0
	subq.w	#2,d0
	bmi.b	uimlib5
UIMLIB4	lea	12(a2),a2
	dbra	d0,uimlib4

UIMLIB5	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	cmp.l	#$3ea,(a2)+		;Hunk_Data
	bne.w	uimlio1
	addq.l	#4,a2
	add.l	16(a5),a2
	move.l	a2,$14(a5)

	move.l	a4,-(sp)
	lea	-$36(sp),sp
	move.l	sp,a4
	lea	uimtab1(pc),a0
	lea	8(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.b	(a3),d0
	lsr.b	#4,d0
	move.b	d0,-(a1)
	move.b	(a3)+,d0
	and.w	#$000f,d0
	mulu	#12,d0
	lea	uimtab2(pc),a0
	add.l	d0,a0
	lea	$24(a4),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)
	move.b	(a3)+,2(a4)
	move.w	(a3)+,(a4)
	move.l	(a3),4(a4)
	clr.b	3(a4)
	lea	$24(a4),a0
	lea	$14(a4),a1

	moveq	#7,d1
UIMLIB6	move.b	(a0)+,d0
	bpl.b	uimlib7
	and.b	#$7f,d0
	addq.b	#8,d0
UIMLIB7	moveq	#0,d2
	bset	d0,d2
	tst.l	4(a4)
	bpl.b	uimlib8
	subq.w	#1,d2
UIMLIB8	move.w	d2,(a1)+
	dbra	d1,uimlib6

	lea	$14(a4),a0
	lea	$1c(a4),a1
	moveq	#3,d1
UIMLIB9	move.w	(a0)+,d0
	add.w	d0,(a1)+
	dbra	d1,uimlib9

	move.l	4(a4),d0
	bclr	#31,d0
	move.l	d0,4(a4)
	move.w	d5,$34(a4)
	move.l	12(a5),a6
	move.l	8(a5),d0
	move.l	d0,d4
	add.l	d0,a6
	move.l	a6,a2
	move.l	$14(a5),a0
	move.l	4(a5),a1
	move.w	$34(a4),d0
	lsl.w	#2,d0
	lea	$14(a1,d0.w),a1
	bsr.w	uimpl
	lea	$36(sp),sp
	move.l	(sp)+,a4

	move.l	a1,d0
	sub.l	4(a5),d0
	move.l	4(a5),UI_DecrunchAdr(a4)
	move.l	d0,UI_DecrunchLen(a4)
	move.l	4(a5),a0
	move.l	UI_CrunchAdrTemp(a4),a1
	move.l	#$3f3,(a0)+		;Hunk_Header
	clr.l	(a0)+
	move.l	8(a1),d0
	subq.l	#2,d0
	move.l	d0,(a0)+
	clr.l	(a0)+
	subq.l	#1,d0
	move.l	d0,(a0)+
	lea	$14(a1),a1
UIMLI10	move.l	(a1)+,(a0)+
	dbra	d0,uimli10
	move.l	#-1,$1c(sp)

UIMLIO1	move.l	12(a5),a1
	bsr.w	fremem
UIMLIBO	lea	$1c(sp),sp
	move.l	(sp)+,d0
	rts

UIMTAB1	dc.l	$060a0a12,$02030304,$04050700
UIMTAB2	dc.l	$05050505,$05050505,$06060606,$05060707
	dc.l	$06060606,$07070606,$05060707,$07070707
	dc.l	$80808080,$05060780,$07078080,$80818181
	dc.l	$06070780,$07808181,$80818282,$06070780
	dc.l	$07818182,$80828383,$06070780,$07818182
	dc.l	$80828484,$06070780,$07818282,$80838485
	dc.l	$06070780,$07818283,$80838586
;------------------------------------------------------------------------------
; Unpack Routine
;

UIMPLM1	MACRO
	add.b	d1,d1
	bne.b	.UNIMP\@
	move.b	-(a0),d1
	addx.b	d1,d1
.UNIMP\@
	bcc.b	\1
	ENDM

UIMPLM2	MACRO
	add.b	d1,d1
	bne.b	.unimp\@
	move.b	-(a0),d1
	addx.b	d1,d1
.UNIMP\@
	addx.b	d0,d0
	ENDM

UIMPL	moveq	#0,d5
	move.l	a5,d7
UIMPL1	cmp.l	a6,a2
	bne.b	uimpl2
	bsr.w	uimpl16
UIMPL2	move.l	(a2)+,d0
	bpl.b	uimpl4

	bclr	#31,d7
	bne.b	uimpl3
	move.l	#$3eb,(a1)+		;Hunk_Bss
	movem.l	d0/a0/a5,-(sp)
	move.l	d7,a5
	move.l	$18(a5),a0
	move.w	d5,d0
	lsl.w	#2,d0
	move.l	(a0,d0.w),d0
	and.l	#$3fffffff,d0
	move.l	d0,(a1)+
	movem.l	(sp)+,d0/a0/a5

UIMPL3	move.l	#$3f2,(a1)+		;Hunk_End
	addq.w	#1,d5
	cmp.w	$34(a4),d5
	bne.b	uimpl1
	move.l	d7,a5
	rts

UIMPL4	bset	#31,d7
	add.l	d0,d0
	bpl.b	uimpl10
	move.l	#$3ec,(a1)+		;Hunk_Reloc32
UIMPL5	cmp.l	a6,a2
	bne.b	uimpl6
	bsr.b	uimpl16
UIMPL6	move.l	(a2)+,d0
	move.l	d0,(a1)+
	beq.b	uimpl1
	cmp.l	a6,a2
	bne.b	uimpl7
	bsr.b	uimpl16
UIMPL7	move.l	(a2)+,(a1)+
	moveq	#0,d2
UIMPL8	cmp.l	a6,a2
	bne.b	uimpl9
	bsr.b	uimpl16
UIMPL9	add.l	(a2)+,d2
	move.l	d2,(a1)+
	subq.l	#1,d0
	bne.b	uimpl8
	bra.b	uimpl5

UIMPL10	lsr.l	#1,d0
	move.l	#$3e9,(a1)+		;Hunk_Code
	move.l	d0,(a1)+
UIMPL11	lea	-$20(a6),a6
	movem.l	d1-d7/a0,-(sp)
UIMPL12	subq.l	#8,d0
	bmi.b	uimpl13
	cmp.l	a6,a2
	bhi.b	uimpl13
	movem.l	(a2)+,d1-d7/a0
	movem.l	d1-d7/a0,(a1)
	lea	$20(a1),a1
	bra.b	uimpl12

UIMPL13	movem.l	(sp)+,d1-d7/a0
	lea	$20(a6),a6
	addq.l	#8,d0
	beq.w	uimpl1
UIMPL14	cmp.l	a6,a2
	beq.b	uimpl15
	move.l	(a2)+,(a1)+
	subq.l	#1,d0
	bne.b	uimpl14
	bra.w	uimpl1

UIMPL15	bsr.b	uimpl16
	bra.b	uimpl11

UIMPL16	sub.l	d4,a2
	movem.l	d0-d3/d5-d7/a3,-(sp)
	move.l	a2,a3
	move.w	d4,d5
	move.w	(a4),d2
	move.b	2(a4),d1
	move.b	3(a4),d0
	bne.w	uimpl37
	bra.w	uimpl38

UIMPL17	UIMPLM1	uimpl22
	UIMPLM1	uimpl21
	UIMPLM1	uimpl20
	UIMPLM1	uimpl19
	UIMPLM1	uimpl18
	move.b	-(a0),d0
	moveq	#3,d7
	bra.b	uimpl23

UIMPL18	UIMPLM2
	UIMPLM2
	UIMPLM2
	addq.b	#6,d0
	moveq	#3,d7
	bra.b	uimpl23

UIMPL19	moveq	#5,d0
	moveq	#3,d7
	bra.b	uimpl23

UIMPL20	moveq	#4,d0
	moveq	#2,d7
	bra.b	uimpl23

UIMPL21	moveq	#3,d0
	moveq	#1,d7
	bra.b	uimpl23

UIMPL22	moveq	#2,d0
	moveq	#0,d7
UIMPL23	move.w	d7,d3
	UIMPLM1	uimpl24
	UIMPLM1	uimpl26
	moveq	#0,d6
	move.b	8(a4,d7.w),d6
	addq.b	#4,d7
	bra.b	uimpl27

UIMPL24	add.b	d1,d1
	bne.b	uimpl25
	move.b	-(a0),d1
	addx.b	d1,d1
UIMPL25	addx.w	d2,d2
	bra.b	uimpl30

UIMPL26	moveq	#2,d6
UIMPL27	move.b	12(a4,d7.w),d7
UIMPL28	add.b	d1,d1
	bne.b	uimpl29
	move.b	-(a0),d1
	addx.b	d1,d1
UIMPL29	addx.w	d2,d2
	subq.b	#1,d7
	bne.b	uimpl28
	add.w	d6,d2
UIMPL30	moveq	#0,d6
	move.w	d6,a5
	move.w	d3,d7
	UIMPLM1	uimpl32
	add.w	d3,d3
	UIMPLM1	uimpl31
	move.w	$1c(a4,d3.w),a5
	addq.b	#8,d7
	bra.b	uimpl32

UIMPL31	move.w	$14(a4,d3.w),a5
	addq.b	#4,d7
UIMPL32	move.b	$24(a4,d7.w),d7
	bpl.b	uimpl33
	move.b	-(a0),d6
	and.b	#$7f,d7
	beq.b	uimpl35
UIMPL33	add.b	d1,d1
	bne.b	uimpl34
	move.b	-(a0),d1
	addx.b	d1,d1
UIMPL34	addx.w	d6,d6
	subq.b	#1,d7
	bne.b	uimpl33
UIMPL35	addq.w	#1,d6
	add.w	a5,d6
	move.l	a3,a5
	sub.w	d6,a5
	cmp.l	a2,a5
	bcc.b	uimpl36
	add.w	d4,a5
UIMPL36	cmp.l	a5,a6
	bne.b	uimpl37
	move.l	a2,a5

UIMPL37	subq.w	#1,d5
	bmi.b	uimpl41
	move.b	(a5)+,(a3)+
	subq.b	#1,d0
	bne.b	uimpl36

UIMPL38	tst.w	d2
	beq.b	uimpl40
UIMPL39	subq.w	#1,d5
	bmi.b	uimpl41
	move.b	-(a0),(a3)+
	subq.w	#1,d2
	bne.b	uimpl39
UIMPL40	subq.l	#1,4(a4)
	bne.w	uimpl17

UIMPL41	move.b	d0,3(a4)
	move.b	d1,2(a4)
	move.w	d2,(a4)
	movem.l	(sp)+,d0-d3/d5-d7/a3
	rts
;------------------------------------------------------------------------------
; Special Unpacker Routine
;

UIML	moveq	#0,d5
	move.l	a5,d7
UIML1	cmp.l	a6,a2
	bne.b	uiml2
	bsr.w	uiml16
UIML2	move.l	(a2)+,d0
	bpl.b	uiml4

	bclr	#31,d7
	bne.b	uiml3
	move.l	#$3eb,(a1)+		;Hunk_Bss
	movem.l	d0/a0/a5,-(sp)
	move.l	d7,a5
	move.l	$18(a5),a0
	move.w	d5,d0
	lsl.w	#2,d0
	move.l	(a0,d0.w),d0
	and.l	#$3fffffff,d0
	move.l	d0,(a1)+
	movem.l	(sp)+,d0/a0/a5

UIML3	move.l	#$3f2,(a1)+		;Hunk_End
	addq.w	#1,d5
	cmp.w	$3c(a4),d5
	bne.b	uiml1
	move.l	d7,a5
	rts

UIML4	bset	#31,d7
	add.l	d0,d0
	bpl.b	uiml10
	move.l	#$3ec,(a1)+		;Hunk_Reloc32
UIML5	cmp.l	a6,a2
	bne.b	uiml6
	bsr.b	uiml16
UIML6	move.l	(a2)+,d0
	move.l	d0,(a1)+
	beq.b	uiml1
	cmp.l	a6,a2
	bne.b	uiml7
	bsr.b	uiml16
UIML7	move.l	(a2)+,(a1)+
	moveq	#0,d2
UIML8	cmp.l	a6,a2
	bne.b	uiml9
	bsr.b	uiml16
UIML9	add.l	(a2)+,d2
	move.l	d2,(a1)+
	subq.l	#1,d0
	bne.b	uiml8
	bra.b	uiml5

UIML10	lsr.l	#1,d0
	move.l	#$3e9,(a1)+		;Hunk_Code
	move.l	d0,(a1)+
UIML11	lea	-$20(a6),a6
	movem.l	d1-d7/a0,-(sp)
UIML12	subq.l	#8,d0
	bmi.b	uiml13
	cmp.l	a6,a2
	bhi.b	uiml13
	movem.l	(a2)+,d1-d7/a0
	movem.l	d1-d7/a0,(a1)
	lea	$20(a1),a1
	bra.b	uiml12

UIML13	movem.l	(sp)+,d1-d7/a0
	lea	$20(a6),a6
	addq.l	#8,d0
	beq.w	uiml1
UIML14	cmp.l	a6,a2
	beq.b	uiml15
	move.l	(a2)+,(a1)+
	subq.l	#1,d0
	bne.b	uiml14
	bra.w	uiml1

UIML15	bsr.b	uiml16
	bra.b	uiml11

UIML16	sub.l	d4,a2
	movem.l	d0-d3/d5-d7/a3,-(sp)
	move.l	a2,a3
	move.w	d4,d5
	move.w	(a4),d2
	move.b	2(a4),d1
	move.b	3(a4),d0
	bne.w	uiml37
	bra.w	uiml38

UIML17	UIMPLM1	uiml22
	UIMPLM1	uiml21
	UIMPLM1	uiml20
	UIMPLM1	uiml19
	UIMPLM1	uiml18
	move.b	-(a0),d0
	moveq	#3,d7
	bra.b	uiml23

UIML18	UIMPLM2
	UIMPLM2
	UIMPLM2
	addq.b	#6,d0
	moveq	#3,d7
	bra.b	uiml23

UIML19	moveq	#5,d0
	moveq	#3,d7
	bra.b	uiml23

UIML20	moveq	#4,d0
	moveq	#2,d7
	bra.b	uiml23

UIML21	moveq	#3,d0
	moveq	#1,d7
	bra.b	uiml23

UIML22	moveq	#2,d0
	moveq	#0,d7
UIML23	moveq	#0,d6
	move.w	d7,d3
	UIMPLM1	uiml25
	UIMPLM1	uiml24
	move.b	12(a4,d7.w),d6
	addq.b	#8,d7
	bra.b	uiml25

UIML24	move.b	8(a4,d7.w),d6
	addq.b	#4,d7
UIML25	move.b	16(a4,d7.w),d7
UIML26	add.b	d1,d1
	bne.b	uiml27
	move.b	-(a0),d1
	addx.b	d1,d1
UIML27	addx.w	d2,d2
	subq.b	#1,d7
	bne.b	uiml26
	add.w	d6,d2
	moveq	#0,d6
	move.w	d6,a5
	move.w	d3,d7
	UIMPLM1	uiml32
	add.w	d3,d3
	UIMPLM1	uiml31
	move.w	$24(a4,d3.w),a5
	addq.b	#8,d7
	bra.b	uiml32

UIML31	move.w	$1c(a4,d3.w),a5
	addq.b	#4,d7
UIML32	move.b	$2c(a4,d7.w),d7
	bpl.b	uiml33
	move.b	-(a0),d6
	and.b	#$7f,d7
	beq.b	uiml35
UIML33	add.b	d1,d1
	bne.b	uiml34
	move.b	-(a0),d1
	addx.b	d1,d1
UIML34	addx.w	d6,d6
	subq.b	#1,d7
	bne.b	uiml33
UIML35	addq.w	#1,d6
	add.w	a5,d6
	move.l	a3,a5
	sub.w	d6,a5
	cmp.l	a2,a5
	bcc.b	uiml36
	add.w	d4,a5
UIML36	cmp.l	a5,a6
	bne.b	uiml37
	move.l	a2,a5

UIML37	subq.w	#1,d5
	bmi.b	uiml41
	move.b	(a5)+,(a3)+
	subq.b	#1,d0
	bne.b	uiml36

UIML38	tst.w	d2
	beq.b	uiml40
UIML39	subq.w	#1,d5
	bmi.b	uiml41
	move.b	-(a0),(a3)+
	subq.w	#1,d2
	bne.b	uiml39
UIML40	subq.l	#1,4(a4)
	bne.w	uiml17

UIML41	move.b	d0,3(a4)
	move.b	d1,2(a4)
	move.w	d2,(a4)
	movem.l	(sp)+,d0-d3/d5-d7/a3
	rts
;------------------------------------------------------------------------------
