;******************************************************************************
;* Lha                                                                        *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; Lha/Lharc

LHA	dc.w	lhasfx-lha,lhat-lha,CN_Lha,typenum
	dc.b	CRU_Archive,PSF_RecogFunc
	dc.w	128
	dc.l	0
	dc.w	_lhat-lha,ulha-lha,0

LHAT	PSNAME	"Lha/Lharc"

_LHAT
	moveq	#0,d0			;Unknown
	cmp.w	#"-l",2(a0)
	bne.b	.out
	cmp.b	#"h",4(a0)
	bne.b	.out
	cmp.b	#"-",6(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; LhaSFX

LHASFX	dc.w	light15-lhasfx,lhasfxt-lhasfx,CN_LhaSFX,typenum
	dc.b	CRU_Archive,PSF_RecogFunc
	dc.w	StartLoad
	dc.l	0
	dc.w	_lhasfxt-lhasfx,ulha-lhasfx,0

LHASFXT	PSNAME	"LhaSFX"

_LHASFXT
	moveq	#0,d0			;Unknown
	cmp.l	#$3f3,(a0)
	bne.b	.out
	cmp.l	#"SFX!",44(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts
;------------------------------------------------------------------------------
; Unpack A LHA File
;

ULHA	bsr.w	fdout			;Find Output File
	beq.w	ulhao
	bsr.w	cacclr			;Clear Caches

	lea	lhastr(pc),a0
	lea	UI_ExecuteString(a4),a1
ULHA1	move.b	(a0)+,(a1)+		;Copy Start Of The String
	bne.b	ulha1

	move.b	#">",-1(a1)
	lea	UI_OutputFile(a4),a0
ULHA2	move.b	(a0)+,(a1)+		;Copy Output
	bne.b	ulha2

	subq.l	#1,a1
	lea	lhastr1(pc),a0
ULHA3	move.b	(a0)+,(a1)+		;Copy End Of The String
	bne.b	ulha3

	move.b	#$22,-1(a1)
	move.l	UI_Filename(a4),a0
ULHA4	move.b	(a0)+,(a1)+		;Copy Archive Name
	bne.b	ulha4
	move.b	#$22,-1(a1)

	move.b	#" ",(a1)+
	move.l	UI_Path(a4),d0
	beq.b	ulha5a

	move.b	#$22,(a1)+
	move.l	d0,a0
ULHA5	move.b	(a0)+,(a1)+		;Copy Path
	bne.b	ulha5
	move.b	#$22,-1(a1)
ULHA5a	clr.b	(a1)

	btst	#UFB_OneFile,UI_Flag(a4);One File At The Time
	bne.b	ulhaone			;Yup!!

; Unpack The Whole Archive

	tst.l	UI_LhaPattern(a4)
	beq.b	ulha7
	move.b	#" ",(a1)+
	move.l	UI_LhaPattern(a4),a0
ULHA6	move.b	(a0)+,(a1)+		;Copy Pattern
	bne.b	ulha6

ULHA7	move.w	#UERR_Extern,UI_ErrorNum(a4)
	bsr.w	exestr			;Execute String
	beq.b	ulha8
	lea	lhard(pc),a0
	bsr.w	scandir			;Scan Directory And Load File
ULHAO	rts

ULHA8	bsr.w	udel			;Delete Temp Directory
	rts

; Unpack One File At The Time

ULHAONE move.b	#" ",(a1)+
	move.l	a1,-(sp)

	move.l	#StartLoad,d0
	bsr.w	alcmem			;Allocate Header Buffer
	beq.w	ulhaono
	move.l	d0,-(sp)		;Store Memory Address

	move.l	LIB_DosBase(a5),a6
	move.l	UI_FileName(a4),d1
	move.l	#1005,d2
	jsr	Open(a6)
	tst.l	d0
	beq.w	ulhaoo1
	move.l	d0,-(sp)		;Store File Handler

	moveq	#0,d7			;Seek Value
	cmp.w	#CN_LHASFX,UI_CrunchNum(a4)
	bne.b	olhalop

OLSFXLP	move.l	(sp),d1
	move.l	4(sp),d2
	move.l	#StartLoad,d3
	jsr	Read(a6)

	move.l	4(sp),a0
	move.w	#StartLoad/4-1,d0
OLSFXL1	addq.l	#4,d7
	cmp.l	#$03f2,(a0)+
	beq.b	olsfxl2
	dbra	d0,olsfxl1
	bra.b	olsfxlp

OLSFXL2	addq.l	#4,d7
	cmp.l	#$03eb,(a0)+
	bne.b	olsfxl1
	addq.l	#8,d7
	addq.l	#4,a0
	cmp.l	#$03f2,(a0)+
	bne.b	olsfxl1
	addq.l	#4,d7
	cmp.l	#$03f5,(a0)+
	bne.b	olsfxl1
	add.l	#5*4,d7
	lea	5*4(a0),a0

	moveq	#0,d0
	move.b	(a0),d0
	add.l	d0,d7
	addq.l	#4,d7

	move.b	10(a0),d0
	lsl.l	#8,d0
	move.b	9(a0),d0
	lsl.l	#8,d0
	move.b	8(a0),d0
	lsl.l	#8,d0
	move.b	7(a0),d0
	add.l	d0,d7

; One File Loop

OLHALOP	move.l	(sp),d1			;File Handler
	move.l	d7,d2
	moveq	#-1,d3
	jsr	Seek(a6)

	move.l	(sp),d1
	move.l	4(sp),d2
	move.l	#StartLoad,d3
	jsr	Read(a6)
	cmp.l	#-1,d0
	beq.b	ulhaoo2

	bsr.w	cacclr			;Clear Caches
	move.l	4(sp),a0
	moveq	#0,d0
	move.b	(a0),d0			;Header Size
	beq.b	ulhaoo2
	add.l	d0,d7
	addq.l	#2,d7

	move.b	10(a0),d0
	lsl.l	#8,d0
	move.b	9(a0),d0
	lsl.l	#8,d0
	move.b	8(a0),d0
	lsl.l	#8,d0
	move.b	7(a0),d0
	add.l	d0,d7			;Crunched Length

	moveq	#0,d0
	move.b	21(a0),d0		;Filename Length
	subq.w	#1,d0

	move.l	8(sp),a1		;String Address
	lea	22(a0),a0
OLHALP1	move.b	(a0)+,d1
	beq.b	olhalp3
	cmp.b	#"\",d1
	bne.b	olhalp2
	move.b	#"/",d1
OLHALP2	move.b	d1,(a1)+
	dbra	d0,olhalp1
OLHALP3	clr.b	(a1)

	move.l	8(sp),a1
	cmp.b	#"*",(a1)		;Display Text File?
	beq.b	olhalop			;Yip, Don't extract!!

	move.l	d7,-(sp)
	move.w	#UERR_Extern,UI_ErrorNum(a4)
	bsr.w	exestr			;Execute String
	bne.b	olhalp4
	move.l	(sp)+,d7
	bra.b	ulhao2a

OLHALP4	lea	lhard(pc),a0
	bsr.w	scandir			;Scan Directory And Load File
	move.l	(sp)+,d7
	tst.l	d0
	beq.b	ulhao2a
	bra.w	olhalop

; Stop Single File Unpacking

ULHAOO2	moveq	#-1,d0
ULHAO2a	move.l	d0,d7
	move.l	(sp)+,d1
	jsr	Close(a6)

ULHAOO1	move.l	(sp)+,a1
	bsr.w	fremem			;Free Header Buffer

ULHAONO	move.l	(sp)+,a1
	move.l	d7,d0
	rts

LHASTR	dc.b	"lha ",0
LHASTR1	dc.b	" -Q e ",0
	even
;------------------------------------------------------------------------------
; Lha Output Reader
;
; IN :	D7 = Size Of File
;	A0 = Start Address Of File
;	A1 = Jump Address
;
; OUT:	Nothing
;

LHARD	subq.l	#1,d7
	cmp.b	#$1b,(a0)+
	bne.b	lhard
	cmp.b	#$5b,(a0)
	bne.b	lhard

LHARD0	subq.l	#1,d7
	cmp.b	#$0a,(a0)+
	bne.b	lhard0

LHARD1	subq.l	#1,d7
	cmp.b	#$0d,(a0)+
	bne.b	lhard1

	sub.l	#34,d7
	lea	34(a0),a0
	cmp.l	#35,d7			;End Of File
	ble.b	lhardo			;Yup!

	lea	UI_LoadName(a4),a2
LHARD2	subq.l	#1,d7
	move.b	(a0)+,(a2)+		;Copy Filename
	cmp.b	#$1b,(a0)
	bne.b	lhard2
	clr.b	(a2)
	addq.l	#1,a0
	subq.l	#1,d7

	movem.l	a0-a1/d7,-(sp)
	jsr	(a1)
	movem.l	(sp)+,a0-a1/d7
	bra.b	lhard

LHARDO	rts
;------------------------------------------------------------------------------
