;******************************************************************************
;* Master Cruncher                                                            *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 3.0-3.1

MAST31	dc.w	mast31a-mast31,mast31t-mast31,CN_MastCrun31,typenum
	dc.b	CRU_Object,0
	dc.w	$3a8
	dc.l	0
	dc.w	_mast31d-mast31,_mast31-mast31,0

MAST31T	PSNAME	"Master Cruncher 3.0-3.1"

_MAST31D dc.w	$40,12-1
	dc.l	$266d0018,$508b201b,$2e00e788,$223c0001
	dc.l	$00004eae,$ff3a2b40,$000c508b,$20075380
	dc.l	$226d000c,$221b5889,$548122c1,$51c8fff6

_MAST31
	move.w	#$390,d2
	move.w	#$20e,d3
	bra.b	umast31
;------------------------------------------------------------------------------
; 3.0-3.1 Address

MAST31A	dc.w	max12-mast31a,mast31at-mast31a,CN_MastCrun31A,typenum
	dc.b	CRU_Address,0
	dc.w	$1e4
	dc.l	0
	dc.w	_mast31da-mast31a,_mast31a-mast31a,0

MAST31AT PSNAME	"Master Cruncher 3.0-3.1 Address"

_MAST31DA dc.w	$44,12-1
	dc.l	$6a025388,$1020e308,$66041020,$e310645a
	dc.l	$4241e308,$66041020,$e3106442,$47fa0038
	dc.l	$76034241,$14333000,$488278ff,$e56c4644

_MAST31A
	move.l	$3e(a0),UI_Address(a4)
	move.l	$48(a0),UI_JumpAdr(a4)

	move.w	#$1d4,d2
	move.w	#$52,d3
;;	bra	umast31
;------------------------------------------------------------------------------
; Unpack Master Cruncher

UMAST31	lea	(a0,d2.w),a2
	move.l	(a2),d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem			;Allocate Memory
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out

	move.l	d0,a1
	lea	(a0,d3.w),a0
	lea	-$1e(sp),sp
	move.l	sp,a3
	move.l	$6c(a0),(a3)+
	move.l	$70(a0),(a3)+
	move.l	$cc(a0),(a3)+
	move.l	$d0(a0),(a3)+
	move.w	$d4(a0),(a3)+
	move.l	$112(a0),(a3)+
	move.l	$116(a0),(a3)+
	move.l	$11a(a0),(a3)+
	move.l	sp,a3
	move.l	a2,a0
	bsr.b	mascr			;Decrunch
	lea	$1e(sp),sp

	moveq	#-1,d0
.OUT	rts
;------------------------------------------------------------------------------
; Master Cruncher Decruncher
;

MASCR	moveq	#-1,d7
	move.l	a1,a5
	move.l	(a0)+,d5
	add.l	d5,a1
	add.l	(a0),a0
	subq.l	#4,a0
	tst.w	-(a0)
	bpl.b	mascr1
	subq.l	#1,a0

MASCR1	move.b	-(a0),d0
MASCR2	lsl.b	#1,d0
	bne.b	mascr3
	move.b	-(a0),d0
	roxl.b	#1,d0
MASCR3	bcc.b	mascr10
	clr.w	d1
	lsl.b	#1,d0
	bne.b	mascr4
	move.b	-(a0),d0
	roxl.b	#1,d0
MASCR4	bcc.b	mascr9

	moveq	#3,d3
MASCR5	clr.w	d1
	move.b	(a3,d3.w),d2
	ext.w	d2
	moveq	#-1,d4
	lsl.w	d2,d4
	not.w	d4
	subq.w	#1,d2
MASCR6	lsl.b	#1,d0
	bne.b	mascr7
	move.b	-(a0),d0
	roxl.b	#1,d0
MASCR7	roxl.w	#1,d1
	dbra	d2,mascr6
	tst.w	d3
	beq.b	mascr8
	cmp.w	d1,d4
	dbne	d3,mascr5

MASCR8	move.b	4(a3,d3.w),d2
	ext.w	d2
	add.w	d2,d1
MASCR9	move.b	-(a0),-(a1)
	cmp.l	a5,a1
	dbeq	d1,mascr9
	cmp.w	d7,d1
	bne.w	mascr28

MASCR10	moveq	#3,d2
MASCR11	lsl.b	#1,d0
	bne.b	mascr12
	move.b	-(a0),d0
	roxl.b	#1,d0
MASCR12	bcc.b	mascr13
	dbra	d2,mascr11

MASCR13	clr.w	d1
	addq.w	#1,d2
	move.b	8(a3,d2.w),d3
	beq.b	mascr16
	ext.w	d3
	subq.w	#1,d3
MASCR14	lsl.b	#1,d0
	bne.b	mascr15
	move.b	-(a0),d0
	roxl.b	#1,d0
MASCR15	roxl.w	#1,d1
	dbra	d3,mascr14

MASCR16	move.b	13(a3,d2.w),d3
	ext.w	d3
	add.w	d3,d1
	cmp.w	#2,d1
	beq.b	mascr22
	moveq	#1,d3
MASCR17	lsl.b	#1,d0
	bne.b	mascr18
	move.b	-(a0),d0
	roxl.b	#1,d0
MASCR18	bcc.b	mascr19
	dbra	d3,mascr17

MASCR19	addq.w	#1,d3
	clr.w	d2
	move.b	18(a3,d3.w),d4
	ext.w	d4
MASCR20	lsl.b	#1,d0
	bne.b	mascr21
	move.b	-(a0),d0
	roxl.b	#1,d0
MASCR21	roxl.w	#1,d2
	dbra	d4,mascr20
	lsl.w	#1,d3
	add.w	22(a3,d3.w),d2
	bra.b	mascr26

MASCR22	clr.w	d2
	moveq	#5,d3
	clr.w	d4
	lsl.b	#1,d0
	bne.b	mascr23
	move.b	-(a0),d0
	roxl.b	#1,d0
MASCR23	bcc.b	mascr24
	moveq	#8,d3
	moveq	#64,d4
MASCR24	lsl.b	#1,d0
	bne.b	mascr25
	move.b	-(a0),d0
	roxl.b	#1,d0
MASCR25	roxl.w	#1,d2
	dbra	d3,mascr24
	add.w	d4,d2
MASCR26	lea	(a1,d2.w),a2
	ext.l	d1
	add.l	d1,a2
	subq.w	#1,d1
MASCR27	move.b	-(a2),-(a1)
	cmp.l	a5,a1
	dbeq	d1,mascr27
	cmp.w	d7,d1
	beq.w	mascr2
MASCR28	rts
;------------------------------------------------------------------------------
