;******************************************************************************
;* MaxPacker                                                                  *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.2

MAX12	dc.w	mega10-max12,max12t-max12,CN_MaxPacker12,typenum
	dc.b	CRU_Address,0
	dc.w	$1b0
	dc.l	0
	dc.w	max12d-max12,_max12-max12,0

MAX12T	PSNAME	"MaxPacker 1.2"

MAX12D	dc.w	$38,12-1
	dc.l	$4a42670c,$53456b00,$ffe01720,$534266f4
	dc.l	$53946700,$01227e03,$43fa004c,$d2016604
	dc.l	$1220d301,$65024ed1,$5d8951cf,$fff0d201

_MAX12
	move.l	a0,a2
	move.l	$1a4(a2),d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	.out

	move.l	$194(a2),UI_Address(a4)
	move.l	$190(a2),UI_JumpAdr(a4)

	move.l	d0,a3
	add.l	$1a4(a2),a3		;Decrunched End Address
	lea	$1a8(a2),a0
	add.l	$1a0(a2),a0		;Crunched End Address
	move.l	$22(a2),d4
	move.w	$198(a2),d2
	move.b	$19a(a2),d1
	move.b	$19b(a2),d0

	lea	-52(sp),sp
	move.l	sp,a5
	move.l	$19c(a2),(a5)
	move.l	$44(a2),4(a5)
	move.l	$e2(a2),8(a5)
	move.l	$e6(a2),12(a5)
	move.l	$ea(a2),16(a5)
	move.l	$13c(a2),20(a5)
	move.l	$140(a2),24(a5)
	move.l	$134(a2),28(a5)
	move.l	$138(a2),32(a5)
	move.l	$144(a2),36(a5)
	move.l	$148(a2),40(a5)
	move.l	$14c(a2),44(a5)
	move.w	$72(a2),d7
	sub.w	#$3a,d7
	ext.l	d7
	move.l	d7,48(a5)
	bsr.b	umaxp1
	lea	52(sp),sp
	moveq	#-1,d0
.OUT	rts
;------------------------------------------------------------------------------
; Max Unpacker
;

UMAXP	move.l	a3,a6
	sub.l	4(a5),a6
UMAXP1	move.l	d4,d5
	move.l	a3,a2
	move.b	d0,d0
	bne.w	umaxp32

UMAXP2	tst.w	d2
	beq.b	umaxp4
UMAXP3	subq.w	#1,d5
	bmi.b	umaxp
	move.b	-(a0),-(a3)
	subq.w	#1,d2
	bne.b	umaxp3
UMAXP4	subq.l	#1,(a5)
	beq.b	umaxp7

	moveq	#3,d7
	lea	umaxp13(pc),a1
	add.l	48(a5),a1
UMAXP5	add.b	d1,d1
	bne.b	umaxp6
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP6	bcs.b	umaxp8
	jmp	(a1)

UMAXP7	rts				;Get Out

UMAXP8	subq.l	#6,a1
	dbra	d7,umaxp5
	add.b	d1,d1
	bne.b	umaxp9
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP9	bcc.b	umaxp10
	move.b	-(a0),d0
	moveq	#3,d7
	bra.b	umaxp14

UMAXP10	moveq	#2,d7
UMAXP11	add.b	d1,d1
	bne.b	umaxp12
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP12	addx.b	d0,d0
	dbra	d7,umaxp11
	addq.b	#6,d0
	moveq	#3,d7
	bra.b	umaxp14

UMAXP13	moveq	#5,d0
	moveq	#3,d7
	bra.b	umaxp14

	moveq	#4,d0
	moveq	#2,d7
	bra.b	umaxp14

	moveq	#3,d0
	moveq	#1,d7
	bra.b	umaxp14

	moveq	#2,d0
	moveq	#0,d7
UMAXP14	move.w	d7,d3
	add.b	d1,d1
	bne.b	umaxp15
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP15	bcc.b	umaxp17
	add.b	d1,d1
	bne.b	umaxp16
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP16	bcc.b	umaxp19
	moveq	#0,d6
	move.b	8(a5,d7.w),d6
	addq.b	#4,d7
	bra.b	umaxp20

UMAXP17	add.b	d1,d1
	bne.b	umaxp18
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP18	addx.w	d2,d2
	bra.b	umaxp23

UMAXP19	moveq	#2,d6
UMAXP20	move.b	12(a5,d7.w),d7
UMAXP21	add.b	d1,d1
	bne.b	umaxp22
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP22	addx.w	d2,d2
	subq.b	#1,d7
	bne.b	umaxp21
	add.w	d6,d2
UMAXP23	moveq	#0,d6
	move.w	d6,a4
	move.w	d3,d7
	add.b	d1,d1
	bne.b	umaxp24
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP24	bcc.b	umaxp27
	add.w	d3,d3
	add.b	d1,d1
	bne.b	umaxp25
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP25	bcc.b	umaxp26
	move.w	20(a5,d3.w),a4
	addq.b	#8,d7
	bra.b	umaxp27

UMAXP26	move.w	28(a5,d3.w),a4
	addq.b	#4,d7
UMAXP27	move.b	36(a5,d7.w),d7
	bpl.b	umaxp28
	move.b	-(a0),d6
	and.b	#$0f,d7
	beq.b	umaxp30
UMAXP28	add.b	d1,d1
	bne.b	umaxp29
	move.b	-(a0),d1
	addx.b	d1,d1
UMAXP29	addx.w	d6,d6
	subq.b	#1,d7
	bne.b	umaxp28

UMAXP30	addq.w	#1,d6
	add.w	d6,a4
	add.l	a3,a4
UMAXP31	cmp.l	a4,a6
	bne.b	umaxp32
	move.l	a2,a4
UMAXP32	subq.w	#1,d5
	bmi.w	umaxp1
	move.b	-(a4),-(a3)
	subq.b	#1,d0
	bne.b	umaxp31
	bra.w	umaxp2
;------------------------------------------------------------------------------
