;******************************************************************************
;* MegaCruncher                                                               *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0

MEGA10	dc.w	mega12-mega10,mega10t-mega10,CN_MegaCrun10,typenum
	dc.b	CRU_Address,0
	dc.w	$180
	dc.l	0
	dc.w	mega10d-mega10,_mega10-mega10,0

MEGA10T	PSNAME	"MegaCruncher 1.0"

MEGA10D	dc.w	$00,12-1
	dc.l	$47fa012e,$200b222b,$000841fa,$0130d1c1
	dc.l	$226b0004,$2460d5c9,$20207203,$61000102
	dc.l	$4a02675a,$0c420007,$6624e288,$66046100

_MEGA10
	move.l	$158(a0),UI_Address(a4)
	move.l	$126(a0),UI_JumpAdr(a4)

	lea	$160(a0),a0
	bra.w	umega
;------------------------------------------------------------------------------
; 1.2

MEGA12	dc.w	mega12a-mega12,mega12t-mega12,CN_MegaCrun12,typenum
	dc.b	CRU_Object,0
	dc.w	$21a
	dc.l	0
	dc.w	mega12d-mega12,_mega12-mega12,0

MEGA12T PSNAME	"MegaCruncher 1.2"

MEGA12D	dc.w	$00,12-1
	dc.l	$48e7fffe,$2c780004,$4bfa01c0,$4cdd0003
	dc.l	$4eaeff3a,$4a806730,$41fa000e,$20806100
	dc.l	$008a4cdf,$7fff4eb9,$f0f0f0f0,$48e7fffe

_MEGA12
	lea	$1fa(a0),a0
	bsr.b	umega
	bra.w	mecruob
;------------------------------------------------------------------------------
; 1.2 Address

MEGA12A	dc.w	pcom-mega12a,mega12at-mega12a,CN_MegaCrun12A,typenum
	dc.b	CRU_Address,0
	dc.w	$184
	dc.l	0
	dc.w	mega12ad-mega12a,_mega12a-mega12a,0

MEGA12AT PSNAME	"MegaCruncher 1.2 Address"

MEGA12AD dc.w	$00,12-1
	dc.l	$47fa0132,$200b222b,$000841fa,$0134d1c1
	dc.l	$226b0004,$2460d5c9,$20207203,$61000106
	dc.l	$4a02675e,$0c420007,$6626e288,$66046100

_MEGA12A
	move.l	$15c(a0),UI_Address(a4)
	move.l	$12a(a0),UI_JumpAdr(a4)

	lea	$164(a0),a0
;;	bra.b	umega
;------------------------------------------------------------------------------
; MegaCruncher Decrunch Routine
;

UMEGA	add.l	-4(a0),a0		;End Address Of Crunched Data
	move.l	-(a0),d0		;Length Of Decrunched Data
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	beq.w	umegao
	move.l	d0,UI_DecrunchAdr(a4)
	move.l	d0,a1
	move.l	a1,a2
	add.l	UI_DecrunchLen(a4),a2

UMEGA0	moveq	#-1,d7
	moveq	#1,d6
	moveq	#2,d5
	moveq	#7,d4
	move.l	-(a0),d0

UMEGA1	moveq	#3,d1
	bsr.b	umega10
	tst.b	d2
	beq.b	umega8
	cmp.w	d4,d2
	bne.b	umega4
	lsr.l	d6,d0
	bne.b	umega2
	bsr.b	umega9
UMEGA2	bcc.b	umega3
	moveq	#10,d1
	bsr.b	umega10
	tst.w	d2
	bne.b	umega4
	moveq	#$12,d1
	bsr.b	umega10
	bra.b	umega4

UMEGA3	moveq	#4,d1
	bsr.b	umega10
	addq.w	#7,d2
UMEGA4	subq.w	#1,d2
UMEGA5	moveq	#7,d1
UMEGA6	lsr.l	d6,d0
	bne.b	umega7
	bsr.b	umega9
UMEGA7	roxl.l	d6,d3
	dbra	d1,umega6
	move.b	d3,-(a2)
	cmp.l	a1,a2
	dbeq	d2,umega5
	cmp.w	d7,d2
	beq.b	umega8
	bra.w	umega22

UMEGA8	moveq	#2,d1
	bsr.b	umega10
	moveq	#2,d3
	moveq	#8,d1
	tst.w	d2
	beq.b	umega20
	moveq	#4,d3
	cmp.w	d5,d2
	beq.b	umega17
	moveq	#3,d3
	cmp.w	d6,d2
	beq.b	umega15
	moveq	#2,d1
	bsr.b	umega10
	cmp.w	#3,d2
	beq.b	umega14
	cmp.w	d5,d2
	beq.b	umega13
	addq.w	#5,d2
	move.w	d2,d3
	bra.b	umega17

UMEGA9	move.l	-(a0),d0
	move.w	#$0010,ccr
	roxr.l	d6,d0
	rts

UMEGA10	subq.w	#1,d1
	moveq	#0,d2
UMEGA11	lsr.l	d6,d0
	bne.b	umega12
	bsr.b	umega9
UMEGA12	roxl.l	d6,d2
	dbra	d1,umega11
	rts

UMEGA13	moveq	#2,d1
	bsr.b	umega10
	addq.w	#7,d2
	move.w	d2,d3
	bra.b	umega17

UMEGA14	moveq	#8,d1
	bsr.b	umega10
	move.w	d2,d3
	bra.b	umega17

UMEGA15	moveq	#8,d1
	lsr.l	d6,d0
	bne.b	umega16
	bsr.b	umega9
UMEGA16	bcs.b	umega20
	moveq	#14,d1
	bra.b	umega20

UMEGA17	moveq	#16,d1
	lsr.l	d6,d0
	bne.b	umega18
	bsr.b	umega9
UMEGA18	bcc.b	umega20
	moveq	#8,d1
	lsr.l	d6,d0
	bne.b	umega19
	bsr.b	umega9
UMEGA19	bcs.b	umega20
	moveq	#12,d1
UMEGA20	bsr.b	umega10
	subq.w	#1,d3
UMEGA21	move.b	-1(a2,d2.l),-(a2)
	cmp.l	a1,a2
	dbeq	d3,umega21
	cmp.w	d7,d3
	beq.w	umega1

UMEGA22	moveq	#-1,d0
UMEGAO	rts				;Get Out
;------------------------------------------------------------------------------
; Make Object Code
;

MECRUOB	move.l	UI_DecrunchAdr(a4),a3
	move.l	a3,UI_Temp(a4)
	move.l	a3,a6
	add.l	UI_DecrunchLen(a4),a6

	lea	$104(a3),a0
	move.l	a0,a1
	add.l	$ec(a3),a1
	move.l	a1,a5
	move.l	(a0),d0
	addq.l	#1,d0
	move.l	d0,d2
	moveq	#$14,d1
	add.l	$ec(a3),d1
	subq.l	#4,d1
	lsl.l	#2,d0
	sub.l	d0,d1
	moveq	#-$14,d3
	add.l	d1,d3
	lsl.l	#2,d0
	add.l	d0,d1
	bsr.w	mecro14
	move.l	d1,UI_DecrunchLen(a4)
	move.l	d1,d0
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	mecrob5
	move.l	d0,a2
	move.l	#$3f3,(a2)+
	clr.l	(a2)+
	move.l	d2,(a2)+
	clr.l	(a2)+
	move.l	$104(a3),(a2)+
	move.l	a2,a1
	move.l	d2,d5
	moveq	#0,d1
	lea	$108(a3),a0
MECROB1	subq.l	#1,d2
	beq.b	mecrob2
	move.l	4(a0),d0
	sub.l	(a0)+,d0
	add.l	d0,d1
	lsr.l	#2,d0
	move.l	d0,(a2)+
	bra.b	mecrob1

MECROB2	move.l	d3,d0
	sub.l	d1,d0
	lsr.l	#2,d0
	move.l	d0,(a2)+
	addq.l	#4,a0
	moveq	#0,d4
MECROB3	move.l	#$3e9,(a2)+
	move.l	(a1)+,d0
	move.l	d0,(a2)+
	beq.b	mecro4a
MECROB4	move.l	(a0)+,(a2)+
	subq.l	#1,d0
	bne.b	mecrob4
MECRO4a	bsr.b	mecrob7
	move.l	#$3f2,(a2)+
	addq.l	#4,d4
	subq.l	#1,d5
	bne.b	mecrob3

	moveq	#-1,d0
MECROB5	move.l	UI_Temp(a4),a1
	bsr.w	fremem			;Free Temp Buffer
	clr.l	UI_Temp(a4)
MECROB6	rts

MECROB7	move.l	a0,-(sp)
	move.l	a5,a0
MECROB8	move.l	(a0)+,d1
	move.l	(a0)+,d0
	beq.b	mecrob9
	cmp.l	#$3ec,d0
	beq.b	mecro10
MECROB9	move.l	(sp)+,a0
	rts

MECRO10	cmp.l	d1,d4
	bne.b	mecro13
	move.l	#$3ec,(a2)+
	move.l	(a0)+,d0
MECRO11	move.l	d0,(a2)+
	addq.l	#1,d0
MECRO12	move.l	(a0)+,(a2)+
	subq.l	#1,d0
	bne.b	mecro12
	move.l	(a0)+,d0
	bne.b	mecro11
	clr.l	(a2)+
	bra.b	mecrob9

MECRO13	move.l	(a0)+,d0
	beq.b	mecrob8
	lsl.l	#2,d0
	lea	4(a0,d0.l),a0
	bra.b	mecro13

MECRO14	addq.l	#4,a1
	move.l	(a1)+,d0
	beq.b	mecro15
	cmp.l	#$3ec,d0
	beq.b	mecro16
MECRO15	rts

MECRO16	move.l	(a1)+,d0
	beq.b	mecro14
	addq.l	#2,d0
	lsl.l	#2,d0
	add.l	d0,d1
	addq.l	#8,d1
	lea	-4(a1,d0.l),a1
	cmp.l	a6,a1
	blt.b	mecro16

	addq.l	#4,sp
	move.w	#UERR_Hunk,UI_ErrorNum(a4)
	clr.l	UI_Temp(a4)
	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
