;******************************************************************************
;* P-Compress                                                                 *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; Archive

PCOM	dc.w	pcomd-pcom,pcomt-pcom,CN_PCompress,typenum
	dc.b	CRU_Archive,PSF_RecogFunc
	dc.w	$34
	dc.l	0
	dc.w	_pcomt-pcom,_pcom-pcom,0

PCOMT	PSNAME	"P-Compress"

_PCOMT
	moveq	#0,d0			;Unknown
	cmp.l	#"PACK",(a0)
	bne.b	.out
	addq.l	#4,a0
	moveq	#4-1,d7
.LOOP	move.b	(a0)+,d1
	cmp.b	#$1f,d1
	bls.b	.out
	cmp.b	#$80,d1
	bhi.b	.out
	dbra	d7,.loop
	moveq	#-1,d0			;Ok
.OUT	rts


_PCOM
	move.w	#UERR_Open,UI_ErrorNum(a4)
	move.l	LIB_DosBase(a5),a6
	move.l	UI_FileName(a4),d1
	move.l	#1005,d2
	jsr	Open(a6)
	move.l	d0,UI_Temp2(a4)		;Open File
	beq.w	pcomo

	move.l	UI_Path(a4),d1
	moveq	#-2,d2
	jsr	Lock(a6)		;Lock Path
	move.l	d0,UI_Temp(a4)
	bne.b	pcom3

	lea	-256(sp),sp
	move.l	UI_Path(a4),a0
	move.l	sp,a1
PCOM1	move.b	(a0)+,(a1)+		;Copy Path
	bne.b	pcom1
	cmp.b	#"/",-2(a1)
	bne.b	pcom2
	clr.b	-2(a1)

PCOM2	move.w	#UERR_Directory,UI_ErrorNum(a4)
	move.l	sp,d1
	jsr	CreateDir(a6)
	lea	256(sp),sp
	tst.l	d0
	beq.w	pcomo1
	move.l	d0,d1
	jsr	Unlock(a6)

	move.l	UI_Path(a4),d1
	moveq	#-2,d2
	jsr	Lock(a6)		;Lock Path
	move.l	d0,UI_Temp(a4)
	beq.w	pcomo1

PCOM3	move.l	d0,d1
	jsr	CurrentDir(a6)
	move.l	d0,-(sp)

	moveq	#4,d7			;Number Of Bytes Taken From File

; Start To Unpack Archive

PCOM4	move.l	UI_Temp2(a4),d1
	move.l	d7,d2
	moveq	#-1,d3
	jsr	Seek(a6)		;Seek To The Start Of The Filename

	lea	-2*108(sp),sp
	move.l	UI_Temp2(a4),d1
	move.l	sp,d2
	move.l	#2*108,d3
	jsr	Read(a6)
	cmp.l	#-1,d0
	bne.b	pcom5
	lea	2*108(sp),sp
	bra.w	pcom12

PCOM5	tst.l	d0			;EOF
	bne.b	pcom5b
PCOM5a	lea	2*108(sp),sp
	moveq	#-1,d0
	bra.w	pcomo2

PCOM5b	lea	UI_LoadName(a4),a1
	move.l	sp,a0
	cmp.b	#10,(a0)
	beq.b	pcom5a
	moveq	#0,d1
PCOM6	move.b	(a0)+,d0
	addq.l	#1,d1
	cmp.b	#10,d0
	beq.b	pcom7
	move.b	d0,(a1)+		;Copy Filename
	bra.b	pcom6

PCOM7	clr.b	(a1)
	lea	2*108(sp),sp
	add.l	d1,d7

	move.l	UI_Temp2(a4),d1
	move.l	d7,d2
	moveq	#-1,d3
	jsr	Seek(a6)		;Seek To The Start Of Data

	subq.l	#4,sp
	move.l	UI_Temp2(a4),d1
	move.l	sp,d2
	moveq	#4,d3
	jsr	Read(a6)		;Read Size Of Data
	move.l	(sp)+,d6
	cmp.l	#-1,d0
	beq.w	pcom12
	addq.l	#4,d7

	move.l	d6,d0
	bsr.w	alcmem
	move.l	d0,UI_CrunchAdr(a4)
	beq.w	pcom13

	move.l	UI_Temp2(a4),d1
	move.l	d0,d2
	move.l	d6,d3
	jsr	Read(a6)		;Read Data
	cmp.l	#-1,d0
	beq.w	pcom12
	add.l	d0,d7
	move.l	d0,UI_DecrunchLen(a4)

	move.l	UI_CrunchAdr(a4),a0
	move.l	a0,UI_DecrunchAdr(a4)
	moveq	#0,d0
	cmp.w	#"LH",(a0)+		;Is Data Crunched?
	beq.b	pcom7a			;Yup!
	addq.l	#2,a0
	move.l	-4(a0),d0
	cmp.w	#"LH",(a0)+
	bne.b	pcom8
PCOM7a	move.l	d6,d1
	bsr.w	upcomp			;Decrunch File
	tst.w	d0
	bne.b	pcom8
	move.l	UI_CrunchAdr(a4),a1
	bsr.w	fremem			;Free Again If Some Error Occured
	clr.l	UI_CrunchAdr(a4)
	bra.w	pcom4

PCOM8	move.l	UI_LoadNamePoi(a4),a0
	move.l	a0,a1
PCOM8a	tst.b	(a0)+
	beq.b	pcom8c
	cmp.b	#":",-1(a0)
	bne.b	pcom8a
PCOM8b	move.b	(a0)+,(a1)+
	bne.b	pcom8b

PCOM8c	moveq	#0,d3
	move.l	UI_LoadNamePoi(a4),d1
	move.l	#1006,d2
	jsr	Open(a6)		;Open Write File
	move.l	d0,d4
	bne.b	pcom11

; Well, See If We Have To Make A Directory

	move.l	UI_LoadNamePoi(a4),a0
	move.l	a0,a1
PCOM9	tst.b	(a0)+			;Find End Of Filename
	bne.b	pcom9

	move.w	#UERR_Directory,UI_ErrorNum(a4)
PCOM10	cmp.l	a0,a1
	beq.w	pcomo2
	cmp.b	#"/",-(a0)
	bne.b	pcom10
	clr.b	(a0)
	move.l	a0,a2
	move.l	a1,d1
	move.l	a1,-(sp)
	jsr	CreateDir(a6)
	move.l	(sp)+,a1
	tst.l	d0
	bne.b	pcom10a
	move.b	#"/",(a2)
	move.l	a2,a0
	addq.w	#1,d3
	bra.b	pcom10

PCOM10a	move.l	d0,d1
	jsr	Unlock(a6)
	move.b	#"/",(a2)
	tst.w	d3
	bne.b	pcom8c

	move.w	#UERR_Open,UI_ErrorNum(a4)
	move.l	UI_LoadNamePoi(a4),d1
	move.l	#1006,d2
	jsr	Open(a6)		;Open File Again
	move.l	d0,d4
	beq.b	pcomo2

PCOM11	move.l	d4,d1
	move.l	UI_DecrunchAdr(a4),d2
	move.l	UI_DecrunchLen(a4),d3
	jsr	Write(a6)		;Write File

	move.l	d0,-(sp)
	move.l	d4,d1
	jsr	Close(a6)		;Close File
	cmp.l	#-1,(sp)+
	beq.b	pcom12

	move.l	UI_CrunchAdr(a4),a1
	bsr.w	fremem
	clr.l	UI_CrunchAdr(a4)

	movem.l	d0-d7/a0-a6,-(sp)
	bsr.w	scanjmp			;Scan File
	bsr.w	udel
	movem.l	(sp)+,d0-d7/a0-a6
	bra.w	pcom4

; Read/Write Error

PCOM12	move.w	#UERR_ReadWrite,UI_ErrorNum(a4)
	moveq	#0,d0
	bra.b	pcomo2

PCOM13	move.w	#UERR_Memory,UI_ErrorNum(a4)
	moveq	#0,d0

; Clean Up

PCOMO2	move.l	d0,d7
	move.l	(sp)+,d1
	jsr	CurrentDir(a6)

	move.l	UI_Temp(a4),d1
	jsr	UnLock(a6)
	clr.l	UI_Temp(a4)

PCOMO1	move.l	UI_Temp2(a4),d1
	jsr	Close(a6)
	clr.l	UI_Temp2(a4)

PCOMO	move.l	UI_CrunchAdr(a4),a1
	bsr.w	fremem
	clr.l	UI_CrunchAdr(a4)

	move.l	d7,d0
	rts
;------------------------------------------------------------------------------
; Data

PCOMD	dc.w	pack10-pcomd,pcomdt-pcomd,CN_PCompressD,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	$14
	dc.l	0
	dc.w	_pcomdt-pcomd,_pcomd-pcomd,0

PCOMDT	PSNAME	"P-Compress Data"

_PCOMDT
	moveq	#0,d0			;Unknown
	cmp.w	#"LH",(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PCOMD
	addq.l	#2,a0
	moveq	#0,d0
	move.l	UI_CrunchLenTemp(a4),d1
;------------------------------------------------------------------------------
; P-Compress Initializing Routine
;
; IN :	A0 = Start Of Packed Data
;	D0 = Special Version (0=No)
;	D1 = Crunched Size
;
; OUT:	D0 = Success (0=Error)
;

UPCOMP	move.l	d0,d2
	moveq	#1,d4
	move.l	a0,a1
	bsr.b	getlong
	tst.l	d2
	beq.b	upcomp0
	addq.l	#4,d0
UPCOMP0	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem			;Allocate Decrunched Data
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	upcompo

	move.l	d0,-(sp)		;Output Buffer
	move.l	a0,-(sp)		;Input Buffer
	bsr.b	upcom
	addq.l	#8,sp
	move.w	d0,d4

UPCOMPO	moveq	#-1,d0
	cmp.w	#1,d4
	bne.b	upcomo1
	move.w	#UERR_Memory,UI_ErrorNum(a4)
	moveq	#0,d0
	rts

UPCOMO1	cmp.w	#2,d4
	bne.b	upcomo2
	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	moveq	#0,d0
UPCOMO2	rts

GETLONG	move.b	(a1),d0
	lsl.l	#8,d0
	move.b	1(a1),d0
	lsl.l	#8,d0
	move.b	2(a1),d0
	lsl.l	#8,d0
	move.b	3(a1),d0
	rts
;------------------------------------------------------------------------------
; P-Compress Decruncher Routine
;
; IN :	D1 = Crunched Length
;

UPCOM	link	a5,#-$3c
	movem.l	d2-d7/a1-a6,-(sp)
	move.l	8(a5),a0		;Input Buffer
	move.l	12(a5),-$18(a5)		;Output Buffer
	move.l	12(a5),-$20(a5)
	move.l	a0,d0
	add.l	#12,d0
	move.l	d0,-$1c(a5)
	sub.l	#14,d1
	move.l	d1,-$10(a5)		;Crunched Size

	lea	8(a0),a1
	bsr.b	getlong
	move.l	d0,-$30(a5)		;CRC

	move.l	UI_DecrunchLen(a4),d0
	move.l	d0,-4(a5)		;Decrunched Size
	add.l	-$20(a5),d0
	move.l	d0,-$34(a5)

	moveq	#2,d4
	clr.l	-$28(a5)
	move.l	#$400,d0
	bsr.w	alcmem
	move.l	d0,-$2c(a5)
	beq.w	upcom4

	move.l	#$13ec,d0
	bsr.w	alcmem
	move.l	d0,-$14(a5)
	beq.b	upcom3

	move.l	#$1000,d0
	bsr.w	alcmem
	move.l	d0,-12(a5)
	beq.b	upcom2
	add.l	#$1000,d0
	move.l	d0,-$38(a5)

	clr.l	-8(a5)
	bsr.w	upcom37			;Calculate CRC-Table
	move.l	-$1c(a5),a0		;Start Address
	move.l	-$10(a5),d0		;Size
	bsr.w	upcom44			;Calculate CRC
	moveq	#2,d4
	cmp.l	-$30(a5),d0
	bne.b	upcom1
	bsr.b	upcom5			;Unpack Data
	move.l	a6,a5

UPCOM1	move.l	-12(a5),a1
	bsr.w	fremem

UPCOM2	move.l	-$14(a5),a1
	bsr.w	fremem

UPCOM3	move.l	-$2c(a5),a1
	bsr.w	fremem

UPCOM4	move.l	d4,d0
	movem.l	(sp)+,d2-d7/a1-a6
	unlk	a5
	rts

UPCOM5	move.l	sp,-$3c(a5)
	move.l	d2,-(sp)
	move.l	-$14(a5),a4
	move.l	a4,a0
	moveq	#0,d1
	lea	$11d4(a4),a1
	moveq	#2,d3
	move.w	#15,d4
	move.w	#1,d2
	bsr.w	upcom31
	move.w	#7,d3
	move.w	#7,d4
	moveq	#2,d2
	bsr.w	upcom31
	move.w	#11,d3
	moveq	#3,d4
	moveq	#3,d2
	bsr.w	upcom31
	move.w	#$17,d3
	moveq	#1,d4
	moveq	#4,d2
	bsr.w	upcom31
	move.w	#15,d3
	move.w	#0,d4
	moveq	#5,d2
	bsr.w	upcom31

	lea	$c60(a4),a1
	lea	$76e(a4),a2
	moveq	#-2,d0
	moveq	#0,d3
	moveq	#1,d1
	moveq	#2,d2
	move.w	#$13c,d7
UPCOM6	move.w	d1,(a0)+
	move.w	d0,(a1)+
	move.w	d3,-(a2)
	sub.w	d2,d0
	add.w	d2,d3
	dbra	d7,upcom6

	moveq	#0,d6
	move.l	#$27a,d7
	move.l	a4,a0
	lea	$27a(a4),a1
	lea	$eda(a4),a2
	lea	$76e(a4),a3
	moveq	#4,d4
	moveq	#2,d2
	move.w	#$13b,d1
UPCOM7	move.w	(a0)+,d0
	add.w	(a0)+,d0
	move.w	d0,(a1)+
	move.w	d6,(a2)+
	move.w	d7,(a3)+
	move.w	d7,(a3)+
	add.w	d4,d6
	add.w	d2,d7
	dbra	d1,upcom7
	move.w	d1,(a1)
	clr.w	$c5e(a4)

	move.l	a5,a6
	move.l	-12(a6),a0
	lea	$1000(a0),a0
	move.l	-12(a6),a1
	move.l	-$14(a6),a5
	lea	$76e(a5),a4
	lea	$c60(a5),a3

	move.l	(sp)+,d0
	beq.b	upcom7a
	move.l	d0,(a1)+
	addq.l	#4,-8(a6)
	subq.l	#4,-4(a6)

UPCOM7a	moveq	#1,d4
	moveq	#15,d5
	bsr.w	upcom33
	bra.b	upcom10

UPCOM8	neg.w	d7
	lsr.w	d4,d7
	sub.w	d4,d7
	cmp.l	-$38(a6),a1
	beq.w	upcom36
	move.b	d7,(a1)+
	addq.l	#1,-8(a6)
	cmp.l	#$1000,-8(a6)
	bne.b	upcom9
	bsr.w	upcom34
UPCOM9	subq.l	#1,-4(a6)
	tst.l	-4(a6)
	beq.w	upcom22
UPCOM10	move.w	$4f0(a3),d7
UPCOM11	add.w	d6,d6
	bcc.b	upcom13
	move.w	2(a3,d7.w),d7
	dbmi	d5,upcom11
	bmi.b	upcom14
UPCOM12	moveq	#15,d5
	bsr.w	upcom33
	bra.b	upcom11

UPCOM13	move.w	(a3,d7.w),d7
	dbmi	d5,upcom11
	bpl.b	upcom12
UPCOM14	dbra	d5,upcom15
	bsr.w	upcom33
	moveq	#15,d5
UPCOM15	cmp.w	#$8000,$4f0(a5)
	beq.b	upcom21
	move.w	(a4,d7.w),d0
UPCOM16	lea	(a5,d0.w),a2
	move.w	(a2),d1
	add.w	d4,d1
	move.w	d1,(a2)+
	cmp.w	(a2)+,d1
	bls.b	upcom20
UPCOM17	cmp.w	(a2)+,d1
	bhi.b	upcom17
	subq.l	#4,a2
	move.l	a2,d2
	sub.l	a5,d2
	move.w	(a2),(a5,d0.w)
	move.w	d1,(a2)
	move.w	(a3,d0.w),d1
	bmi.b	upcom18
	move.w	d2,2(a4,d1.w)
UPCOM18	move.w	d2,(a4,d1.w)
	move.w	(a3,d2.w),d3
	bmi.b	upcom19
	move.w	d0,2(a4,d3.w)
UPCOM19	move.w	d1,(a3,d2.w)
	move.w	d0,(a4,d3.w)
	move.w	d3,(a3,d0.w)
	move.w	(a4,d2.w),d0
	bne.b	upcom16
	bra.b	upcom21

UPCOM20	move.w	(a4,d0.w),d0
	bne.b	upcom16
UPCOM21	cmp.w	#$fe00,d7
	bge.w	upcom8
	cmp.w	#$fd86,d7
	bgt.b	upcom23
UPCOM22	bsr.w	upcom34
	moveq	#0,d4
	rts

UPCOM23	rol.w	#8,d6
	subq.w	#7,d5
	bcc.b	upcom24
	moveq	#0,d3
	move.l	d6,-(sp)
	bsr.w	upcom33
	move.w	d6,d3
	move.l	(sp)+,d6
	swap	d3
	neg.w	d5
	rol.l	d5,d3
	move.w	d3,d1
	or.b	d6,d1
	swap	d3
	move.w	d3,d6
	neg.w	d5
	moveq	#15,d2
	add.w	d2,d5
	bra.b	upcom25

UPCOM24	moveq	#0,d1
	move.b	d6,d1
	clr.b	d6
	dbra	d5,upcom25
	bsr.w	upcom33
	moveq	#15,d5
UPCOM25	move.w	d1,d3
	add.w	d3,d3
	pea	(a5)
	move.l	-$14(a6),a5
	lea	$1194(a5),a2
	move.l	(sp)+,a5
	move.w	(a2,d3.w),d3
	clr.w	d2
	move.b	d3,d2
	clr.b	d3
	lsr.w	#2,d3
UPCOM26	add.w	d6,d6
	addx.w	d1,d1
	dbra	d5,upcom27
	moveq	#15,d5
	bsr.b	upcom33
UPCOM27	dbra	d2,upcom26

	and.w	#$3f,d1
	or.w	d3,d1
	move.l	a1,d3
	sub.l	-12(a6),d3
	add.l	#$1000,d3
	sub.w	d1,d3
	and.l	#$fff,d3
	add.l	-12(a6),d3
	move.l	d3,a2
	clr.l	d3
	move.w	d7,d3
	add.l	#$202,d3
	beq.w	upcom10
	neg.w	d3
	ror.w	#1,d3
UPCOM28	move.b	(a2)+,(a1)+
	cmp.l	a2,a0
	bgt.b	upcom29
	move.l	-12(a6),a2
UPCOM29	addq.l	#1,-8(a6)
	cmp.l	#$1000,-8(a6)
	bne.b	upcom30
	bsr.b	upcom34
UPCOM30	subq.l	#1,-4(a6)
	tst.l	-4(a6)
	beq.w	upcom22
	dbra	d3,upcom28
	bra.w	upcom10

UPCOM31	addq.w	#1,d1
	move.w	d4,d0
UPCOM32	move.b	d1,(a1)+
	move.b	d2,(a1)+
	dbra	d0,upcom32
	dbra	d3,upcom31
	rts

UPCOM33	pea	(a0)
	move.l	-$1c(a6),a0
	add.l	-$28(a6),a0
	addq.l	#2,-$28(a6)
	move.b	(a0),d6
	lsl.w	#8,d6
	move.b	1(a0),d6
	move.l	(sp)+,a0
	rts

UPCOM34	pea	(a0)
	move.l	-8(a6),d0
	sub.l	d0,a1
	subq.l	#1,d0
	move.l	-$20(a6),a0
UPCOM35	cmp.l	-$34(a6),a0
	beq.b	upcom36
	move.b	(a1)+,(a0)+
	dbra	d0,upcom35
	move.l	a0,-$20(a6)
	sub.l	-8(a6),a1
	clr.l	-8(a6)
	move.l	(sp)+,a0
	rts

UPCOM36	move.l	-$3c(a6),sp
	moveq	#2,d4
	rts

UPCOM37	movem.l	d4-d7/a3,-(sp)
	move.l	-$2c(a5),a3
	moveq	#0,d6
UPCOM38	cmp.l	#$100,d6
	bge.b	upcom43
	moveq	#0,d7
	move.l	d6,d5
	add.l	d5,d5
	moveq	#8,d4
UPCOM39	tst.l	d4
	ble.b	upcom42
	asr.l	#1,d5
	move.l	d5,d0
	eor.l	d7,d0
	btst	#0,d0
	beq.b	upcom40
	move.l	d7,d0
	lsr.l	#1,d0
	move.l	d0,d7
	eor.l	#$edb88320,d7
	bra.b	upcom41

UPCOM40	lsr.l	#1,d7
UPCOM41	subq.l	#1,d4
	bra.b	upcom39

UPCOM42	move.l	d6,d0
	asl.l	#2,d0
	move.l	d7,(a3,d0.l)
	addq.w	#1,d6
	bra.b	upcom38

UPCOM43	movem.l	(sp)+,d4-d7/a3
	rts

UPCOM44	movem.l	d2/d4-d7/a2,-(sp)
	move.l	-$2c(a5),a2
	moveq	#0,d5
	moveq	#0,d7
UPCOM45	cmp.l	d0,d7
	bge.b	upcom46
	moveq	#0,d2
	move.b	(a0,d7.l),d2
	eor.l	d5,d2
	moveq	#0,d1
	not.b	d1
	and.l	d1,d2
	asl.l	#2,d2
	move.l	d5,d6
	lsr.l	#8,d6
	and.l	#$00ffffff,d6
	move.l	(a2,d2.l),d4
	eor.l	d6,d4
	move.l	d4,d5
	addq.l	#1,d7
	bra.b	upcom45

UPCOM46	move.l	d5,d0
	movem.l	(sp)+,d2/d4-d7/a2
	rts
;------------------------------------------------------------------------------
