;******************************************************************************
;* PowerPacker                                                                *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 2.x

PP2x	dc.w	pp23m-pp2x,pp2xt-pp2x,CN_PP2x,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$240
	dc.l	0
	dc.w	_pp2xt-pp2x,_pp2x-pp2x,0

PP2xT	PSNAME	"PowerPacker 2.x"

_PP2xT
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$230(a0)
	beq.b	.ok
	cmp.l	#$3ea,$234(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#$45fa0136,$44(a0)
	bne.b	.out
	cmp.l	#$61000132,$4c(a0)
	bne.b	.out
	cmp.l	#$48808216,$22c(a0)
	bne.b	.out
	cmp.w	#$6620,$19e(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP2x
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$228(a0),UI_Temp1(a4)
	lea	$238(a0),a1
	moveq	#0,d7			;Type #1
	bra.w	ppdata
;------------------------------------------------------------------------------
; 2.3 Master

PP23M	dc.w	pp30-pp23m,pp23mt-pp23m,CN_PP23Master,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$240
	dc.l	0
	dc.w	_pp23mt-pp23m,_pp23m-pp23m,0

PP23MT	PSNAME	"PowerPacker 2.3 Master"

_PP23MT
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$230(a0)
	beq.b	.ok
	cmp.l	#$3ea,$234(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#$45fa0136,$44(a0)
	bne.b	.out
	cmp.l	#$61000132,$4c(a0)
	bne.b	.out
	cmp.w	#$6720,$19e(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP23M
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$228(a0),UI_Temp1(a4)
	lea	$238(a0),a1
	moveq	#1,d7			;Type #2
	bra.w	ppdata
;------------------------------------------------------------------------------
; 3.0

PP30	dc.w	pp30e-pp30,pp30t-pp30,CN_PP30,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$25c
	dc.l	0
	dc.w	_pp30t-pp30,_pp30-pp30,0

PP30T	PSNAME	"PowerPacker 3.0"

_PP30T
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$24c(a0)
	beq.b	.ok
	cmp.l	#$3ea,$250(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#$487a0178,$24(a0)
	bne.b	.out
	cmp.l	#$61000156,$48(a0)
	bne.b	.out
	cmp.w	#$653e,$1c0(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP30
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$240(a0),UI_Temp1(a4)
	lea	$254(a0),a1
	moveq	#0,d7			;Type #1
	bra.w	ppdata
;------------------------------------------------------------------------------
; 3.0 Encrypted

PP30E	dc.w	pp30o-pp30e,pp30et-pp30e,CN_PP30E,typenum
	dc.b	CRU_Object,PSF_RecogFunc!PSF_Encrypted
	dc.w	$318
	dc.l	0
	dc.w	_pp30et-pp30e,_pp30e-pp30e,0

PP30ET	PSNAME	"PowerPacker 3.0 Encrypted"

_PP30ET
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$308(a0)
	beq.b	.ok
	cmp.l	#$3ea,$30c(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#$487a01f6,$24(a0)
	bne.b	.out
	cmp.l	#$61000156,$c6(a0)
	bne.b	.out
	cmp.w	#$653e,$23c(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP30E
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$2fe(a0),UI_Temp1(a4)
	move.w	$8e(a0),UI_Temp2(a4)
	move.w	#$310,d0
	bsr.w	pppass			;Test Password
	beq.b	.out
	lea	$310(a0),a1
	moveq	#0,d7			;Type #1
	bsr.w	ppdata
.OUT	rts
;------------------------------------------------------------------------------
; 3.0 Overlayed

PP30O	dc.w	pp30m-pp30o,pp30ot-pp30o,CN_PP30Ov,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$27c
	dc.l	0
	dc.w	_pp30ot-pp30o,_pp30o-pp30o,0

PP30OT	PSNAME	"PowerPacker 3.0 Overlayed"

_PP30OT
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$260(a0)
	bne.b	.out
	cmp.l	#$487a0176,$3c(a0)
	bne.b	.out
	cmp.l	#$61000154,$60(a0)
	bne.b	.out
	cmp.w	#$abcd,$2a(a0)
	bne.b	.out
	cmp.w	#$653e,$1d6(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP30O
	move.l	$256(a0),UI_Temp1(a4)
	lea	$268(a0),a1
	moveq	#0,d7			;Type #1
	bra.w	ppover
;------------------------------------------------------------------------------
; 3.0 Master

PP30M	dc.w	pp30me-pp30m,pp30mt-pp30m,CN_PP30Master,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$25c
	dc.l	0
	dc.w	_pp30mt-pp30m,_pp30m-pp30m,0

PP30MT	PSNAME	"PowerPacker 3.0 Master"

_PP30MT
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$24c(a0)
	beq.b	.ok
	cmp.l	#$3ea,$250(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#$487a0178,$24(a0)
	bne.b	.out
	cmp.l	#$61000156,$48(a0)
	bne.b	.out
	cmp.w	#$643e,$1c0(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP30M
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$240(a0),UI_Temp1(a4)
	lea	$254(a0),a1
	moveq	#1,d7			;Type #2
	bra.w	ppdata
;------------------------------------------------------------------------------
; 3.0 Master Encrypted

PP30ME	dc.w	pp30mo-pp30me,pp30met-pp30me,CN_PP30MasterE,typenum
	dc.b	CRU_Object,PSF_RecogFunc!PSF_Encrypted
	dc.w	$318
	dc.l	0
	dc.w	_pp30met-pp30me,_pp30me-pp30me,0

PP30MET	PSNAME	"PowerPacker 3.0 Master Encrypted"

_PP30MET
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$308(a0)
	beq.b	.ok
	cmp.l	#$3ea,$30c(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#$487a01f6,$24(a0)
	bne.b	.out
	cmp.l	#$61000156,$c6(a0)
	bne.b	.out
	cmp.w	#$643e,$23c(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP30ME
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$2fe(a0),UI_Temp1(a4)
	move.w	$8e(a0),UI_Temp2(a4)
	move.w	#$310,d0
	bsr.w	pppass			;Test Password
	beq.b	.out
	lea	$310(a0),a1
	moveq	#1,d7			;Type #2
	bsr.w	ppdata
.OUT	rts
;------------------------------------------------------------------------------
; 3.0 Master Overlayed

PP30MO	dc.w	pp40-pp30mo,pp30mot-pp30mo,CN_PP30MasterOv,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$27c
	dc.l	0
	dc.w	_pp30mot-pp30mo,_pp30mo-pp30mo,0

PP30MOT	PSNAME	"PowerPacker 3.0 Master Overlayed"

_PP30MOT
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$260(a0)
	bne.b	.out
	cmp.l	#$487a0176,$3c(a0)
	bne.b	.out
	cmp.l	#$61000154,$60(a0)
	bne.b	.out
	cmp.w	#$abcd,$2a(a0)
	bne.b	.out
	cmp.w	#$643e,$1d6(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP30MO
	move.l	$256(a0),UI_Temp1(a4)
	lea	$268(a0),a1
	moveq	#1,d7			;Type #2
	bra.w	ppover
;------------------------------------------------------------------------------
; 4.0

PP40	dc.w	pp40e-pp40,pp40t-pp40,CN_PP40,typenum
	dc.b	CRU_Object,0
	dc.w	$2b0
	dc.l	0
	dc.w	pp40d-pp40,_pp40-pp40,0

PP40T	PSNAME	"PowerPacker 4.0"

PP40D	dc.w	$dc,12-1
	dc.l	$41f22800,$22039288,$e48922da,$538066fa
	dc.l	$24570c42,$1000651c,$24d85381,$66fa2457
	dc.l	$20039682,$5e830203,$00f82243,$90834eae

_PP40
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$290(a0),UI_Temp1(a4)
	lea	$2a8(a0),a1
	moveq	#0,d7			;Type #1
	bsr.w	ppdata
	tst.w	d0
	beq.b	.out
	moveq	#0,d7
	bsr.w	conlen			;Count New Length
	bsr.w	copnew			;Copy New Object File
	move.l	UI_Temp(a4),a1
	bsr.w	fremem			;Free The File Again
	clr.l	UI_Temp(a4)
.OUT	rts
;------------------------------------------------------------------------------
; 4.0 Encrypted

PP40E	dc.w	pp40o-pp40e,pp40et-pp40e,CN_PP40E,typenum
	dc.b	CRU_Object,PSF_Encrypted
	dc.w	$36c
	dc.l	0
	dc.w	pp40ed-pp40e,_pp40e-pp40e,0

PP40ET	PSNAME	"PowerPacker 4.0 Encrypted"

PP40ED	dc.w	$dc,12-1
	dc.l	$00fc2440,$281a0c44,$03ec6620,$3546fffc
	dc.l	$524a200a,$08800000,$2440301a,$67dc5c4a
	dc.l	$534067ec,$4a1a66f8,$564a60f4,$0c4403f2

_PP40E
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$34e(a0),UI_Temp1(a4)
	move.w	$8e(a0),UI_Temp2(a4)
	move.w	#$364,d0
	bsr.w	pppass			;Test Password
	beq.b	.out
	lea	$364(a0),a1
	moveq	#0,d7			;Type #1
	bsr.w	ppdata
	tst.w	d0
	beq.b	.out
	moveq	#0,d7
	bsr.w	conlen			;Count New Length
	bsr.w	copnew			;Copy New Object File
	move.l	UI_Temp(a4),a1
	bsr.w	fremem			;Free The File Again
	clr.l	UI_Temp(a4)
.OUT	rts
;------------------------------------------------------------------------------
; 4.0 Overlayed

PP40O	dc.w	pp40l-pp40o,pp40ot-pp40o,CN_PP40Ov,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$2d4
	dc.l	0
	dc.w	_pp40ot-pp40o,_pp40o-pp40o,0

PP40OT	PSNAME	"PowerPacker 4.0 Overlayed"

_PP40OT
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$2b8(a0)
	bne.b	.out
	cmp.l	#$487a01c8,$3c(a0)
	bne.b	.out
	cmp.l	#$610001a6,$60(a0)
	bne.b	.out
	cmp.w	#$abcd,$2a(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP40O
	move.l	$2a8(a0),UI_Temp1(a4)
	lea	$2c0(a0),a1
	moveq	#0,d7			;Type #1
	bsr.w	ppover
	tst.l	d0
	beq.b	.out
	moveq	#0,d7
	bsr.w	conlen			;Count New Length
	bsr.w	copnew			;Copy New Object File
	move.l	UI_Temp(a4),a1
	bsr.w	fremem			;Free The File Again
	clr.l	UI_Temp(a4)
.OUT	rts
;------------------------------------------------------------------------------
; 4.0 Library

PP40L	dc.w	pp40le-pp40l,pp40lt-pp40l,CN_PP40Lib,typenum
	dc.b	CRU_Object,0
	dc.w	$b4
	dc.l	0
	dc.w	pp40ld-pp40l,_pp40l-pp40l,0

PP40LT	PSNAME	"PowerPacker 4.0 Library"

PP40LD	dc.w	$2c,12-1
	dc.l	$4eaeffb2,$6024286e,$01144aac,$00ac661a
	dc.l	$47ec005c,$204b4eae,$fe80204b,$4eaefe8c
	dc.l	$522e0127,$22404eae,$fe864cdf,$7fff4e75

_PP40L
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$94(a0),UI_Temp1(a4)
	lea	$ac(a0),a1
	moveq	#0,d7			;Type #1
	bsr.w	ppdata
	tst.w	d0
	beq.b	.out
	moveq	#0,d7
	bsr.w	conlen			;Count New Length
	bsr.w	copnew			;Copy New Object File
	move.l	UI_Temp(a4),a1
	bsr.w	fremem			;Free The File Again
	clr.l	UI_Temp(a4)
.OUT	rts
;------------------------------------------------------------------------------
; 4.0 Library Encrypted

PP40LE	dc.w	pp40lo-pp40le,pp40let-pp40le,CN_PP40LibE,typenum
	dc.b	CRU_Object,PSF_Encrypted
	dc.w	$b8
	dc.l	0
	dc.w	pp40led-pp40le,_pp40le-pp40le,0

PP40LET	PSNAME	"PowerPacker 4.0 Library Encrypted"

PP40LED	dc.w	$2c,12-1
	dc.l	$45fa0046,$4eaeffac,$6024286e,$01144aac
	dc.l	$00ac661a,$47ec005c,$204b4eae,$fe80204b
	dc.l	$4eaefe8c,$522e0127,$22404eae,$fe864cdf

_PP40LE
	subq.l	#4,UI_CrunchLenTemp(a4)
	move.l	$98(a0),UI_Temp1(a4)
	move.w	$4a(a0),UI_Temp2(a4)
	move.w	#$b0,d0
	bsr.w	pppass			;Test Password
	beq.b	.out
	lea	$b0(a0),a1
	moveq	#0,d7			;Type #1
	bsr.w	ppdata
	tst.w	d0
	beq.b	.out
	moveq	#0,d7
	bsr.w	conlen			;Count New Length
	bsr.w	copnew			;Copy New Object File
	move.l	UI_Temp(a4),a1
	bsr.w	fremem			;Free The File Again
	clr.l	UI_Temp(a4)
.OUT	rts
;------------------------------------------------------------------------------
; 4.0 Library Overlayed

PP40LO	dc.w	ppd-pp40lo,pp40lot-pp40lo,CN_PP40LibOv,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$cc
	dc.l	0
	dc.w	_pp40lot-pp40lo,_pp40lo-pp40lo,0

PP40LOT	PSNAME	"PowerPacker 4.0 Library Overlayed"

_PP40LOT
	moveq	#0,d0			;Unknown
	cmp.l	#$3ea,$bc(a0)
	bne.b	.out
	cmp.l	#$487a0058,$3c(a0)
	bne.b	.out
	cmp.l	#$4eaeffa6,$68(a0)
	bne.b	.out
	cmp.w	#$abcd,$2a(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_PP40LO
	move.l	$ac(a0),UI_Temp1(a4)
	lea	$c4(a0),a1
	moveq	#0,d7			;Type #1
	bsr.w	ppover
	tst.l	d0
	beq.b	.out
	moveq	#0,d7
	bsr.w	conlen			;Count New Length
	bsr.w	copnew			;Copy New Object File
	move.l	UI_Temp(a4),a1
	bsr.w	fremem			;Free The File Again
	clr.l	UI_Temp(a4)
.OUT	rts
;------------------------------------------------------------------------------
; Data

PPD	dc.w	pped-ppd,ppdt-ppd,CN_PPData,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	16
	dc.l	"PP20"
	dc.w	0,_ppd-ppd,0

PPDT	PSNAME	"PowerPacker Data"

_PPD
	move.l	4(a0),UI_Temp1(a4)
	lea	8(a0),a1
	move.l	a1,-(sp)
	moveq	#0,d7			;Type #1
	bsr.w	ppdata
	tst.w	d0
	bne.b	.ok
	move.l	UI_DecrunchAdr(a4),a1
	bsr.w	fremem
	clr.l	UI_DecrunchAdr(a4)
	clr.l	UI_DecrunchLen(a4)
	move.l	(sp),a1
	moveq	#1,d7			;Type #2
	bsr.w	ppdata
.OK	addq.l	#4,sp
	rts
;------------------------------------------------------------------------------
; Encrypted Data

PPED	dc.w	ppls-pped,ppedt-pped,CN_PPData,typenum
	dc.b	CRU_Data,PSF_Data!PSF_Encrypted
	dc.w	18
	dc.l	"PX20"
	dc.w	0,_pped-pped,0

PPEDT	PSNAME	"PowerPacker Encrypted Data"

_PPED
	move.l	6(a0),UI_Temp1(a4)
	move.w	4(a0),UI_Temp2(a4)
	moveq	#10,d0
	bsr.w	pppass			;Test Password
	beq.b	.out
	lea	10(a0),a1
	move.l	a1,-(sp)
	moveq	#0,d7			;Type #1
	bsr.w	ppdata
	tst.w	d0
	bne.b	.ok
	move.l	UI_DecrunchAdr(a4),a1
	bsr.w	fremem
	clr.l	UI_DecrunchAdr(a4)
	clr.l	UI_DecrunchLen(a4)
	move.l	(sp),a1
	moveq	#1,d7			;Type #2
	bsr.w	ppdata
.OK	addq.l	#4,sp
.OUT	rts
;------------------------------------------------------------------------------
; LoadSeg

PPLS	dc.w	rnc1-ppls,pplst-ppls,CN_PPLoadSeg,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	20
	dc.l	"PPLS"
	dc.w	0,_ppls-ppls,0

PPLST	PSNAME	"PowerPacker LoadSeg"

_PPLS
	move.l	8(a0),UI_Temp1(a4)
	lea	12(a0),a1
	moveq	#0,d7			;Type #1
	bsr.b	ppdata
	tst.w	d0
	beq.b	.out
	moveq	#0,d7
	bsr.w	conlen			;Count New Length
	bsr.w	copnew			;Copy New Object File
	move.l	UI_Temp(a4),a1
	bsr.w	fremem			;Free The File Again
	clr.l	UI_Temp(a4)
.OUT	rts
;------------------------------------------------------------------------------
; PowerPacker Data Decruncher
;
; IN :	A1 = Start Of Crunched Data
;	D7 = Type
;
; OUT:	D0 = Success (0=Error)
;	D1 = Unpacked Length
;

PPDATA	move.l	a1,-(sp)
	move.l	UI_CrunchAdrTemp(a4),a0
	add.l	UI_CrunchLenTemp(a4),a0
	move.l	a0,a1

	move.l	-(a0),d0
	lsr.l	#8,d0
	move.l	d0,-(sp)		;Length Of Decrunched Data

	add.l	d0,UI_DecrunchLen(a4)
	move.l	UI_DecrunchLen(a4),d0
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	ppdatao

	move.l	a1,a0			;End Of Crunched Data
	move.l	d0,a3			;Start Of Decrunched Data
	lea	UI_Temp1(a4),a5		;Crunch Bit
	moveq	#-1,d3			;Safety Compare Number

	tst.w	d7
	bne.b	ppdata1
	bsr.b	ppdat1
	bra.b	ppdata2

PPDATA1	bsr.w	ppdat2

PPDATA2	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	moveq	#0,d0
	sub.l	4(sp),a0
	cmp.l	d0,a0
	bne.b	ppdatao
	tst.w	d2
	bne.b	ppdatao
	move.l	(sp),d1
	moveq	#-1,d0
PPDATAO	addq.l	#8,sp
	rts

; Unpack Type #1

PPDAT1	moveq	#7,d7
	moveq	#3,d6
	moveq	#1,d5
	moveq	#1,d4
	move.l	a3,a2
	move.l	-(a0),d1
	tst.b	d1
	beq.b	ppdat1a
	bsr.b	ppdat1l
	subq.l	#1,d1
	lsr.l	d1,d5
PPDAT1a	lsr.l	#8,d1
	add.l	d1,a3

PPDAT1b	bsr.b	ppdat1l
	bcs.b	ppdat1e
	moveq	#0,d2
PPDAT1c	moveq	#1,d0
	bsr.b	ppdat1o
	add.w	d1,d2
	cmp.w	d6,d1
	beq.b	ppdat1c
PPDAT1d	moveq	#7,d0
	bsr.b	ppdat1o
	move.b	d1,-(a3)
	cmp.l	a3,a2
	dbeq	d2,ppdat1d
	cmp.w	d3,d2
	bne.b	ppdat1k

PPDAT1e	moveq	#1,d0
	bsr.b	ppdat1o
	moveq	#0,d0
	move.b	(a5,d1.w),d0
	move.w	d1,d2
	cmp.w	d6,d2
	bne.b	ppdat1h
	bsr.b	ppdat1l
	bcs.b	ppdat1f
	moveq	#7,d0
PPDAT1f	bsr.b	ppdat1n
	move.l	d1,a1

PPDAT1g	moveq	#2,d0
	bsr.b	ppdat1o
	add.w	d1,d2
	cmp.w	d7,d1
	beq.b	ppdat1g
	move.l	a1,d1
	bra.b	ppdat1i

PPDAT1h	bsr.b	ppdat1n
PPDAT1i	addq.w	#1,d2
PPDAT1j	move.b	(a3,d1.w),-(a3)
	cmp.l	a3,a2
	dbeq	d2,ppdat1j
	cmp.w	d3,d2
	beq.b	ppdat1b
PPDAT1k	rts

PPDAT1l	lsr.l	d4,d5
	bne.b	ppdat1m
	move.l	-(a0),d5
	roxr.l	d4,d5
PPDAT1m	rts

PPDAT1n	subq.w	#1,d0
PPDAT1o	moveq	#0,d1
PPDAT1p	lsr.l	d4,d5
	bne.b	ppdat1q
	move.l	-(a0),d5
	roxr.l	d4,d5
PPDAT1q	roxl.l	d4,d1
	dbra	d0,ppdat1p
	rts

; Unpack Type #2

PPDAT2	moveq	#7,d7
	moveq	#3,d6
	moveq	#1,d5
	moveq	#1,d4
	move.l	a3,a2
	move.l	-(a0),d1
	tst.b	d1
	beq.b	ppdat2a
	bsr.b	ppdat1l
	subq.l	#1,d1
	lsr.l	d1,d5
PPDAT2a	lsr.l	#8,d1
	add.l	d1,a3

PPDAT2b	bsr.b	ppdat1l
	bcc.b	ppdat2e
	moveq	#0,d2
PPDAT2c	moveq	#1,d0
	bsr.b	ppdat1o
	add.w	d1,d2
	cmp.w	d6,d1
	beq.b	ppdat2c
PPDAT2d	moveq	#7,d0
	bsr.b	ppdat1o
	move.b	d1,-(a3)
	cmp.l	a3,a2
	dbeq	d2,ppdat2d
	cmp.w	d3,d2
	bne.b	ppdat2k

PPDAT2e	moveq	#1,d0
	bsr.b	ppdat1o
	moveq	#0,d0
	move.b	(a5,d1.w),d0
	move.w	d1,d2
	cmp.w	d6,d2
	bne.b	ppdat2h
	bsr.b	ppdat1l
	bcs.b	ppdat2f
	moveq	#7,d0
PPDAT2f	bsr.b	ppdat1n
	move.l	d1,a1
PPDAT2g	moveq	#2,d0
	bsr.b	ppdat1o
	add.w	d1,d2
	cmp.w	d7,d1
	beq.b	ppdat2g
	move.l	a1,d1
	bra.b	ppdat2i

PPDAT2h	bsr.b	ppdat1n
PPDAT2i	addq.w	#1,d2
PPDAT2j	move.b	(a3,d1.w),-(a3)
	cmp.l	a3,a2
	dbeq	d2,ppdat2j
	cmp.w	d3,d2
	beq.b	ppdat2b
PPDAT2k	rts
;------------------------------------------------------------------------------
; Unpack Overlayed Files
;
; IN :	A1 = Start Of Crunched Data
;	D7 = Type
;
; OUT:	D0 = Number Of Overlay Bytes (0=Error)
;

PPOVER	move.l	a1,a5
	move.l	UI_CrunchLenTemp(a4),-(sp)
	move.l	UI_CrunchAdrTemp(a4),a1
	move.l	16(a1),d0
	sub.l	12(a1),d0
	lsl.l	#2,d0
	lea	32(a1,d0.l),a1
	move.l	-4(a1),d0
	lsl.l	#2,d0
	lea	12(a1,d0.l),a1
	move.l	-4(a1),d0
	lsl.l	#2,d0
	add.l	d0,a1

	move.l	a1,a2
	sub.l	UI_CrunchAdrTemp(a4),a1	;Crunched Length
	move.l	a1,d0
	sub.l	UI_CrunchLenTemp(a4),d0
	neg.l	d0
	subq.l	#4,d0			;Overlay Length
	move.l	d0,d2
	move.l	d0,UI_DecrunchLen(a4)
	move.l	a1,UI_CrunchLenTemp(a4)

	movem.l	d2-d7/a0-a6,-(sp)
	move.l	a5,a1
	bsr.w	ppdata			;Unpack File
	movem.l	(sp)+,d2-d7/a0-a6
	move.l	(sp)+,UI_CrunchLenTemp(a4)
	tst.w	d0
	beq.b	ppovero

	move.l	d2,-(sp)
	move.l	d2,d0			;Number Of Bytes (Overlay Length)
	addq.l	#4,a2
	move.l	UI_DecrunchAdr(a4),a0
	add.l	d1,a0

	move.l	(a2)+,(a0)+		;Copy Hunk
	move.l	(a2)+,(a0)+		;Copy Length
	move.l	(a2)+,d2
	move.l	d2,(a0)+		;Copy Number Of Hunks
	sub.l	#3*4,d0
	beq.b	ppover5

PPOVER3	move.l	(a2)+,d3
	sub.l	a1,d3
	add.l	d1,d3
	subq.l	#4,d3
	move.l	d3,(a0)+		;New Hunk Offset
	move.l	(a2)+,(a0)+
	subq.l	#2*4,d0
	beq.b	ppover5
	subq.l	#1,d2
	bne.b	ppover3

PPOVER4	move.l	(a2)+,(a0)+		;Copy Overlay
	subq.l	#4,d0
	bne.b	ppover4

PPOVER5	move.l	(sp)+,d0		;Number Of Overlay Bytes
PPOVERO	rts
;------------------------------------------------------------------------------
; Test Password
;
; IN :	D0 = Data Start Offset
;
; OUT:	D0 = Success (0=Error)
;

PPPASS	move.w	d0,-(sp)
	lea	UI_PasswordStr(a4),a1
	moveq	#0,d3
	moveq	#0,d4
	moveq	#0,d5
PPPASS1	move.b	(a1)+,d5
	beq.b	pppass2
	ror.w	d5,d3
	add.w	d5,d3
	rol.l	#1,d4
	add.l	d5,d4
	swap	d4
	bra.b	pppass1

PPPASS2	cmp.w	UI_Temp2(a4),d3
	beq.b	pppass3
	moveq	#0,d0
	move.w	#UERR_Password,UI_ErrorNum(a4)
	bra.b	pppasso

; Decrypt Data

PPPASS3	moveq	#0,d0
	move.w	(sp),d0
	lea	(a0,d0.w),a1
	move.l	UI_CrunchLenTemp(a4),d1
	sub.l	d0,d1
	subq.l	#4,d1
	lsr.l	#1,d1
PPPASS4	swap	d4
	eor.w	d4,(a1)+
	subq.l	#1,d1
	bne.b	pppass4
	moveq	#-1,d0

PPPASSO	addq.l	#2,sp
	tst.l	d0
	rts
;------------------------------------------------------------------------------
; Count New Length
;
; IN :	D7 = Start Length
;
; OUT:	D0 = Length
;

CONLEN	move.l	UI_DecrunchAdr(a4),a0
	move.l	UI_DecrunchLen(a4),d2
	add.l	a0,d2
	move.l	d7,d0
CONLEN1	move.l	(a0)+,d1
	and.l	#$0000ffff,d1

	cmp.w	#$03f3,d1		;Hunk_Header
	bne.b	conlen3
	lea	16(a0),a0
	add.l	#20,d0
	move.l	-4(a0),d1
	sub.l	-8(a0),d1
	addq.l	#1,d1
	lsl.l	#2,d1
	add.l	d1,d0
	add.l	d1,a0
	bra.b	conlen1

CONLEN3	cmp.w	#$03e9,d1		;Hunk_Code
	beq.b	conlen4
	cmp.w	#$03ea,d1		;Hunk_Data
	bne.b	conlen5
CONLEN4	addq.l	#8,d0
	move.l	(a0)+,d1
	lsl.l	#2,d1
	add.l	d1,d0
	add.l	d1,a0
	bra.b	conlen1

CONLEN5	cmp.w	#$03eb,d1		;Hunk_BSS
	bne.b	conle5a
	addq.l	#4,a0
	addq.l	#8,d0
	bra.b	conlen1

CONLE5a	cmp.w	#$03f2,d1		;Hunk_End
	beq.b	conle5b
	cmp.w	#$03f6,d1		;Hunk_Break
	bne.b	conlen6
CONLE5b	addq.l	#4,d0
	cmp.l	d2,a0
	bne.b	conlen1
	rts

CONLEN6	cmp.w	#$03ec,d1		;Hunk_Reloc32
	bne.b	conle11
	addq.l	#4,d0
CONLEN7	addq.l	#1,a0
	move.l	a0,d1
	bclr	#0,d1
	move.l	d1,a0
	addq.l	#4,d0
	move.w	(a0)+,d1
	beq.b	conle10
	addq.w	#1,d1
	addq.l	#4,d0
	addq.l	#2,a0
CONLEN8	subq.w	#1,d1
	beq.b	conlen7
	tst.b	(a0)+
	bne.b	conlen9
	addq.l	#3,a0
CONLEN9	addq.l	#4,d0
	bra.b	conlen8

CONLE10	addq.l	#3,a0
	move.l	a0,d1
	and.b	#$fc,d1
	move.l	d1,a0
	bra.w	conlen1

CONLE11	cmp.w	#$3f5,d1		;Hunk_Overlay
	bne.b	conle13
	addq.l	#4,d0
CONLE12	addq.l	#4,d0
	move.l	(a0)+,d1
	beq.w	conlen1
	lsl.l	#2,d1
	add.l	d1,d0
	lea	(a0,d1.l),a0
	bra.b	conle12

CONLE13	rts
;------------------------------------------------------------------------------
; Copy New Object File
;
; IN :	D0 = Length
;
; OUT:	D0 = Success (0=Error)
;

COPNEW	move.l	UI_DecrunchAdr(a4),UI_Temp(a4)

	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmemj		;Allocate New Buffer
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	copnewo

	move.l	UI_Temp(a4),a0
	move.l	d0,a1
	moveq	#0,d0
COPNEW1	move.l	(a0)+,d1
	and.l	#$0000ffff,d1
	move.l	d1,(a1)+
	addq.l	#4,d0

	cmp.w	#$03f3,d1		;Hunk_Header
	bne.b	copnew3
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,d1
	move.l	d1,(a1)+
	sub.l	-8(a1),d1
	addq.l	#1,d1
	add.l	#16,d0
COPNEW2	move.l	(a0)+,(a1)+
	addq.l	#4,d0
	subq.l	#1,d1
	bne.b	copnew2
	bra.b	copnew1

COPNEW3	cmp.w	#$03f2,d1		;Hunk_End
	beq.b	copne3a
	cmp.w	#$03f6,d1		;Hunk_Break
	bne.b	copnew4
COPNE3a	cmp.l	UI_DecrunchLen(a4),d0
	bne.b	copnew1
	moveq	#-1,d0
	rts

COPNEW4	cmp.w	#$03eb,d1		;Hunk_BSS
	bne.b	copnew5
	move.l	(a0)+,(a1)+
	addq.l	#4,d0
	bra.b	copnew1

COPNEW5	cmp.w	#$03e9,d1		;Hunk_Code
	beq.b	copnew6
	cmp.w	#$03ea,d1		;Hunk_Data
	bne.b	copnew8
COPNEW6	move.l	(a0)+,d1
	move.l	d1,(a1)+
	addq.l	#4,d0
	tst.l	d1
	beq.b	copnew1
COPNEW7	move.l	(a0)+,(a1)+		;Copy Code/Data
	addq.l	#4,d0
	subq.l	#1,d1
	bne.b	copnew7
	bra.b	copnew1

COPNEW8	cmp.w	#$03ec,d1		;Hunk_Reloc32
	bne.b	copnw13
COPNEW9	addq.l	#1,a0
	move.l	a0,d1
	bclr	#0,d1
	move.l	d1,a0

	addq.l	#4,d0
	moveq	#0,d1
	move.w	(a0)+,d1
	move.l	d1,(a1)+
	tst.w	d1
	beq.b	copnw12
	moveq	#0,d2
	move.w	(a0)+,d2
	move.l	d2,(a1)+
	move.l	(a0)+,d2
	move.l	d2,(a1)+
	addq.l	#8,d0
COPNW10	subq.w	#1,d1
	beq.b	copnew9
	moveq	#0,d3
	move.b	(a0)+,d3
	bne.b	copnw11
	move.b	(a0)+,d3
	lsl.l	#8,d3
	move.b	(a0)+,d3
	lsl.l	#8,d3
	move.b	(a0)+,d3
COPNW11	add.l	d3,d3
	add.l	d3,d2
	move.l	d2,(a1)+
	addq.l	#4,d0
	bra.b	copnw10

COPNW12	addq.l	#3,a0
	move.l	a0,d1
	and.b	#$fc,d1
	move.l	d1,a0
	bra.w	copnew1

COPNW13	cmp.w	#$03f5,d1		;Hunk_Overlay
	bne.b	copnewo
COPNW14	addq.l	#4,d0
	move.l	(a0)+,d1
	move.l	d1,(a1)+
	beq.w	copnew1
	move.l	(a0)+,d2
	move.l	d2,(a1)+
	addq.l	#4,d0
	subq.l	#1,d1

	move.l	a0,a2
	sub.l	UI_Temp(a4),a2
	move.l	a1,d3
	sub.l	UI_DecrunchAdr(a4),d3
	sub.l	a2,d3

COPNW15	move.l	(a0)+,d4
	add.l	d3,d4
	move.l	d4,(a1)+
	move.l	(a0)+,(a1)+
	addq.l	#8,d0
	subq.l	#2,d1
	subq.l	#1,d2
	bne.b	copnw15

COPNW16	move.l	(a0)+,(a1)+
	addq.l	#4,d0
	subq.l	#1,d1
	bne.b	copnw16
	bra.b	copnw14

COPNEWO	rts
;------------------------------------------------------------------------------
