;******************************************************************************
;* Spike Cruncher                                                             *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; Execute

SPIKE	dc.w	stc271-spike,spiket-spike,CN_Spike,typenum
	dc.b	CRU_Object,0
	dc.w	$28c
	dc.l	0
	dc.w	spiked-spike,_spike-spike,0

SPIKET	PSNAME	"Spike Cruncher"

SPIKED	dc.w	$188,8-1
	dc.l	$183b0078,$612ab27b,$207656c8,$fff2143b
	dc.l	$0076d441,$12d851ca,$fffcb5c9,$6e1e4e75

_SPIKE
	move.l	$32(a0),d0		;Decrunched Length
	move.l	d0,UI_DecrunchLen(a4)
	add.l	#$100,d0
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out

	move.w	$3a(a0),d7
	move.l	d0,a2
	add.l	$32(a0),a2		;End Of Decrunched Data
	move.l	a2,-(sp)
	lea	$100(a2),a2
	move.l	a2,a1
	sub.l	$36(a0),a1
	move.l	a1,-(sp)
	lea	$226(a0),a5
	lea	$284(a0),a0		;Start Of Crunched Data
	bsr.b	uspike			;Decrunch

	move.l	(sp)+,a1
	move.l	(sp)+,a2
	move.l	UI_DecrunchAdr(a4),a0
	bsr.w	uspik20
	moveq	#-1,d0
.OUT	rts
;------------------------------------------------------------------------------
; Spike Decruncher
;

USPIKE	moveq	#-1,d5
	moveq	#-$80,d3
USPIKE1	bsr.b	uspik10
	bcc.b	uspike4
	moveq	#0,d2
	bsr.b	uspik10
	bcc.b	uspike3
	moveq	#3,d0
	moveq	#8,d2
USPIKE2	subq.w	#2,d2
	move.b	(a5,d0.w),d4
	bsr.b	uspik12
	cmp.w	4(a5,d2.w),d1
	dbne	d0,uspike2
	move.b	12(a5,d0.w),d2
	add.w	d1,d2
USPIKE3	move.b	(a0)+,(a1)+
	cmp.l	a2,a1
	dbeq	d2,uspike3
	cmp.w	d5,d2
	bne.b	uspike9

USPIKE4	moveq	#4,d0
USPIKE5	bsr.b	uspik10
	bcc.b	uspike6
	subq.w	#1,d0
	bne.b	uspike5
USPIKE6	clr.w	d1
	move.b	16(a5,d0.w),d4
	bmi.b	uspike7
	bsr.b	uspik12
USPIKE7	move.b	21(a5,d0.w),d0
	add.w	d1,d0
	moveq	#2,d4
	bsr.b	uspik12
	move.l	d1,d2
	move.b	26(a5,d2.w),d4
	add.w	d2,d2
	bsr.b	uspik12
	add.w	34(a5,d2.w),d1
	move.l	a1,a3
	sub.l	d1,a3
USPIKE8	move.b	(a3)+,(a1)+
	cmp.l	a2,a1
	dbeq	d0,uspike8
	cmp.w	d5,d0
	beq.b	uspike1
USPIKE9	rts				;Get Out

USPIK10	add.b	d3,d3
	bne.b	uspik11
	move.b	(a0)+,d3
	addx.b	d3,d3
USPIK11	rts

USPIK12	moveq	#0,d1
USPIK13	bsr.b	uspik10
	addx.w	d1,d1
	subq.b	#1,d4
	bpl.b	uspik13
	rts

; Pass 2

USPIK20	moveq	#0,d1
USPIK21	move.b	(a1)+,d1
	cmp.w	d7,d1
	bne.b	uspik23
	moveq	#0,d2
	move.b	(a1)+,d2
	beq.b	uspik23
	addq.w	#1,d2
	move.b	(a1)+,d1
USPIK22	move.b	d1,(a0)+
	cmp.l	a2,a0
	dbeq	d2,uspik22
	tst.w	d2
	bpl.b	uspik24
USPIK23	move.b	d1,(a0)+
	cmp.l	a0,a2
	bne.b	uspik21
USPIK24	rts
;------------------------------------------------------------------------------
