;******************************************************************************
;* Super-Cruncher                                                             *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 2.7

SUPCR27	dc.w	syn46-supcr27,supcr27t-supcr27,CN_SuperCrun27,typenum
	dc.b	CRU_Object,PSF_RecogFunc
	dc.w	$3c8
	dc.l	0
	dc.w	_supcr27t-supcr27,_supcr27-supcr27,0

SUPCR27T PSNAME	"Super-Cruncher 2.7"

_SUPCR27T
	moveq	#0,d0			;Unknown
	cmp.l	#$49e90008,$44(a0)
	beq.b	.ok
	cmp.l	#$49e90008,$48(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#$b0ba0126,$5c(a0)
	bne.b	.out
	cmp.l	#$203a00ba,$c8(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts


_SUPCR27
	move.l	$98(a0),d0
	bsr.w	alcdmemj		;Allocate Work Memory
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	usupcro

	move.l	#$258,d0
	bsr.w	alcmemj			;Allocate Decruncher Memory
	move.l	d0,UI_Temp(a4)
	beq.w	usupcro

	lea	$2cc(a0),a2
	move.l	(a2)+,d0
	move.l	a2,a5			;Crunch Start
	move.l	UI_DecrunchAdr(a4),a2
	lsl.l	#2,d0
	add.l	d0,a2			;Crunch End

	move.l	UI_DecrunchAdr(a4),a6
	add.l	$98(a0),a6		;Work End

	move.l	UI_DecrunchAdr(a4),a1
USUPCR1	move.b	(a5)+,(a1)+		;Copy Crunched Data To Work Area
	cmp.l	a1,a2
	bne.b	usupcr1

USUPCR2	move.l	UI_DecrunchAdr(a4),a0
	tst.l	(a0)
	bne.b	usupcr5

	move.l	a6,a1
USUPCR3	move.b	-(a2),-(a1)		;Copy Crunched Data To Work Area
	cmp.l	a0,a2
	bne.b	usupcr3

	lea	4(a1),a0
	move.l	(a0)+,d0		;Decruncher Length
	move.l	d0,d1
	move.l	UI_Temp(a4),a1
	move.l	a1,a3
USUPCR4	move.w	(a0)+,(a1)+		;Copy Decruncher
	subq.l	#2,d0
	bne.b	usupcr4

	move.l	(a0)+,a1
	add.l	a0,a1			;Crunch End
	move.l	UI_DecrunchAdr(a4),a2

	pea	usupcr2(pc)
	cmp.l	#$008e,d1		;Bytecruncher?
	beq.w	sucrby
	cmp.l	#$005c,d1		;ABCABC Cruncher?
	beq.w	sucrab
	cmp.l	#$006e,d1		;ABCxxABC Cruncher?
	beq.w	sucrax
	cmp.l	#$01e0,d1		;Bitcruncher?
	beq.w	sucrbi
	addq.l	#4,sp
	move.l	UI_Temp(a4),a1
	bsr.w	frememj			;Free Decruncher Memory
	clr.l	UI_Temp(a4)
	move.w	#UERR_Unpack,UI_ErrorNum(a4)
	moveq	#0,d0
	bra.w	usupcro

; Rebuild Object File

USUPCR5	move.l	UI_Temp(a4),a1
	bsr.w	frememj			;Free Decruncher Memory
	clr.l	UI_Temp(a4)

	move.l	a6,a1
USUPCR6	move.b	-(a2),-(a6)		;Copy Crunched Data To Work Area
	cmp.l	a0,a2
	bne.b	usupcr6

	move.l	UI_DecrunchAdr(a4),a3
	move.l	#$03f3,(a3)+
	clr.l	(a3)+
	clr.l	4(a3)
	move.l	a3,a2
	lea	3*4(a3),a3

	moveq	#5*4,d6
	moveq	#0,d7
	move.l	a6,a0
USUPCR7	cmp.l	#-1,(a0)
	beq.b	usupcr8
	tst.l	(a0)
	beq.b	usupcr8
	move.l	(a0),d0
	move.l	d0,d2
	and.l	#$c0000000,d2
	and.l	#$3fffffff,d0
	move.l	d0,d1
	subq.l	#8,d1
	lsr.l	#2,d1
	or.l	d2,d1
	move.l	d1,(a3)+
	add.l	d0,a0
	btst	#2,d0
	beq.b	usucr7a
	cmp.w	#$3e9,6(a0)
	beq.b	usucr7a
	cmp.w	#$3ea,6(a0)
	beq.b	usucr7a
	cmp.w	#$3eb,6(a0)
	beq.b	usucr7a
	addq.l	#4,a0
USUCR7a	addq.l	#1,d7
	addq.l	#4,d6
	bra.b	usupcr7

USUPCR8	move.l	d7,(a2)
	subq.l	#1,d7
	move.l	d7,8(a2)

USUPCR9	cmp.l	#-1,(a6)
	beq.w	usucr16
	tst.l	(a6)
	beq.w	usucr16
	move.l	4(a6),(a3)+		;Hunk
	move.l	(a6),d0
	and.l	#$3fffffff,d0
	move.l	d0,d1
	subq.l	#8,d0
	add.l	d0,d6
	lsr.l	#2,d0
	move.l	d0,(a3)+		;Length

	addq.l	#8,d6
	addq.l	#8,a6
	cmp.l	#$03eb,-8(a3)		;Hunk_BSS
	bne.b	usucr10
	lsl.l	#2,d0
	add.l	d0,a6
	sub.l	d0,d6
	btst	#2,d1
	beq.b	usucr11
	cmp.w	#$3e9,6(a6)
	beq.b	usucr11
	cmp.w	#$3ea,6(a6)
	beq.b	usucr11
	cmp.w	#$3eb,6(a6)
	beq.b	usucr11
	addq.l	#4,a6
	bra.b	usucr11

USUCR10	tst.l	d0
	beq.b	uscr10b
USCR10a	move.l	(a6)+,(a3)+		;Copy Hunk
	subq.l	#1,d0
	bne.b	uscr10a
USCR10b	btst	#2,d1
	beq.b	usucr11
	cmp.w	#$3e9,6(a6)
	beq.b	usucr11
	cmp.w	#$3ea,6(a6)
	beq.b	usucr11
	cmp.w	#$3eb,6(a6)
	beq.b	usucr11
	addq.l	#4,a6

USUCR11	cmp.l	#-1,-(a1)
	bne.b	usucr13
USUCR12	move.l	#$03f2,(a3)+		;Hunk_End
	addq.l	#4,d6
	bra.w	usupcr9

USUCR13	move.l	#$03ec,(a3)+		;Hunk_Reloc32
	move.l	a3,a5
	addq.l	#4,a3
	addq.l	#8,d6
	moveq	#-1,d7
	bra.b	usucr15

USUCR14	cmp.l	#-1,-(a1)
	bne.b	usucr15
	move.l	d7,(a5)
	move.l	a3,a5
	addq.l	#4,a3
	addq.l	#4,d6
	moveq	#-1,d7
	cmp.l	#-1,-(a1)
	bne.b	usucr15
	clr.l	(a5)
	bra.b	usucr12

USUCR15	move.l	(a1),(a3)+		;Hunk Number
	addq.l	#4,d6
	addq.l	#1,d7
	bra.b	usucr14

USUCR16	move.l	d6,UI_DecrunchLen(a4)
	moveq	#-1,d0
USUPCRO	rts
;------------------------------------------------------------------------------
; Super Cruncher 2.7 (Bytedecruncher)
;

SUCRBY	move.l	a4,-(sp)
	moveq	#-1,d2
	lea	$50(a3),a4
	lea	$88(a3),a3
SUCRBY1	move.b	(a0)+,d0
	cmp.b	(a3),d0
	bne.b	sucrby3
	moveq	#0,d1
	move.b	(a0)+,d1
	addq.w	#3,d1
	move.b	(a0)+,d0
SUCRBY2	move.b	d0,(a2)+
	cmp.l	a6,a2
	dbeq	d1,sucrby2
	cmp.w	d2,d1
	bne.b	sucrbyo
	bra.b	sucry10

SUCRBY3	cmp.b	1(a3),d0
	bne.b	sucrby5
	moveq	#0,d1
	move.b	(a0)+,(a4)
	move.b	(a0)+,1(a4)
	move.w	(a4),d1
	add.l	#$104,d1
	move.b	(a0)+,d0
SUCRBY4	move.b	d0,(a2)+
	cmp.l	a6,a2
	beq.b	sucrbyo
	subq.l	#1,d1
	bne.b	sucrby4
	bra.b	sucry10

SUCRBY5	cmp.b	2(a3),d0
	bne.b	sucrby6
	move.b	(a0)+,d0
	move.b	d0,(a2)+
	cmp.l	a6,a2
	beq.b	sucrbyo
	move.b	d0,(a2)+
	cmp.l	a6,a2
	beq.b	sucrbyo
	move.b	d0,(a2)+
	cmp.l	a6,a2
	beq.b	sucrbyo
	bra.b	sucry10

SUCRBY6	cmp.b	4(a3),d0
	beq.b	sucrby7
	cmp.b	3(a3),d0
	bne.b	sucrby8
	clr.b	(a2)+
	cmp.l	a6,a2
	beq.b	sucrbyo
SUCRBY7	clr.b	(a2)+
	cmp.l	a6,a2
	beq.b	sucrbyo
	clr.b	(a2)+
	cmp.l	a6,a2
	beq.b	sucrbyo
	bra.b	sucry10

SUCRBY8	cmp.b	5(a3),d0
	bne.b	sucrby9
	move.b	(a0)+,(a2)+
	cmp.l	a6,a2
	beq.b	sucrbyo
	bra.b	sucry10

SUCRBY9	move.b	d0,(a2)+
	cmp.l	a6,a2
	beq.b	sucrbyo
SUCRY10	cmp.l	a1,a0
	bcs.w	sucrby1
SUCRBYO	move.l	(sp)+,a4
	rts				;Get Out
;------------------------------------------------------------------------------
; Super Cruncher 2.7 (ABCABC Decruncher)
;

SUCRAB	moveq	#-1,d5
	lea	$58(a3),a3
SUCRAB1	move.b	(a0)+,d0
	cmp.b	2(a3),d0
	bne.b	sucrab2
	move.b	(a0)+,(a2)+
	cmp.l	a6,a2
	bne.b	sucrab7
	rts				;Get Out

SUCRAB2	cmp.b	1(a3),d0
	bne.b	sucrab5
	moveq	#0,d1
	moveq	#0,d2
	move.b	(a0)+,d1
	move.b	(a0)+,d2
SUCRAB3	move.w	d2,d3
	moveq	#0,d4
SUCRAB4	move.b	(a0,d4.l),(a2)+
	addq.b	#1,d4
	cmp.l	a6,a2
	dbeq	d3,sucrab4
	cmp.w	d5,d3
	bne.b	sucrabo
	dbra	d1,sucrab3
	add.l	d4,a0
	bra.b	sucrab7

SUCRAB5	cmp.b	(a3),d0
	bne.b	sucrab6
	moveq	#1,d1
	moveq	#1,d2
	bra.b	sucrab3

SUCRAB6	move.b	d0,(a2)+
	cmp.l	a6,a2
	beq.b	sucrabo
SUCRAB7	cmp.l	a1,a0
	bcs.b	sucrab1
SUCRABO	rts				;Get Out
;------------------------------------------------------------------------------
; Super Cruncher 2.7 (ABCxxABC Decruncher)
;

SUCRAX	move.l	a4,-(sp)
	moveq	#-1,d2
	lea	$6a(a3),a3
SUCRAX1	move.b	(a0)+,d0
	cmp.b	(a3),d0
	bne.b	sucrax4
	moveq	#0,d0
	move.b	(a0)+,d0
	addq.w	#3,d0
	moveq	#2,d1
SUCRAX2	move.l	a2,a4
	sub.l	d0,a4
SUCRAX3	move.b	(a4)+,(a2)+
	cmp.l	a6,a2
	dbeq	d1,sucrax3
	cmp.w	d2,d1
	beq.b	sucrax8
	bra.b	sucraxo

SUCRAX4	cmp.b	1(a3),d0
	bne.b	sucrax5
	moveq	#0,d0
	moveq	#0,d1
	move.b	(a0)+,d1
	subq.b	#1,d1
	move.b	(a0)+,d0
	addq.w	#4,d0
	bra.b	sucrax2

SUCRAX5	cmp.b	2(a3),d0
	bne.b	sucrax6
	moveq	#0,d0
	moveq	#0,d1
	move.b	(a0)+,d1
	subq.b	#1,d1
	move.b	(a0)+,d0
	lsl.w	#8,d0
	move.b	(a0)+,d0
	bra.b	sucrax2

SUCRAX6	cmp.b	3(a3),d0
	bne.b	sucrax7
	move.b	(a0)+,d0
SUCRAX7	move.b	d0,(a2)+
	cmp.l	a6,a2
	beq.b	sucraxo
SUCRAX8	cmp.l	a1,a0
	bcs.b	sucrax1
SUCRAXO	move.l	(sp)+,a4
	rts
;------------------------------------------------------------------------------
; Super Cruncher 2.7 (Bitdecruncher)
;

SUCRBI	move.l	a4,-(sp)
	move.l	(a0)+,d0
	add.l	a2,d0
	move.l	d0,-(sp)

	lea	$e0(a3),a3
	moveq	#7,d3
	move.b	(a0)+,d2

SUCRBI1	moveq	#0,d0
	moveq	#1,d1
	bsr.w	sucrbi9
	btst	#1,d0
	bne.b	sucrbi3
	tst.b	d0
	bne.b	sucrbi2
	moveq	#0,d1
	bsr.w	sucrbi9
	move.b	(a3,d0.l),(a2)+
	cmp.l	a6,a2
	beq.w	sucrbio
	bra.w	sucrbi8

SUCRBI2	moveq	#0,d0
	moveq	#1,d1
	bsr.w	sucrbi9
	addq.b	#2,d0
	move.b	(a3,d0.l),(a2)+
	cmp.l	a6,a2
	beq.w	sucrbio
	bra.w	sucrbi8

SUCRBI3	moveq	#0,d1
	bsr.w	sucrbi9
	cmp.b	#4,d0
	bne.b	sucrbi4
	moveq	#0,d0
	moveq	#2,d1
	bsr.b	sucrbi9
	addq.b	#6,d0
	move.b	(a3,d0.l),(a2)+
	cmp.l	a6,a2
	beq.b	sucrbio
	bra.b	sucrbi8

SUCRBI4	cmp.b	#5,d0
	bne.b	sucrbi5
	moveq	#0,d0
	moveq	#3,d1
	bsr.b	sucrbi9
	add.b	#14,d0
	move.b	(a3,d0.l),(a2)+
	cmp.l	a6,a2
	beq.b	sucrbio
	bra.b	sucrbi8

SUCRBI5	cmp.b	#6,d0
	bne.b	sucrbi6
	moveq	#0,d0
	moveq	#4,d1
	bsr.b	sucrbi9
	add.b	#30,d0
	move.b	(a3,d0.l),(a2)+
	cmp.l	a6,a2
	beq.b	sucrbio
	bra.b	sucrbi8

SUCRBI6	move.b	(a0)+,d0
	cmp.b	#$c2,d0
	bcs.b	sucrbi7
	sub.b	#$c2,d0
	lea	-$3f(a2),a4
	move.b	(a4,d0.l),(a2)+
	cmp.l	a6,a2
	beq.b	sucrbio
	move.b	1(a4,d0.l),(a2)+
	cmp.l	a6,a2
	beq.b	sucrbio
	bra.b	sucrbi8

SUCRBI7	add.b	#62,d0
	move.b	(a3,d0.l),(a2)+
	cmp.l	a6,a2
	beq.b	sucrbio
SUCRBI8	cmp.l	a0,a1
	bcc.w	sucrbi1
SUCRBIO	move.l	(sp)+,a2
	move.l	(sp)+,a4
	rts				;Get Out

SUCRBI9	roxl.b	#1,d2
	roxl.b	#1,d0
	dbra	d3,sucri10
	move.b	(a0)+,d2
	moveq	#7,d3
SUCRI10	dbra	d1,sucrbi9
	rts
;------------------------------------------------------------------------------
