;******************************************************************************
;* TetraPack                                                                  *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.02

TET102	dc.w	tet11-tet102,tet102t-tet102,CN_Tetra102,typenum
	dc.b	CRU_Address,0
	dc.w	$110
	dc.l	0
	dc.w	tet102d-tet102,_tet102-tet102,0

TET102T	PSNAME	"TetraCrunch 1.02"

TET102D	dc.w	$70,4-1
	dc.l	$fffab3ca,$6da04bfa,$0040720d,$49f80080

_TET102
	move.l	a0,a3
	move.l	$dc(a3),UI_Address(a4)
	move.l	$104(a3),UI_JumpAdr(a4)

	move.l	$e2(a3),d0
	sub.l	$dc(a3),d0		;Unpacked Size

	lea	$108(a3),a0		;Data Start Address
	add.l	$26(a3),a0

	move.l	$2c(a3),d1
	sub.l	$dc(a3),d1

	moveq	#0,d5
	move.b	$3f(a3),d5
	move.w	d5,a5

	move.b	$d5(a3),d5
	move.w	d5,a6

	move.b	$81(a3),d5
	move.b	$d9(a3),d7

	lea	$84(a3),a1
	bra.w	utetra
;------------------------------------------------------------------------------
; 1.1

TET11	dc.w	tet21-tet11,tet11t-tet11,CN_Tetra11,typenum
	dc.b	CRU_Address,0
	dc.w	$108
	dc.l	0
	dc.w	tet11d-tet11,_tet11-tet11,0

TET11T	PSNAME	"TetraCrunch 1.1"

TET11D	dc.w	$70,4-1
	dc.l	$fffab3ca,$6da0602e,$53417400,$e2886602

_TET11
	move.l	a0,a3
	move.l	$ca(a3),UI_Address(a4)
	move.l	$f2(a3),UI_JumpAdr(a4)

	move.l	$d0(a3),d0
	sub.l	$ca(a3),d0		;Unpacked Size

	lea	$100(a3),a0		;Data Start Address
	add.l	$26(a3),a0

	move.l	$2c(a3),d1
	sub.l	$ca(a3),d1

	moveq	#0,d5
	move.b	$3f(a3),d5
	move.w	d5,a5

	move.b	$c3(a3),d5
	move.w	d5,a6

	move.b	$81(a3),d5
	move.b	$c7(a3),d7

	lea	$84(a3),a1
	bra.w	utetra
;------------------------------------------------------------------------------
; 2.1

TET21	dc.w	tet21p-tet21,tet21t-tet21,CN_Tetra21,typenum
	dc.b	CRU_Address,0
	dc.w	$110
	dc.l	0
	dc.w	tet21d-tet21,_tet21-tet21,0

TET21T	PSNAME	"TetraPack 2.1"

TET21D	dc.w	$76,4-1
	dc.l	$fffab3ca,$6da26038,$53417400,$e2886602

_TET21
	move.l	a0,a3
	move.l	$da(a3),UI_Address(a4)
	move.l	$104(a3),UI_JumpAdr(a4)

	move.l	$e0(a3),d0
	sub.l	$da(a3),d0		;Unpacked Size

	lea	$108(a3),a0		;Data Start Address
	add.l	$2e(a3),a0

	move.l	$34(a3),d1
	sub.l	$da(a3),d1

	moveq	#0,d5
	move.b	$47(a3),d5
	move.w	d5,a5

	move.b	$c9(a3),d5
	move.w	d5,a6

	move.b	$87(a3),d5
	move.b	$d7(a3),d7

	lea	$8a(a3),a1
	bra.w	utetra
;------------------------------------------------------------------------------
; 2.1 Professional

TET21P	dc.w	tet22-tet21p,tet21pt-tet21p,CN_Tetra21Pro,typenum
	dc.b	CRU_Address,0
	dc.w	$174
	dc.l	0
	dc.w	tet21pd-tet21p,_tet21p-tet21p,0

TET21PT	PSNAME	"TetraPack 2.1 Pro"

TET21PD	dc.w	$114,4-1
	dc.l	$fffab3ca,$6da26000,$ff4e5341,$7400e288

_TET21P
	move.l	a0,a3
	move.l	$8e(a3),UI_Address(a4)
	move.l	$70(a3),UI_JumpAdr(a4)

	move.l	$94(a3),d0
	sub.l	$8e(a3),d0		;Unpacked Size

	lea	$16c(a3),a0		;Data Start Address
	add.l	$cc(a3),a0

	move.l	$d2(a3),d1
	sub.l	$8e(a3),d1

	moveq	#0,d5
	move.b	$e5(a3),d5
	move.w	d5,a5

	move.b	$169(a3),d5
	move.w	d5,a6

	move.b	$125(a3),d5
	move.b	$8b(a3),d7

	lea	$128(a3),a1
	bra.w	utetra
;------------------------------------------------------------------------------
; 2.2

TET22	dc.w	tet22p-tet22,tet22t-tet22,CN_Tetra22,typenum
	dc.b	CRU_Address,0
	dc.w	$128
	dc.l	0
	dc.w	tet22d-tet22,_tet22-tet22,0

TET22T	PSNAME	"TetraPack 2.2"

TET22D	dc.w	$8e,4-1
	dc.l	$fffab3ca,$6da26038,$53417400,$e2886602

_TET22
	move.l	a0,a3
	move.l	$f2(a3),UI_Address(a4)
	move.l	$11c(a3),UI_JumpAdr(a4)

	move.l	$f8(a3),d0
	sub.l	$f2(a3),d0		;Unpacked Size

	lea	$120(a3),a0		;Data Start Address
	add.l	$34(a3),a0

	move.l	$4c(a3),d1
	sub.l	$f2(a3),d1

	moveq	#0,d5
	move.b	$5f(a3),d5
	move.w	d5,a5

	move.b	$e1(a3),d5
	move.w	d5,a6

	move.b	$9f(a3),d5
	move.b	$ef(a3),d7

	lea	$a2(a3),a1
	bra.b	utetra
;------------------------------------------------------------------------------
; 2.2 Professional

TET22P	dc.w	tfa154-tet22p,tet22pt-tet22p,CN_Tetra22Pro,typenum
	dc.b	CRU_Address,0
	dc.w	$18c
	dc.l	0
	dc.w	tet22pd-tet22p,_tet22p-tet22p,0

TET22PT	PSNAME	"TetraPack 2.2 Pro"

TET22PD	dc.w	$12c,4-1
	dc.l	$fffab3ca,$6da26000,$ff605341,$7400e288

_TET22P
	move.l	a0,a3
	move.l	$b8(a3),UI_Address(a4)
	move.l	$70(a3),UI_JumpAdr(a4)

	move.l	$be(a3),d0
	sub.l	$b8(a3),d0		;Unpacked Size

	lea	$184(a3),a0		;Data Start Address
	add.l	$84(a3),a0

	move.l	$9c(a3),d1
	sub.l	$b8(a3),d1

	moveq	#0,d5
	move.b	$fd(a3),d5
	move.w	d5,a5

	move.b	$181(a3),d5
	move.w	d5,a6

	move.b	$13d(a3),d5
	move.b	$b5(a3),d7

	lea	$140(a3),a1
;;	bra.b	utetra
;------------------------------------------------------------------------------
; Tetra Decruncher Routine
;

UTETRA	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmemj		;Allocate Decrunch Buffer
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	utetrao

	moveq	#0,d6
	cmp.w	#$4e71,(a1)		;NOP Instruction
	bne.b	utetr0
	moveq	#1,d6

UTETR0	move.l	d0,a1
	add.l	d1,a1

	move.l	-(a0),a2
	add.l	a1,a2
	move.l	-(a0),d0
UTETR1	bsr.b	utetr6
	bcs.b	utetr8
	move.w	a5,d1
	moveq	#1,d3
	bsr.b	utetr6
	bcs.b	utetr11
	moveq	#3,d1
	moveq	#0,d4
UTETR2	bsr.b	utetr14
	move.w	d2,d3
	add.w	d4,d3
UTETR3	moveq	#7,d1
UTETR4	bsr.b	utetr6
	roxl.l	#1,d2
	dbra	d1,utetr4
	move.b	d2,-(a2)
	cmp.l	a1,a2
	dbeq	d3,utetr3
	bra.b	utetr13

UTETR5	moveq	#7,d1
	moveq	#8,d4
	bra.b	utetr2

UTETR6	lsr.l	#1,d0
	bne.b	utetr7
	move.l	-(a0),d0
	move.w	#$0010,ccr
	roxr.l	#1,d0
UTETR7	rts

UTETR8	moveq	#2,d1
	bsr.b	utetr14
	cmp.b	#2,d2
	blt.b	utetr9
	cmp.b	#3,d2
	beq.b	utetr5
	moveq	#8,d1
	bsr.b	utetr14
	move.w	d2,d3
	addq.w	#4,d3
	move.w	a6,d1
	bra.b	utetr11

UTETR9	move.w	d5,d1
	move.w	d2,d3
	tst.w	d6
	bne.b	utetr10
	add.w	d2,d1
UTETR10	addq.w	#2,d3
UTETR11	bsr.b	utetr14
UTETR12	move.b	-1(a2,d2.w),-(a2)
	cmp.l	a1,a2
	dbeq	d3,utetr12
UTETR13	cmp.w	#-1,d3
	beq.b	utetr1
	bra.b	utetr16

UTETR14	subq.w	#1,d1
	moveq	#0,d2
UTETR15	bsr.b	utetr6
	roxl.l	#1,d2
	dbra	d1,utetr15
	rts

UTETR16	move.l	UI_DecrunchAdr(a4),a0
	move.l	a0,a2
	add.l	UI_DecrunchLen(a4),a2
UTETR17	move.b	(a1)+,d0
	cmp.b	d7,d0
	bne.b	utetr19
	moveq	#0,d1
	move.b	(a1)+,d1
	beq.b	utetr19
	move.b	(a1)+,d0
	addq.w	#1,d1
UTETR18	move.b	d0,(a0)+
	cmp.l	a2,a0
	dbeq	d1,utetr18
	cmp.w	#-1,d1
	bne.b	utetr20
UTETR19	move.b	d0,(a0)+
	cmp.l	a2,a0
	bne.b	utetr17

UTETR20	moveq	#-1,d0
UTETRAO	rts
;------------------------------------------------------------------------------
