;******************************************************************************
;* Titanics Cruncher                                                          *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.1

TITAN11	dc.w	titan12-titan11,titan11t-titan11,CN_Titanic11,typenum
	dc.b	CRU_Object,0
	dc.w	$308
	dc.l	0
	dc.w	titan11d-titan11,_titan11-titan11,0

TITAN11T PSNAME	"Titanics Cruncher 1.1"

TITAN11D dc.w	$dc,12-1
	dc.l	$06800000,$14002940,$006a6100,$01062e18
	dc.l	$2c07227a,$ff0cd3c9,$d3c92f09,$2018b1fa
	dc.l	$ff6e6604,$610000ec,$22000280,$00ffffff

_TITAN11
	moveq	#0,d6
	bra.b	utitan
;------------------------------------------------------------------------------
; 1.2

TITAN12	dc.w	tnm11-titan12,titan12t-titan12,CN_Titanic12,typenum
	dc.b	CRU_Object,0
	dc.w	$354
	dc.l	0
	dc.w	titan12d-titan12,_titan12-titan12,0

TITAN12T PSNAME	"Titanics Cruncher 1.2"

TITAN12D dc.w	$dc,12-1
	dc.l	$ff2c7400,$343aff50,$76ff4ead,$ffbe203c
	dc.l	$00001400,$72004eae,$ff3a49fa,$ff082940
	dc.l	$0024660e,$224d4eae,$fe624cdf,$6fff7000

_TITAN12
	moveq	#0,d6
	cmp.w	#$4e71,$2a2(a0)		;Test For Protection
	beq.b	utitan
	moveq	#-1,d6
;;	bra.b	utitan
;------------------------------------------------------------------------------
; Titanics Decruncher Routine
;

UTITAN	move.l	a4,-(sp)
	move.w	d6,-(sp)
	moveq	#0,d0
	move.w	$56(a0),d0
	add.l	d0,a0			;Data Start Address

; Count Decrunched Length

	move.l	(a0)+,d7		;Number Of Hunks
	move.l	a0,a4
	move.l	a0,a5
	move.l	d7,d6
	addq.l	#1,d6
	lsl.l	#2,d6
	add.l	d6,a0
	move.l	d6,d5

	move.l	d7,d6
	lea	uptit98(pc),a3
UTITA1	addq.l	#8,d5			;Plus Hunk Size

	move.l	(a0)+,d1
	beq.b	utita4
	move.l	(a5),d0
	and.l	#$00ffffff,d0
	add.l	d0,d5			;Calculate All The Hunk Sizes
	tst.l	d0
	beq.b	utita2
	bsr.w	uptitan
UTITA2	move.l	(a0)+,d0
	beq.b	utita4
	addq.l	#8,d5
UTITA3	addq.l	#1,d0
	lsl.l	#2,d0
	add.l	d0,d5
	add.l	d0,a0
	addq.l	#4,d5
	move.l	(a0)+,d0
	bne.b	utita3

UTITA4	addq.l	#4,d5
	addq.l	#4,a5
	dbra	d6,utita1
	add.l	#20,d5			;Plus Hunk_Header Size
	move.w	(sp)+,d6
	move.l	(sp)+,a0

	move.l	d5,d0
	move.l	d0,UI_DecrunchLen(a0)
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a0)
	beq.w	utitano
	move.l	d0,a1

; Decrunch Data

	move.w	d6,d5
	move.l	d7,d6
	addq.l	#1,d6
	move.l	#$03f3,(a1)+
	clr.l	(a1)+
	move.l	d6,(a1)+
	clr.l	(a1)+
	subq.l	#1,d6
	move.l	d6,(a1)+

	move.l	a4,a0
UTITA5	move.l	(a0)+,d0
	move.l	d0,d1
	and.l	#$00ffffff,d0
	and.l	#$ff000000,d1
	lsr.l	#2,d0
	lsl.l	#5,d1
	or.l	d1,d0
	move.l	d0,(a1)+
	dbra	d6,utita5

UTITA6	move.l	(a0)+,d0		;Hunk_BSS
	bne.b	utita7			;Nap!
	move.l	#$03eb,(a1)+		;Hunk_BSS
	move.l	(a4)+,d0
	and.l	#$00ffffff,d0
	lsr.l	#2,d0
	move.l	d0,(a1)+		;Size
	bra.b	utita10

UTITA7	move.l	#$03e9,(a1)+		;Hunk_Code
	move.l	(a4)+,d0
	and.l	#$00ffffff,d0
	move.l	d0,d1
	lsr.l	#2,d1
	move.l	d1,(a1)+		;Size
	tst.l	d0
	beq.b	utita8
	lea	uptit99(pc),a3
	bsr.b	uptitan			;Unpack One Hunk

UTITA8	move.l	(a0)+,d0
	beq.b	utita10

	move.l	#$3ec,(a1)+		;Hunk_Reloc32
	move.l	d0,(a1)+
UTITA9	move.l	(a0)+,(a1)+		;Copy Offsets
	dbra	d0,utita9

	move.l	(a0)+,d0
	move.l	d0,(a1)+
	bne.b	utita9
UTITA10	move.l	#$03f2,(a1)+		;Hunk_End
	dbra	d7,utita6

	moveq	#-1,d0
UTITANO	rts
;------------------------------------------------------------------------------
; Unpacker Routine
;

UPTITAN	lea	(a1,d0.l),a2
	moveq	#0,d0
UPTIT1	lsl.l	#1,d0
	bne.b	uptit2
	bsr.b	uptit12
UPTIT2	bcs.b	uptit9
	lsl.l	#1,d0
	bne.b	uptit3
	bsr.b	uptit12
UPTIT3	bcs.b	uptit8
	moveq	#2,d1
	bsr.b	uptit13
	move.w	d2,d3
UPTIT4	moveq	#7,d1
	bsr.b	uptit13
	tst.w	d5
	beq.b	uptit5
	not.b	d2
UPTIT5	move.b	d2,d4
	jsr	(a3)
	cmp.l	a2,a1
	dbeq	d3,uptit4
UPTIT6	cmp.w	#-1,d3
	beq.b	uptit1
	rts				;Get Out

UPTIT7	moveq	#7,d1
	bsr.b	uptit13
	move.w	d2,d3
	addq.w	#8,d3
	bra.b	uptit4

UPTIT8	moveq	#7,d1
	bsr.b	uptit13
	addq.w	#2,d2
	neg.w	d2
	moveq	#1,d3
	bra.b	uptit10

UPTIT9	moveq	#1,d1
	bsr.b	uptit13
	cmp.w	#2,d2
	bgt.b	uptit7
	beq.b	uptit11
	moveq	#8,d1
	add.w	d2,d1
	moveq	#2,d3
	add.w	d2,d3
	bsr.b	uptit13
	add.w	d3,d2
	addq.w	#1,d2
	neg.w	d2
UPTIT10	move.b	(a1,d2.w),d4
	jsr	(a3)
	cmp.l	a2,a1
	dbeq	d3,uptit10
	bra.b	uptit6

UPTIT11	moveq	#7,d1
	bsr.b	uptit13
	move.w	d2,d3
	addq.w	#2,d3
	moveq	#11,d1
	bsr.b	uptit13
	addq.w	#3,d2
	neg.w	d2
	bra.b	uptit10

UPTIT12	move.l	(a0)+,d0
	move.w	#$0010,ccr
	roxl.l	#1,d0
	rts

UPTIT13	moveq	#0,d2
UPTIT14	lsl.l	#1,d0
	bne.b	uptit15
	bsr.b	uptit12
UPTIT15	roxl.w	#1,d2
	dbra	d1,uptit14
	rts

UPTIT98	addq.l	#1,a1
	rts

UPTIT99	move.b	d4,(a1)+
	rts
;------------------------------------------------------------------------------
