;******************************************************************************
;* XPK                                                                        *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; Normal

XPK	dc.w	xpke-xpk,xpkt-xpk,CN_XPK,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	$34
	dc.l	0
	dc.w	_xpkt-xpk,_xpk-xpk,0

XPKT	PSNAME	"XPK"

_XPKT
	moveq	#0,d0			;Unknown
	cmp.l	#"XPKF",(a0)
	bne.b	.out
	btst	#1,$20(a0)		;Encrypted?
	bne.b	.out			;Yup!
	moveq	#-1,d0			;Ok
.OUT	rts


_XPK
	moveq	#0,d7
	bra.b	uxpk
;------------------------------------------------------------------------------
; Encrypted

XPKE	dc.w	0,xpket-xpke,CN_XPKE,typenum
	dc.b	CRU_Data,PSF_RecogFunc!PSF_Encrypted
	dc.w	$34
	dc.l	0
	dc.w	_xpket-xpke,_xpke-xpke,0

XPKET	PSNAME	"XPK Encrypted"

_XPKET
	moveq	#0,d0			;Unknown
	cmp.l	#"XPKF",(a0)
	bne.b	.out
	btst	#1,$20(a0)		;Encrypted?
	beq.b	.out			;Nup!
	moveq	#-1,d0			;Ok
.OUT	rts


_XPKE
	moveq	#1,d7
;;	bra.b	uxpk
;------------------------------------------------------------------------------
; XPK Decrunching Routine
;

UXPK	move.l	a0,a3
	move.l	12(a0),d0
	move.l	d0,UI_DecrunchLen(a4)
	add.l	#XPK_MARGIN,d0
	move.l	d0,d6
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	uxpko

	move.w	#UERR_OpenLibrary,UI_ErrorNum(a4)
	move.l	LIB_SysBase(a6),a2
	exg	a2,a6
	lea	xpkname(pc),a1
	moveq	#0,d0
	jsr	OpenLibrary(a6)		;Open Xpkmaster.library
	tst.l	d0
	beq.b	uxpko
	move.l	d0,a6

; Setup Taglist

	move.l	sp,a5
	clr.l	-(sp)			;TAG_END
	tst.w	d7
	beq.b	uxpk1			;Not Encrypted
	lea	UI_PasswordStr(a4),a0
	move.l	a0,-(sp)
	move.l	#XPK_Password,-(sp)

UXPK1	move.l	d6,-(sp)
	move.l	#XPK_OutBufLen,-(sp)
	move.l	UI_DecrunchAdr(a4),-(sp)
	move.l	#XPK_OutBuf,-(sp)

	move.l	4(a3),d0
	addq.l	#8,d0
	move.l	d0,-(sp)
	move.l	#XPK_InLen,-(sp)
	move.l	UI_CrunchAdrTemp(a4),-(sp)
	move.l	#XPK_InBuf,-(sp)

	move.l	sp,a0
	jsr	XpkUnpack(a6)
	move.l	a5,sp			;Restore Stack Pointer
	move.l	d0,-(sp)

	move.l	a6,a1
	move.l	LIB_SysBase(a2),a6
	jsr	CloseLibrary(a6)	;Close Xpkmaster.library

	moveq	#-1,d7
	move.l	(sp)+,d0
	beq.b	uxpko1

	moveq	#0,d7
	move.w	#UERR_Unknown,UI_ErrorNum(a4)
	cmp.w	#-32,d0
	blt.b	uxpko1

	lea	xpkerr(pc),a0
	not.w	d0
	add.w	d0,d0
	move.w	(a0,d0.w),UI_ErrorNum(a4)

UXPKO1	move.l	d7,d0
UXPKO	rts

XPKERR	dc.w	UERR_Unpack,UERR_Unpack,UERR_Unpack,UERR_Unpack
	dc.w	UERR_Corrupt,UERR_Unpack,UERR_Memory,UERR_Unpack
	dc.w	UERR_Unpack,UERR_Memory,UERR_Unpack,UERR_Unpack
	dc.w	UERR_PasswordReq,UERR_Corrupt,UERR_OpenLibrary,UERR_Unpack
	dc.w	UERR_Unpack,UERR_Unpack,UERR_Unpack,UERR_Corrupt
	dc.w	UERR_Unpack,UERR_Unpack,UERR_Unpack,UERR_Unpack
	dc.w	UERR_Unpack,UERR_Unpack,UERR_Unpack,UERR_Unpack
	dc.w	UERR_Unpack,UERR_Unpack,UERR_Unpack,UERR_Password

XPKNAME	dc.b	"xpkmaster.library",0
	even
;------------------------------------------------------------------------------
