;******************************************************************************
;* Crunch Master                                                              *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
CMAS10	dc.w	cman191-cmas10,cmas10t-cmas10,CN_CrunMast10,typenum
	dc.b	CRU_Object,0
	dc.w	$c6
	dc.l	0
	dc.w	cmas10d-cmas10,_cmas10-cmas10,0

CMAS10T PSNAME "Crunch Master 1.0"

CMAS10D	dc.w	$1c,12-1		;Crunch Master 1.0
	dc.l	$04840000,$00010c50,$54566600,$003a0c68
	dc.l	$54560006,$66000030,$4a846700,$002a283c
	dc.l	$00000003,$42804281,$30280002,$32280004


_CMAS10
	moveq	#0,d6
	bsr.b	ucrmas
	move.l	d7,UI_DecrunchLen(a4)

	move.l	d7,d0
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out
	moveq	#-1,d6
	bsr.b	ucrmas
	moveq	#-1,d0
.OUT	rts
;------------------------------------------------------------------------------
; Crunch Master Decruncher
;
; IN :	D6 = Count Flag (0=Count Only)
;
; OUT:	D7 = Number Of Decrunched Bytes
;

UCRMAS	move.l	UI_CrunchAdrTemp(a4),a2
	lea	$a2(a2),a2
	lea	8(a2),a0		;Start Of Crunched Data
	move.l	a0,a5
	add.l	(a2),a0
	subq.l	#6,a0
	move.l	UI_DecrunchAdr(a4),a1
	add.l	UI_DecrunchLen(a4),a1
	moveq	#0,d4
	moveq	#0,d7

CRMAS1	subq.l	#1,d4
	cmp.w	#$5456,(a0)
	bne.b	crmas3
	cmp.w	#$5456,6(a0)
	bne.b	crmas3
	tst.l	d4
	beq.b	crmas3
	moveq	#3,d4
	move.w	2(a0),d0
	move.w	4(a0),d1
	addq.l	#6,a1
	subq.l	#6,d7
CRMAS2	tst.w	d6
	beq.b	crmas2a
	move.w	d1,-(a1)
CRMAS2a	addq.l	#2,d7
	dbra	d0,crmas2
	bra.b	crmas4

CRMAS3	tst.w	d6
	beq.b	crmas3a
	move.w	(a0),-(a1)
CRMAS3a	addq.l	#2,d7
CRMAS4	subq.l	#2,a0
	cmp.l	a5,a0
	bcc.b	crmas1
	rts
;------------------------------------------------------------------------------
