;******************************************************************************
;* Defjam                                                                     *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 3.2-3.6

DEF36	dc.w	def36p-def36,def36t-def36,CN_Defjam36,typenum
	dc.b	CRU_Address,PSF_RecogFunc
	dc.w	$2b8
	dc.l	0
	dc.w	_def36t-def36,_def36-def36,0

DEF36T	PSNAME "Defjam 3.6"

_DEF36T
	moveq	#0,d0			;Unknown
	cmp.l	#$43fa028c,$22(a0)
	beq.b	.ok
	cmp.l	#$43fa028c,$26(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#$49fa015e,$50(a0)
	bne.b	.out
	cmp.l	#$b0076610,$18c(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_DEF36
	move.l	$180(a0),UI_Address(a4)
	move.l	$1aa(a0),UI_JumpAdr(a4)

	lea	$1b0(a0),a3		;Start Of Crunched Data
	move.l	$4c(a0),a1
	sub.l	$180(a0),a1		;Compare Address
	move.l	$186(a0),d0
	sub.l	$180(a0),d0		;Length Of Decrunched Data
	lea	$100(a3),a2
	add.l	$34(a0),a2		;End Address Of Crunched Data

	move.b	$ff(a0),d1
	move.b	$12d(a0),d2
	move.b	$14d(a0),d3
	move.b	$15b(a0),d4
	move.b	$161(a0),d5
	move.b	$17d(a0),d6
	bra.w	udef
;------------------------------------------------------------------------------
; 3.2-3.6 Professional

DEF36P	dc.w	dfimp10-def36p,def36pt-def36p,CN_Defjam36Pro,typenum
	dc.b	CRU_Address,PSF_RecogFunc
	dc.w	$320
	dc.l	0
	dc.w	_def36pt-def36p,_def36p-def36p,0

DEF36PT	PSNAME "Defjam 3.2-3.6 Pro"

_DEF36PT
	moveq	#0,d0			;Unknown
	cmp.l	#$43fa029a,$7c(a0)
	beq.b	.ok
	cmp.l	#$43fa029a,$80(a0)
	bne.b	.out
	addq.l	#4,a0
.OK	cmp.l	#$49fa0126,$f0(a0)
	bne.b	.out
	cmp.l	#$b0076610,$a2(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_DEF36P
	move.l	$96(a0),UI_Address(a4)
	move.l	$74(a0),UI_JumpAdr(a4)

	lea	$218(a0),a3		;Start Of Crunched Data
	move.l	$ec(a0),a1
	sub.l	$96(a0),a1		;Compare Address
	move.l	$9c(a0),d0
	sub.l	$96(a0),d0		;Length Of Decrunched Data
	lea	$100(a3),a2
	add.l	$d4(a0),a2		;End Address Of Crunched Data

	move.b	$19f(a0),d1
	move.b	$1cd(a0),d2
	move.b	$1ed(a0),d3
	move.b	$1fb(a0),d4
	move.b	$201(a0),d5
	move.b	$93(a0),d6
;------------------------------------------------------------------------------
; Start To Unpack
;

UDEF	move.l	a2,a0			;End Address Of Crunched Data
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem			;Allocate Memory
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out
	add.l	d0,a1
	bsr.b	defjam			;Decrunch
	moveq	#-1,d0
.OUT	rts
;------------------------------------------------------------------------------
; Defjam Decruncher
;

DEFJAM	lea	-10(sp),sp
	move.l	sp,a5
	clr.l	(a5)
	clr.l	4(a5)
	clr.w	8(a5)
	move.b	d1,1(a5)
	move.b	d2,3(a5)
	move.b	d3,5(a5)
	move.b	d4,7(a5)
	move.b	d5,9(a5)

	move.l	-(a0),a2
	add.l	a1,a2
	move.l	-(a0),d0
	moveq	#-1,d7
DEJAM1	moveq	#3,d1
	bsr.w	dejam16
	tst.w	d2
	beq.b	dejam11
	cmp.b	#7,d2
	bne.b	dejam5
	bsr.w	dejam12
	bcs.b	dejam2
	moveq	#2,d1
	bsr.w	dejam16
	addq.w	#7,d2
	bra.b	dejam5

DEJAM2	moveq	#8,d1
	bsr.w	dejam16
	tst.w	d2
	beq.b	dejam3
	add.w	#10,d2
	bra.b	dejam5

DEJAM3	moveq	#12,d1
	bsr.w	dejam16
	tst.w	d2
	beq.b	dejam4
	add.w	#$109,d2
	bra.b	dejam5

DEJAM4	moveq	#15,d1
	bsr.b	dejam16
	add.l	#$110b,d2
DEJAM5	subq.w	#1,d2
	move.w	d2,d3
DEJAM6	bsr.b	dejam12
	bcs.b	dejam7
	moveq	#8,d5
	moveq	#6,d1
	bra.b	dejam10

DEJAM7	bsr.b	dejam12
	bcs.b	dejam8
	moveq	#0,d5
	moveq	#3,d1
	bra.b	dejam10

DEJAM8	bsr.b	dejam12
	bcs.b	dejam9
	moveq	#$48,d5
	moveq	#6,d1
	bra.b	dejam10

DEJAM9	move.w	#$88,d5
	moveq	#7,d1
DEJAM10	bsr.b	dejam16
	add.w	d5,d2
	move.b	(a3,d2.w),-(a2)
	cmp.l	a1,a2
	dbeq	d3,dejam6
	cmp.w	d7,d3
	bne.b	dejam23

DEJAM11	bsr.b	dejam12
	bcc.b	dejam19
	moveq	#2,d1
	bsr.b	dejam16
	move.w	(a5),d1
	moveq	#3,d3
	tst.b	d2
	beq.b	dejam21
	cmp.b	d2,d3
	beq.b	dejam18
	cmp.b	#1,d2
	beq.b	dejam14
	moveq	#6,d3
	moveq	#3,d1
	bra.b	dejam15

DEJAM12	lsr.l	#1,d0
	bne.b	dejam13
	move.l	-(a0),d0
	move.w	#$10,ccr
	roxr.l	#1,d0
DEJAM13	rts

DEJAM14	moveq	#4,d3
	moveq	#1,d1
DEJAM15	bsr.b	dejam16
	add.w	d2,d3
	move.w	2(a5),d1
	bra.b	dejam21

DEJAM16	subq.w	#1,d1
	moveq	#0,d2
DEJAM17	bsr.b	dejam12
	addx.l	d2,d2
	dbra	d1,dejam17
	rts

DEJAM18	moveq	#8,d1
	bsr.b	dejam16
	move.w	d2,d3
	add.w	#14,d3
	move.w	4(a5),d1
	bra.b	dejam21

DEJAM19	bsr.b	dejam12
	bcs.b	dejam20
	moveq	#2,d3
	move.w	6(a5),d1
	bra.b	dejam21

DEJAM20	moveq	#1,d3
	move.w	8(a5),d1
DEJAM21	bsr.b	dejam16
DEJAM22	move.b	-1(a2,d2.w),-(a2)
	cmp.l	a1,a2
	dbeq	d3,dejam22
	cmp.w	d7,d3
	beq.w	dejam1

DEJAM23	move.l	UI_DecrunchAdr(a4),a0
	move.l	a0,a2
	add.l	UI_DecrunchLen(a4),a2
DEJAM24	move.b	(a1)+,d0
	cmp.b	d6,d0
	bne.b	dejam26
	moveq	#0,d1
	move.b	(a1)+,d1
	beq.b	dejam26
	move.b	(a1)+,d0
	addq.w	#1,d1
DEJAM25	move.b	d0,(a0)+
	cmp.l	a2,a0
	dbeq	d1,dejam25
	cmp.w	d7,d1
	bne.b	dejam27
DEJAM26	move.b	d0,(a0)+
	cmp.l	a2,a0
	bne.b	dejam24

DEJAM27	lea	10(sp),sp
	rts
;------------------------------------------------------------------------------
