;******************************************************************************
;* HQC                                                                        *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 2.0

HQC20	dc.w	iam10atm-hqc20,hqc20t-hqc20,CN_HQC20,typenum
	dc.b	CRU_Object,0
	dc.w	$74c
	dc.l	0
	dc.w	hqc20d-hqc20,_hqc20-hqc20,0

HQC20T	PSNAME	"HQC Cruncher 2.0"

HQC20D	dc.w	$00,12-1
	dc.l	$2c790000,$00044eae,$ff7c43fa,$050a4eae
	dc.l	$fe684a80,$6700033e,$41fa0676,$208041fa
	dc.l	$066443fa,$05102089,$43fa0524,$21490004

_HQC20
	move.l	a0,a3
	lea	$714(a3),a1
	cmp.l	#$3f3,(a1)+
	bne.w	uhqco1

	moveq	#20,d7
	move.l	12(a1),d0
	sub.l	8(a1),d0
	addq.l	#1,d0
	move.l	d0,d6
	lsl.l	#2,d0
	add.l	d0,d7
	lea	16(a1,d0.l),a1
	move.l	d6,d5
UHQC1	move.l	(a1)+,d0
	and.l	#$3fffffff,d0
	cmp.l	#$3e9,d0		;Hunk_Code
	beq.b	uhqc2
	cmp.l	#$3ea,d0		;Hunk_Data
	beq.b	uhqc2
	cmp.l	#$3eb,d0		;Hunk_Bss
	beq.b	uhqc3
	cmp.l	#$3ec,d0		;Hunk_Reloc32
	beq.b	uhqc4
	cmp.l	#$3f2,d0		;Hunk_End
	bne.w	uhqco1
	addq.l	#4,d7
	subq.l	#1,d5
	bne.b	uhqc1
	bra.b	uhqc5

UHQC2	move.l	(a1),d0
	add.l	d0,a1
	move.l	(a1)+,d0
	add.l	d0,d7
	addq.l	#8,d7
	bra.b	uhqc1

UHQC3	addq.l	#4,a1
	addq.l	#8,d7
	bra.b	uhqc1

UHQC4	addq.l	#8,d7
UHQC4a	move.l	(a1)+,d0
	beq.b	uhqc1
	lsl.l	#2,d0
	lea	4(a1,d0.l),a1
	add.l	d0,d7
	addq.l	#8,d7
	bra.b	uhqc4a

; Begin To Unpack

UHQC5	move.l	d7,d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	uhqco
	move.l	d0,a1			;Decrunch Start Address
	lea	$714(a3),a0		;Crunch Start Address
	move.l	d6,d3			;Number Of Hunks
	moveq	#0,d5
	move.b	$47d(a3),d5
	move.w	$4d4(a3),d6
	move.w	$4dc(a3),d7

	moveq	#5,d0
	add.l	d3,d0
UHQC6	move.l	(a0)+,(a1)+		;Copy Header
	subq.l	#1,d0
	bne.b	uhqc6

UHQC7	move.l	(a0)+,d0
	move.l	d0,(a1)+
	and.l	#$3fffffff,d0
	cmp.l	#$3e9,d0		;Hunk_Code
	beq.b	uhqc9
	cmp.l	#$3ea,d0		;Hunk_Data
	beq.b	uhqc9
	cmp.l	#$3eb,d0		;Hunk_Bss
	bne.b	uhqc8
	move.l	(a0)+,(a1)+
	bra.b	uhqc7

UHQC8	cmp.l	#$3ec,d0		;Hunk_Reloc32
	beq.b	uhqc10
	cmp.l	#$3f2,d0		;Hunk_End
	bne.b	uhqco1
	subq.l	#1,d3
	bne.b	uhqc7
	moveq	#-1,d0
	rts

UHQC9	move.l	(a0),d0
	add.l	d0,a0
	move.l	(a0)+,d0
	lsr.l	#2,d0
	move.l	d0,(a1)+
	beq.b	uhqc7

	movem.l	d3/a0,-(sp)
	move.l	-(a0),a2
	add.l	a1,a2
	move.l	-(a0),d4
	bsr.w	bytunp1			;Unpack One Segment
	movem.l	(sp)+,d3/a0
	tst.l	d0
	bne.b	uhqco1

	add.l	-4(a0),a1
	bra.b	uhqc7

UHQC10	move.l	(a0)+,d0
	move.l	d0,(a1)+
	beq.b	uhqc7
	addq.l	#1,d0
UHQC11	move.l	(a0)+,(a1)+
	subq.l	#1,d0
	bne.b	uhqc11
	bra.b	uhqc10

UHQCO1	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
UHQCO	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
