;******************************************************************************
;* PHD                                                                        *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
;

PHD	dc.w	pmc-phd,phdt-phd,CN_PHD,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	$10
	dc.l	"PHD"<<8+1
	dc.w	0,_phd-phd,0

PHDT	PSNAME	"PHD"

_PHD
	move.l	4(a0),d0
	move.l	d0,UI_DecrunchLen(a4)
	add.l	#512,d0
	bsr.w	alcdmem
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out

	move.l	#3670,d0
	bsr.w	alcmem			;Allocate Work Buffer
	move.l	d0,UI_Temp(a4)
	beq.b	.out

	move.l	UI_DecrunchAdr(a4),a1
	move.l	d0,a2
	bsr.b	uphd			;Decrunch Data

	move.l	UI_Temp(a4),a1
	bsr.w	fremem			;Free Work Buffer
	clr.l	UI_Temp(a4)
	moveq	#-1,d0
.OUT	rts
;------------------------------------------------------------------------------
; PHD Decrunching Routine
;
; IN :	A0 = Pointer To Crunched Data
;	A1 = Pointer To Decrunched Data
;	A2 = Pointer To Work Buffer
;
; OUT:	Nothing
;

UPHD	move.l	a4,-(sp)
	addq.l	#8,a0
	moveq	#0,d6
	move.w	(a0)+,d6
	moveq	#15,d7
	lea	$4c4(a2),a2
	lea	$4c6(a2),a3
	lea	$98c(a2),a4
	lea	uphd26(pc),a5
	bra.b	uphd2

UPHD1	tst.w	(a2)
	bne.b	uphd5
UPHD2	movem.l	a3-a5,-(sp)
	lea	-$4c4(a2),a5
	lea	-$4c4(a3),a6
	move.l	a5,a3
	move.w	#$131,d1
	moveq	#1,d2
UPHD3	move.w	d2,(a5)+
	move.w	d1,(a6)+
	dbra	d1,uphd3
	move.w	#$130,d1
	move.w	#$fb3c,d2
	moveq	#0,d3
UPHD4	move.w	(a3)+,d0
	add.w	(a3)+,d0
	move.w	d0,(a5)+
	move.w	d2,(a6)+
	addq.w	#4,d2
	move.w	d3,-(a4)
	move.w	d3,-(a4)
	subq.w	#2,d3
	dbra	d1,uphd4
	movem.l	(sp)+,a3-a5
	bra.b	uphd10

UPHD5	lea	(a2,d3.w),a6
	move.w	(a6)+,d0
	addq.w	#1,d0
	cmp.w	(a6)+,d0
	bls.b	uphd9
UPHD6	cmp.w	(a6)+,d0
	bhi.b	uphd6
	subq.l	#4,a6
	sub.l	a2,a6
	move.w	(a3,a6.w),d1
	bpl.b	uphd7
	move.w	d3,(a4,d1.w)
	move.w	d3,2(a4,d1.w)
UPHD7	move.w	(a3,d3.w),d2
	bpl.b	uphd8
	move.w	a6,(a4,d2.w)
	move.w	a6,2(a4,d2.w)
UPHD8	move.w	d1,(a3,d3.w)
	move.w	d2,(a3,a6.w)
	move.w	a6,d3
UPHD9	move.w	d0,(a2,d3.w)
	move.w	(a4,d3.w),d3
	bne.b	uphd5
	addq.w	#1,(a2)
UPHD10	moveq	#0,d3
UPHD11	move.w	(a3,d3.w),d4
	bpl.b	uphd13
	add.w	d6,d6
	bcc.b	uphd12
	addq.w	#2,d4
UPHD12	move.w	d4,d3
	dbra	d7,uphd11
	moveq	#15,d7
	move.w	(a0)+,d6
	bra.b	uphd11

UPHD13	cmp.w	#$100,d4
	bcc.b	uphd16
	move.b	d4,(a1)+
	bra.w	uphd1

UPHD14	cmp.w	#$131,d4
	beq.b	uphd15
	lea	$18(a5),a5
	bra.w	uphd1

UPHD15	move.l	(sp)+,a4
	rts				;Get Out

UPHD16	bne.b	uphd17
	moveq	#12,d0
	bra.b	uphd20

UPHD17	cmp.w	#$12f,d4
	bcs.b	uphd19
	bhi.b	uphd14
	moveq	#6,d1
	cmp.b	d1,d7
	bcc.b	uphd18
	addq.b	#1,d7
	lsl.l	d7,d6
	sub.b	d7,d1
	move.w	(a0)+,d6
	moveq	#15,d7
UPHD18	lsl.l	d1,d6
	sub.b	d1,d7
	swap	d6
	add.w	d6,d4
	clr.w	d6
	swap	d6
UPHD19	moveq	#0,d0
UPHD20	add.w	d6,d6
	bcc.b	uphd22
	addq.w	#4,d0
	dbra	d7,uphd21
	moveq	#15,d7
	move.w	(a0)+,d6
UPHD21	add.w	d6,d6
	bcc.b	uphd22
	addq.w	#4,d0
UPHD22	dbra	d7,uphd23
	moveq	#15,d7
	move.w	(a0)+,d6
UPHD23	move.w	(a5,d0.w),d1
	cmp.b	d1,d7
	bcc.b	uphd24
	addq.b	#1,d7
	lsl.l	d7,d6
	sub.b	d7,d1
	move.w	(a0)+,d6
	moveq	#15,d7
UPHD24	lsl.l	d1,d6
	sub.b	d1,d7
	swap	d6
	add.w	2(a5,d0.w),d6
	neg.w	d6
	lea	-1(a1,d6.w),a6
	clr.w	d6
	swap	d6
	sub.w	#$fe,d4
UPHD25	move.b	(a6)+,(a1)+
	dbra	d4,uphd25
	bra.w	uphd1

UPHD26	dc.w	5,0,7,32,9,160,5,0,7,32,9,160
	dc.w	6,0,8,64,10,320,6,0,8,64,10,320
	dc.w	7,0,9,128,11,640,7,0,9,128,11,640
	dc.w	8,0,10,256,12,1280,7,0,9,128,11,640
	dc.w	8,0,10,256,13,1280,7,0,9,128,11,640
	dc.w	9,0,11,512,14,2560,7,0,9,128,11,640
;------------------------------------------------------------------------------
