;******************************************************************************
;* PackIt                                                                     *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0

PACK10	dc.w	pack10d-pack10,pack10t-pack10,CN_PackIt10,typenum
	dc.b	CRU_Object,0
	dc.w	$27a
	dc.l	0
	dc.w	pack10da-pack10,_pack10-pack10,0

PACK10T	PSNAME	"PackIt 1.0"

PACK10DA dc.w	$30,12-1
	dc.l	$70004eae,$fdd82a40,$203a0208,$72014eae
	dc.l	$ff3a6700,$00b449fa,$01ec2880,$610000dc
	dc.l	$2c4d49fa,$01e8220c,$243c0000,$03ee4eae

_PACK10
	move.l	$262(a0),d0		;Length Of Decrunched Data
	lea	$26a(a0),a3		;Start Address Of Crunched Data
	move.l	$266(a0),a0
	add.l	a3,a0			;End Address Of Crunched Data
	bra.b	upackit
;------------------------------------------------------------------------------
; 1.0 Data

PACK10D	dc.w	pak10-pack10d,pack10dt-pack10d,CN_PackIt10D,typenum
	dc.b	CRU_Data,PSF_Data
	dc.w	$18
	dc.l	"PIcd"
	dc.w	0,_pack10d-pack10d,0

PACK10DT PSNAME	"PackIt 1.0 Data"

_PACK10D
	lea	4(a0),a3		;Start Address Of Crunched Data
	add.l	UI_CrunchLenTemp(a4),a0	;End Address Of Crunched Data
	move.l	-4(a0),d0		;Length Of Decrunched Data
;;	bra.b	upackit
;------------------------------------------------------------------------------
; PackIt Initializing Routine
;

UPACKIT	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmem			;Allocate Memory
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out
	move.l	d0,a1
	bsr.b	pacit
	moveq	#-1,d0
.OUT	rts
;------------------------------------------------------------------------------
; PackIt Decruncher
;

PACIT	moveq	#-1,d7
	move.l	-(a0),a2
	add.l	a1,a2
	move.l	-(a0),d0
PACIT1	moveq	#0,d3
	lsr.l	#1,d0
	bne.b	pacit2
	bsr.b	pacit9
PACIT2	bcs.b	pacit7
PACIT3	moveq	#2,d1
	bsr.b	pacit10
	add.w	d2,d3
	cmp.w	#3,d2
	beq.b	pacit3
PACIT4	moveq	#7,d1
PACIT5	lsr.l	#1,d0
	bne.b	pacit6
	bsr.b	pacit9
PACIT6	roxl.w	#1,d2
	dbra	d1,pacit5
	move.b	d2,-(a2)
	cmp.l	a1,a2
	dbeq	d3,pacit4
	cmp.w	d7,d3
	beq.b	pacit7
	rts				;Get Out

PACIT7	moveq	#3,d1
	bsr.b	pacit10
	cmp.b	#3,d2
	beq.b	pacit13
	cmp.b	#7,d2
	beq.b	pacit13
	move.b	(a3,d2.w),d1
	ext.w	d1
	and.b	#3,d2
	addq.w	#1,d2
	move.w	d2,d3
	bsr.b	pacit10
	addq.w	#1,d2
PACIT8	move.b	-1(a2,d2.w),-(a2)
	cmp.l	a1,a2
	dbeq	d3,pacit8
	cmp.w	d7,d3
	beq.b	pacit1
	rts				;Get Out

PACIT9	move.l	-(a0),d0
	move.w	#$0010,ccr
	roxr.l	#1,d0
	rts

PACIT10	subq.w	#1,d1
	clr.w	d2
PACIT11	lsr.l	#1,d0
	bne.b	pacit12
	bsr.b	pacit9
PACIT12	roxl.w	#1,d2
	dbra	d1,pacit11
	rts

PACIT13	move.b	(a3,d2.w),d1
	ext.w	d1
	bsr.b	pacit10
	addq.w	#1,d2
	move.w	d2,d3
	moveq	#-1,d4
PACIT14	addq.l	#1,d4
	moveq	#1,d1
	bsr.b	pacit10
	tst.w	d2
	bne.b	pacit14
	add.w	d4,d4
	addq.l	#3,d4
	move.w	d4,d1
	bsr.b	pacit10
	addq.w	#4,d2
	exg	d2,d3
	bra.b	pacit8
;------------------------------------------------------------------------------
