;******************************************************************************
;* Pak                                                                        *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.0

PAK10	dc.w	phd-pak10,pak10t-pak10,CN_Pak10,typenum
	dc.b	CRU_Archive,0
	dc.w	StartLoad
	dc.l	0
	dc.w	pak10d-pak10,_pak10-pak10,0

PAK10T	PSNAME	"Pak 1.0"

PAK10D	dc.w	0,8-1
	dc.l	$60021234,$48e77ffe,$43fa00ca,$2c780004
	dc.l	$4eaefdd8,$2c4045fa,$ffe8202a,$fffce580


_PAK10	move.l	a6,-(sp)

	move.l	a4,a0
	jsr	upLoadFile(a6)		;Read The File
	tst.w	d0
	beq.w	upaker

	move.l	UI_DecrunchAdr(a4),UI_CrunchAdr(a4)
	move.l	UI_DecrunchLen(a4),UI_CrunchLen(a4)
	clr.l	UI_DecrunchAdr(a4)
	clr.l	UI_DecrunchLen(a4)

; Unpack The File

	move.w	#UERR_Memory,UI_ErrorNum(a4)
	move.l	#StartLoad,d0
	bsr.w	alcmem			;Allocate Unpack Buffer
	beq.w	upaker
	move.l	d0,-(sp)

	move.w	#UERR_Open,UI_ErrorNum(a4)
	move.l	LIB_DosBase(a5),a6
	move.l	UI_Path(a4),d1
	moveq	#-2,d2
	jsr	Lock(a6)		;Lock Path
	move.l	d0,UI_Temp(a4)
	bne.b	upak0

	lea	-256(sp),sp
	move.l	UI_Path(a4),a0
	move.l	sp,a1
UPAK00	move.b	(a0)+,(a1)+		;Copy Path
	bne.b	upak00
	cmp.b	#"/",-2(a1)
	bne.b	upak01
	clr.b	-2(a1)

UPAK01	move.w	#UERR_Directory,UI_ErrorNum(a4)
	move.l	sp,d1
	jsr	CreateDir(a6)
	lea	256(sp),sp
	tst.l	d0
	beq.w	upaker1
	move.l	d0,d1
	jsr	Unlock(a6)

	move.l	UI_Path(a4),d1
	moveq	#-2,d2
	jsr	Lock(a6)		;Lock Path
	move.l	d0,UI_Temp(a4)
	beq.w	upaker1

UPAK0	move.l	d0,d1
	jsr	CurrentDir(a6)
	move.l	d0,-(sp)

	movem.l	a4-a5,-(sp)
	move.l	UI_CrunchAdr(a4),a5
	move.l	16(a5),d0
	sub.l	12(a5),d0
	lsl.l	#2,d0
	lea	32(a5,d0.l),a5
	move.l	-4(a5),d0
	lsl.l	#2,d0
	lea	16(a5,d0.l),a5		;Start Of Crunched Data
	move.l	-4(a5),d0		;Crunched Length

	lea	UI_LoadName(a4),a0
	move.l	a0,-(sp)
	move.l	16(sp),a2		;Buffer Address
	lea	(a5,d0.l),a4
UPAK1	cmp.l	a4,a5
	bcc.b	upak9
	addq.l	#4,a5
	move.l	(a5)+,d7		;Decrunched Length

	move.l	a5,a0
	move.l	(sp),a1			;UI_LoadName
UPAK2	move.b	(a0)+,(a1)+		;Copy Filename
	bne.b	upak2

	move.l	a5,d1
	move.l	#1006,d2
	jsr	Open(a6)		;Open Write File
	move.l	d0,d4
	beq.b	upak8

UPAK3	move.w	(a5)+,d0
	tst.b	d0
	bne.b	upak3
	move.l	a5,a3
	add.w	2(a3),a5
	moveq	#0,d6
UPAK4	moveq	#0,d3
UPAK5	subq.l	#1,d7
	bmi.b	upak6
	bsr.b	upak13
	move.b	d0,(a2,d3.w)
	addq.w	#1,d3
	cmp.w	#StartLoad,d3
	bcs.b	upak5
UPAK6	tst.l	d3
	beq.b	upak7
	move.l	d4,d1
	move.l	a2,d2
	jsr	Write(a6)		;Write A Little Bit Of The File
	cmp.l	d3,d0
	beq.b	upak4
	moveq	#0,d7
UPAK7	move.l	d4,d1
	jsr	Close(a6)		;Close The File

	movem.l	d0-d7/a0-a6,-(sp)
	movem.l	15*4+4(sp),a4-a5
	bsr.w	scanjmp			;Scan File
	bsr.w	udel
UPAK7a	movem.l	(sp)+,d0-d7/a0-a6
	tst.l	d7
	bmi.b	upak1

UPAK8	moveq	#-1,d0
	bra.b	upak10

UPAK9	moveq	#0,d0
UPAK10	addq.l	#4,sp
	movem.l	(sp)+,a4-a5
	bra.b	upak19

UPAK11	dbra	d6,upak12
	move.w	(a5)+,d5
	moveq	#16-1,d6
UPAK12	asl.w	#1,d5
	rts

UPAK13	clr.w	d2
	move.b	(a3),d1
	bmi.b	upak14
	bsr.b	upak11
	bcc.b	upak15
	bset	d1,d2
UPAK14	move.b	1(a3),d1
UPAK15	clr.w	d0
	move.b	d1,-(sp)
UPAK16	subq.b	#1,d1
	bmi.b	upak17
	bsr.b	upak11
	roxl.b	#1,d0
	bra.b	upak16

UPAK17	cmp.b	#8,(sp)+
	bcc.b	upak18
	add.w	d2,d0
	move.b	4(a3,d0.w),d0
UPAK18	rts

; Scan The Files

UPAK19	move.l	(sp)+,d1
	jsr	CurrentDir(a6)

	move.l	UI_Temp(a4),d1
	jsr	UnLock(a6)
	clr.l	UI_Temp(a4)

	move.l	(sp)+,a1
	bsr.w	fremem			;Free Unpack Buffer

	move.l	UI_CrunchAdr(a4),a1
	bsr.w	fremem			;Free Crunched Memory
	clr.l	UI_CrunchAdr(a4)
	clr.l	UI_CrunchLen(a4)

UPAKO	move.l	(sp)+,a6
	moveq	#-1,d0
	rts

UPAKER1	move.l	(sp)+,a1
	bsr.w	fremem			;Free Unpack Buffer

UPAKER	move.l	(sp)+,a6
	moveq	#0,d0
	rts
;------------------------------------------------------------------------------
