;******************************************************************************
;* ProPack (RNC)                                                              *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; (Mode 1)

RNC1	dc.w	rnc1v-rnc1,rnc1t-rnc1,CN_PPRNC1,typenum
	dc.b	CRU_Object,0
	dc.w	$2a4+header_len+min_length
	dc.l	0
	dc.w	rnc1da-rnc1,_rnc1-rnc1,0

RNC1T	PSNAME	"ProPack (RNC) Mode 1"

RNC1DA	dc.w	$0,8-1
	dc.l	$487a025e,$48e7fffe,$487afff2,$203c0000
	dc.l	$01807201,$2c780004,$4eaeff3a,$72fc4a80

_RNC1
	lea	unpackrnc1(pc),a5
	bra.w	uxrnc
;------------------------------------------------------------------------------
; Validate (Mode 1)

RNC1V	dc.w	rnc1k-rnc1v,rnc1vt-rnc1v,CN_PPRNC1V,typenum
	dc.b	CRU_Object,0
	dc.w	$2f8+header_len+min_length
	dc.l	0
	dc.w	rnc1vda-rnc1v,_rnc1v-rnc1v,0

RNC1VT	PSNAME	"ProPack (RNC) Validate Mode 1"

RNC1VDA	dc.w	$0,8-1
	dc.l	$487a02b8,$48e7fffe,$487afff2,$203c0000
	dc.l	$02007201,$2c780004,$4eaeff3a,$72fc4a80

_RNC1V
	lea	unpackrnc1(pc),a5
	bra.w	uxrnc
;------------------------------------------------------------------------------
; Key (Mode 1)

RNC1K	dc.w	rnc1vk-rnc1k,rnc1kt-rnc1k,CN_PPRNC1K,typenum
	dc.b	CRU_Object,PSF_Encrypted
	dc.w	$2a8+header_len+min_length
	dc.l	0
	dc.w	rnc1kda-rnc1k,_rnc1k-rnc1k,0

RNC1KT	PSNAME	"ProPack (RNC) Key Mode 1"

RNC1KDA	dc.w	$0,8-1
	dc.l	$487a026a,$48e7fffe,$487afff2,$203c0000
	dc.l	$01807201,$2c780004,$4eaeff3a,$72fc4a80

_RNC1K
	lea	unpackrnc1(pc),a5
	lea	uxrnca(pc),a6
	bra.w	urnck
;------------------------------------------------------------------------------
; Validate Key (Mode 1)

RNC1VK	dc.w	rnc1m68-rnc1vk,rnc1vkt-rnc1vk,CN_PPRNC1VK,typenum
	dc.b	CRU_Object,PSF_Encrypted
	dc.w	$360+header_len+min_length
	dc.l	0
	dc.w	rnc1vkda-rnc1vk,_rnc1vk-rnc1vk,0

RNC1VKT	PSNAME	"ProPack (RNC) Validate Key Mode 1"

RNC1VKDA dc.w	$0,8-1
	dc.l	$487a02c4,$48e7fffe,$487afff2,$203c0000
	dc.l	$02007201,$2c780004,$4eaeff3a,$72fc4a80

_RNC1VK
	lea	unpackrnc1(pc),a5
	lea	uxrnca(pc),a6
	bra.w	urnck
;------------------------------------------------------------------------------
; 68000 (Mode 1)

RNC1M68	dc.w	rnc1m68v-rnc1m68,rnc1m68t-rnc1m68,CN_PPRNC168000,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	$232+header_len+min_length
	dc.l	0
	dc.w	_rnc1m68t-rnc1m68,_rnc1m68-rnc1m68,0

RNC1M68T PSNAME	"ProPack (RNC) 68000 Mode 1"

_RNC1M68T
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+1,$232(a0)
	bne.b	.out
	cmp.l	#$303c0038,$6e(a0)
	bne.b	.out
	cmp.l	#$41ea0080,$ac(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC1M68
	lea	$232(a0),a0
	lea	unpackrnc1(pc),a5
	bra.w	urnc
;------------------------------------------------------------------------------
; 68000 Validate (Mode 1)

RNC1M68V dc.w	rnc1m68k-rnc1m68v,rnc1m68vt-rnc1m68v,CN_PPRNC168000V,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	$284+header_len+min_length
	dc.l	0
	dc.w	_rnc1m68vt-rnc1m68v,_rnc1m68v-rnc1m68v,0

RNC1M68VT PSNAME "ProPack (RNC) 68000 Validate Mode 1"

_RNC1M68VT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+1,$284(a0)
	bne.b	.out
	cmp.l	#$303c0040,$7e(a0)
	bne.b	.out
	cmp.l	#$41ea0080,$bc(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC1M68V
	lea	$284(a0),a0
	lea	unpackrnc1(pc),a5
	bra.w	urnc
;------------------------------------------------------------------------------
; 68000 Key (Mode 1)

RNC1M68K dc.w	rnc1m68vk-rnc1m68k,rnc1m68kt-rnc1m68k,CN_PPRNC168000K,typenum
	dc.b	CRU_Data,PSF_Encrypted!PSF_RecogFunc
	dc.w	$23e+header_len+min_length
	dc.l	0
	dc.w	_rnc1m68kt-rnc1m68k,_rnc1m68k-rnc1m68k,0

RNC1M68KT PSNAME "ProPack (RNC) 68000 Key Mode 1"

_RNC1M68KT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+1,$23e(a0)
	bne.b	.out
	cmp.l	#$303c003a,$6e(a0)
	bne.b	.out
	cmp.l	#$41ea0080,$b2(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC1M68K
	lea	$23e(a0),a0
	lea	unpackrnc1(pc),a5
	lea	urnca(pc),a6
	bra.w	urnck
;------------------------------------------------------------------------------
; 68000 Validate Key (Mode 1)

RNC1M68VK dc.w	rnc1d-rnc1m68vk,rnc1m68vkt-rnc1m68vk,CN_PPRNC168000VK,typenum
	dc.b	CRU_Data,PSF_Encrypted!PSF_RecogFunc
	dc.w	$290+header_len+min_length
	dc.l	0
	dc.w	_rnc1m68vkt-rnc1m68vk,_rnc1m68vk-rnc1m68vk,0

RNC1M68VKT PSNAME "ProPack (RNC) 68000 Validate Key Mode 1"

_RNC1M68VKT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+1,$290(a0)
	bne.b	.out
	cmp.l	#$303c0042,$7e(a0)
	bne.b	.out
	cmp.l	#$41ea0080,$c2(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC1M68VK
	lea	$290(a0),a0
	lea	unpackrnc1(pc),a5
	lea	urnca(pc),a6
	bra.w	urnck
;------------------------------------------------------------------------------
; Data (Mode 1)

RNC1D	dc.w	rnc1dk-rnc1d,rnc1dt-rnc1d,CN_PPRNC1D,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	header_len+min_length
	dc.l	0
	dc.w	_rnc1dt-rnc1d,_rnc1d-rnc1d,0

RNC1DT	PSNAME	"ProPack (RNC) Data Mode 1"

_RNC1DT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+1,(a0)
	bne.b	.out
	btst	#1,$12(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC1D
	lea	unpackrnc1(pc),a5
	bra.w	urnc
;------------------------------------------------------------------------------
; Data Key (Mode 1)

RNC1DK	dc.w	rnc2-rnc1dk,rnc1dkt-rnc1dk,CN_PPRNC1DK,typenum
	dc.b	CRU_Data,PSF_Encrypted!PSF_RecogFunc
	dc.w	header_len+min_length
	dc.l	0
	dc.w	_rnc1dkt-rnc1dk,_rnc1dk-rnc1dk,0

RNC1DKT	PSNAME	"ProPack (RNC) Data Key Mode 1"

_RNC1DKT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+1,(a0)
	bne.b	.out
	btst	#1,$12(a0)
	beq.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC1DK
	lea	unpackrnc1(pc),a5
	lea	urnca(pc),a6
	bra.w	urnck
;------------------------------------------------------------------------------
; (Mode 2)

RNC2	dc.w	rnc2v-rnc2,rnc2t-rnc2,CN_PPRNC2,typenum
	dc.b	CRU_Object,0
	dc.w	$220+header_len+min_length
	dc.l	0
	dc.w	rnc2da-rnc2,_rnc2-rnc2,0

RNC2T	PSNAME	"ProPack (RNC) Mode 2"

RNC2DA	dc.w	$0,8-1
	dc.l	$487a01e0,$48e7fffe,$487afff2,$2a574a95
	dc.l	$670001b8,$2a55dbcd,$dbcd2e8d,$584d41ed

_RNC2
	lea	unpackrnc2(pc),a5
	bra.w	uxrnc
;------------------------------------------------------------------------------
; Validate (Mode 2)

RNC2V	dc.w	rnc2k-rnc2v,rnc2vt-rnc2v,CN_PPRNC2V,typenum
	dc.b	CRU_Object,0
	dc.w	$294+header_len+min_length
	dc.l	0
	dc.w	rnc2vda-rnc2v,_rnc2v-rnc2v,0

RNC2VT	PSNAME	"ProPack (RNC) Validate Mode 2"

RNC2VDA	dc.w	$0,8-1
	dc.l	$487a0200,$48e7fffe,$487afff2,$2a574a95
	dc.l	$670001d8,$2a55dbcd,$dbcd2e8d,$584d41ed

_RNC2V
	lea	unpackrnc2(pc),a5
	bra.w	uxrnc
;------------------------------------------------------------------------------
; Key (Mode 2)

RNC2K	dc.w	rnc2vk-rnc2k,rnc2kt-rnc2k,CN_PPRNC2K,typenum
	dc.b	CRU_Object,PSF_Encrypted
	dc.w	$244+header_len+min_length
	dc.l	0
	dc.w	rnc2kda-rnc2k,_rnc2k-rnc2k,0

RNC2KT	PSNAME	"ProPack (RNC) Key Mode 2"

RNC2KDA	dc.w	$0,8-1
	dc.l	$487a0202,$48e7fffe,$487afff2,$2a574a95
	dc.l	$670001da,$2a55dbcd,$dbcd2e8d,$584d41ed

_RNC2K
	lea	unpackrnc2(pc),a5
	lea	uxrnca(pc),a6
	bra.w	urnck
;------------------------------------------------------------------------------
; Validate Key (Mode 2)

RNC2VK	dc.w	rnc2m68-rnc2vk,rnc2vkt-rnc2vk,CN_PPRNC2VK,typenum
	dc.b	CRU_Object,PSF_Encrypted
	dc.w	$2a0+header_len+min_length
	dc.l	0
	dc.w	rnc2vkda-rnc2vk,_rnc2vk-rnc2vk,0

RNC2VKT	PSNAME	"ProPack (RNC) Validate Key Mode 2"

RNC2VKDA dc.w	$0,8-1
	dc.l	$487a0222,$48e7fffe,$487afff2,$2a574a95
	dc.l	$670001fa,$2a55dbcd,$dbcd2e8d,$584d41ed

_RNC2VK
	lea	unpackrnc2(pc),a5
	lea	uxrnca(pc),a6
	bra.w	urnck
;------------------------------------------------------------------------------
; 68000 (Mode 2)

RNC2M68	dc.w	rnc2m68v-rnc2m68,rnc2m68t-rnc2m68,CN_PPRNC268000,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	$1f8+header_len+min_length
	dc.l	0
	dc.w	_rnc2m68t-rnc2m68,_rnc2m68-rnc2m68,0

RNC2M68T PSNAME	"ProPack (RNC) 68000 Mode 2"

_RNC2M68T
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+2,$1f8(a0)
	bne.b	.out
	cmp.l	#$303c0032,$68(a0)
	bne.b	.out
	cmp.l	#$51cefff6,$ca(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC2M68
	lea	$1f8(a0),a0
	lea	unpackrnc2(pc),a5
	bra.w	urnc
;------------------------------------------------------------------------------
; 68000 Validate (Mode 2)

RNC2M68V dc.w	rnc2m68k-rnc2m68v,rnc2m68vt-rnc2m68v,CN_PPRNC268000V,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	$252+header_len+min_length
	dc.l	0
	dc.w	_rnc2m68vt-rnc2m68v,_rnc2m68v-rnc2m68v,0

RNC2M68VT PSNAME "ProPack (RNC) 68000 Validate Mode 2"

_RNC2M68VT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+2,$252(a0)
	bne.b	.out
	cmp.l	#$303c003b,$78(a0)
	bne.b	.out
	cmp.l	#$51cefff6,$da(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC2M68V
	lea	$252(a0),a0
	lea	unpackrnc2(pc),a5
	bra.w	urnc
;------------------------------------------------------------------------------
; 68000 Key (Mode 2)

RNC2M68K dc.w	rnc2m68vk-rnc2m68k,rnc2m68kt-rnc2m68k,CN_PPRNC268000K,typenum
	dc.b	CRU_Data,PSF_Encrypted!PSF_RecogFunc
	dc.w	$22e+header_len+min_length
	dc.l	0
	dc.w	_rnc2m68kt-rnc2m68k,_rnc2m68k-rnc2m68k,0

RNC2M68KT PSNAME "ProPack (RNC) 68000 Key Mode 2"

_RNC2M68KT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+2,$22e(a0)
	bne.b	.out
	cmp.l	#$303c0038,$68(a0)
	bne.b	.out
	cmp.l	#$51ceffe6,$ea(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC2M68K
	lea	$22e(a0),a0
	lea	unpackrnc2(pc),a5
	lea	urnca(pc),a6
	bra.w	urnck
;------------------------------------------------------------------------------
; 68000 Validate Key (Mode 2)

RNC2M68VK dc.w	rnc2d-rnc2m68vk,rnc2m68vkt-rnc2m68vk,CN_PPRNC268000VK,typenum
	dc.b	CRU_Data,PSF_Encrypted!PSF_RecogFunc
	dc.w	$288+header_len+min_length
	dc.l	0
	dc.w	_rnc2m68vkt-rnc2m68vk,_rnc2m68vk-rnc2m68vk,0

RNC2M68VKT PSNAME "ProPack (RNC) 68000 Validate Key Mode 2"

_RNC2M68VKT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+2,$288(a0)
	bne.b	.out
	cmp.l	#$303c0042,$78(a0)
	bne.b	.out
	cmp.l	#$51ceffe6,$fa(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC2M68VK
	lea	$288(a0),a0
	lea	unpackrnc2(pc),a5
	lea	urnca(pc),a6
	bra.w	urnck
;------------------------------------------------------------------------------
; Data (Mode 2)

RNC2D	dc.w	rnc2dk-rnc2d,rnc2dt-rnc2d,CN_PPRNC2D,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	header_len+min_length
	dc.l	0
	dc.w	_rnc2dt-rnc2d,_rnc2d-rnc2d,0

RNC2DT	PSNAME	"ProPack (RNC) Data Mode 2"

_RNC2DT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+2,(a0)
	bne.b	.out
	btst	#6,$12(a0)
	bne.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC2D
	lea	unpackrnc2(pc),a5
	bra.w	urnc
;------------------------------------------------------------------------------
; Data Key (Mode 2)

RNC2DK	dc.w	relo10-rnc2dk,rnc2dkt-rnc2dk,CN_PPRNC2DK,typenum
	dc.b	CRU_Data,PSF_Encrypted!PSF_RecogFunc
	dc.w	header_len+min_length
	dc.l	0
	dc.w	_rnc2dkt-rnc2dk,_rnc2dk-rnc2dk,0

RNC2DKT	PSNAME	"ProPack (RNC) Data Key Mode 2"

_RNC2DKT
	moveq	#0,d0			;Unknown
	cmp.l	#"RNC"<<8+2,(a0)
	bne.b	.out
	btst	#6,$12(a0)
	beq.b	.out
	moveq	#-1,d0			;Ok
.OUT	rts

_RNC2DK
	lea	unpackrnc2(pc),a5
	lea	urnca(pc),a6
;------------------------------------------------------------------------------
; RNC Unpacking Routine
;

URNCK	moveq	#UERR_Password,d6
	move.w	d6,UI_ErrorNum(a4)
	lea	UI_PasswordStr(a4),a1
	moveq	#0,d0
	cmp.w	#"0x",(a1)
	beq.b	.hex
	cmp.b	#"$",(a1)
	beq.b	.hex1
	move.l	a1,a2
.DEC1	move.b	(a1)+,d1
	beq.b	.dec2
	cmp.b	#"0"-1,d1
	bls.w	urncer
	cmp.b	#"9",d1
	bhi.w	urncer
	bra.b	.dec1

.DEC2	subq.l	#1,a1
	moveq	#1,d2
.DEC3	moveq	#0,d1
	move.b	-(a1),d1
	sub.b	#"0",d1
	mulu	d2,d1
	add.l	d1,d0
	mulu	#10,d2
	cmp.l	a2,a1
	bne.b	.dec3
.JMP	jmp	(a6)

.HEX	addq.l	#1,a1
.HEX1	addq.l	#1,a1
.HEX2	moveq	#0,d1
	move.b	(a1)+,d1
	beq.b	.jmp
	cmp.b	#"0"-1,d1
	bls.b	urncer
	cmp.b	#"9",d1
	bls.b	.hex3
	and.b	#%11011111,d1
	cmp.b	#"A"-1,d1
	bls.b	urncer
	cmp.b	#"F",d1
	bhi.b	urncer
.HEX3	sub.b	#"0",d1
	cmp.b	#9,d1
	bls.b	.hex4
	subq.b	#7,d1
.HEX4	lsl.l	#4,d0
	or.l	d1,d0
	bra.b	.hex2


URNC	moveq	#0,d0			;No Key
	moveq	#UERR_Corrupt,d6
URNCa	move.w	d0,d7
	move.w	#UERR_Memory,UI_ErrorNum(a4)
	move.l	4(a0),d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	urncout

	move.l	d0,a1			;Decrunch Address
	move.w	d7,d0			;Key
	jsr	(a5)			;Unpack Data
	tst.l	d0
	bpl.b	urncout
URNCER1	move.w	d6,UI_ErrorNum(a4)
URNCER	moveq	#0,d0
URNCOUT	rts
;------------------------------------------------------------------------------
; Execute Decrunch
;

UXRNC	moveq	#0,d0			;No Key
	moveq	#UERR_Corrupt,d6

UXRNCa	move.w	d0,d7
	move.l	16(a0),d3		;Number Of Hunks
	move.l	d3,d1
	sub.l	12(a0),d1
	lsl.l	#2,d1
	lea	$20(a0,d1.l),a0

	move.l	-4(a0),d0
	lsl.l	#2,d0
	lea	4(a0,d0.l),a0
	move.l	a0,a3

	move.l	d3,d1
	moveq	#20,d2			;Start Number Of Bytes
.UXRNC1	cmp.l	#$3eb,(a0)
	bne.b	.uxrnc3
	lea	12(a0),a0
	bra.b	.uxrnc4

.UXRNC3	cmp.l	#4,4(a0)
	bls.b	.uxrn3a
	move.l	16(a0),d0
	lsr.l	#8,d0
	cmp.l	#"RNC",d0
	beq.b	.uxrn3d
.UXRN3a	move.l	4(a0),d0
	lsl.l	#2,d0
	add.l	d0,d2
	lea	8(a0,d0.l),a0
	cmp.l	#$3ec,(a0)+
	bne.b	.uxrnc4
	addq.l	#4,d2
.UXRN3b	addq.l	#4,d2
	move.l	(a0)+,d0
	beq.b	.uxrn3c
	addq.l	#4,a0
	addq.l	#4,d2
	lsl.l	#2,d0
	add.l	d0,d2
	add.l	d0,a0
	bra.b	.uxrn3b

.UXRN3c	addq.l	#4,a0
	bra.b	.uxrnc4

.UXRN3d	add.l	$14(a0),d2
	move.l	4(a0),d0
	addq.l	#3,d0
	lsl.l	#2,d0
	add.l	d0,a0
.UXRNC4	addq.l	#8,d2			;Hunk Header
	addq.l	#8,d2			;Hunk_End + Hunk Length
	subq.l	#1,d1
	bne.b	.uxrnc1

	move.w	#UERR_Memory,UI_ErrorNum(a4)
	move.l	d2,d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	.out

; Start To Rebuild Object File

	move.l	a4,-(sp)
	move.l	d0,a2
	move.l	#$3f3,(a2)+
	clr.l	(a2)+
	move.l	d3,(a2)+
	clr.l	(a2)+
	move.l	d3,(a2)
	subq.l	#1,(a2)+

	move.l	UI_CrunchAdrTemp(a4),a6
	lea	$18(a6),a6
	move.l	a2,a4
	move.l	d3,d0
	lsl.l	#2,d0
	add.l	d0,a2
.UXRNC5	move.l	(a3),d0
	move.l	d0,(a2)+
	cmp.l	#$3eb,d0
	bne.b	.uxrnc7
	addq.l	#4,a3
	move.l	(a3)+,(a2)+		;Hunk Length
	move.l	(a6)+,(a4)+		;Hunk Length In Hunk Header
	move.l	(a3)+,(a2)+		;Hunk End
	bra.w	.uxrnc8

.UXRNC7	cmp.l	#4,4(a3)
	bls.b	.uxrn7a
	move.l	16(a3),d0
	lsr.l	#8,d0
	cmp.l	#"RNC",d0
	beq.b	.uxrn7f
.UXRN7a	move.l	(a6)+,(a4)+
	addq.l	#4,a3
	move.l	(a3)+,d0
	move.l	d0,(a2)+		;Hunk Length
	beq.b	.uxrn7z
.UXRN7b	move.l	(a3)+,(a2)+		;Copy Hunk
	subq.l	#1,d0
	bne.b	.uxrn7b

.UXRN7z	move.l	(a3)+,d0
	move.l	d0,(a2)+		;Copy Hunk_End Or Hunk_Reloc
	cmp.l	#$3ec,d0
	bne.b	.uxrnc8
.UXRN7c	move.l	(a3)+,d0		;Number Of Relocs
	move.l	d0,(a2)+
	beq.b	.uxrn7e
	move.l	(a3)+,(a2)+		;Hunk Number
.UXRN7d	move.l	(a3)+,(a2)+		;Relocs
	subq.l	#1,d0
	bne.b	.uxrn7d
	bra.b	.uxrn7c

.UXRN7e	move.l	(a3)+,(a2)+		;Hunk_End
	bra.b	.uxrnc8

.UXRN7f	move.l	8(a3),d0
	lsr.l	#2,d0
	move.l	d0,(a2)+		;Hunk Length
	move.l	12(a3),(a4)+		;Hunk Length In Hunk Header
	addq.l	#4,a6

	lea	16(a3),a0		;Crunched Data
	move.l	a2,a1			;Decrunch Address
	move.w	d7,d0			;Key
	move.l	a4,-(sp)
	move.l	4(sp),a4
	jsr	(a5)			;Unpack Data
	move.l	(sp)+,a4
	tst.l	d0
	bpl.b	.uxrn7g
	move.l	(sp)+,a4
	bra.w	urncer1

.UXRN7g	add.l	$14(a3),a2
	move.l	#$3f2,(a2)+

	move.l	4(a3),d0
	addq.l	#3,d0
	lsl.l	#2,d0
	add.l	d0,a3
.UXRNC8	subq.l	#1,d3
	bne.w	.uxrnc5
	move.l	(sp)+,a4
	moveq	#-1,d0
.OUT	rts
*------------------------------------------------------------------------------
* Conditional Assembly Flags
*------------------------------------------------------------------------------
CHECKSUMS	EQU	1	; set this flag to 1 if you require
				; the data to be validated

PROTECTED	EQU	1	;set this flag to 1 if you are unpacking
				; a file packed with option "-K"
*------------------------------------------------------------------------------
* Return Codes
*------------------------------------------------------------------------------
PACKED_CRC	EQU	-1
UNPACKED_CRC	EQU	-2
WRONG_KEY	EQU	-3
*------------------------------------------------------------------------------
* Other Equates
*------------------------------------------------------------------------------
HEADER_LEN	EQU	18
MIN_LENGTH	EQU	2
CRC_POLY	EQU	$A001

; Only Mode 1

RAW_TABLE	EQU	0
POS_TABLE	EQU	RAW_TABLE+16*8
LEN_TABLE	EQU	POS_TABLE+16*8

		IFEQ	CHECKSUMS
BUFSIZE		EQU	16*8*3
		ELSE
BUFSIZE		EQU	512
		ENDC

counts		EQUR	d4
bit_buffer	EQUR	d6
bit_count	EQUR	d7

; Only Mode 2

len		EQUR	d4
pos		EQUR	d6
bitbuf		EQUR	d7

; Both Modes

key		EQUR	d5

inputr		EQUR	a3
inputr_hi	EQUR	a4
outputr		EQUR	a5
outputr_hi	EQUR	a6
*------------------------------------------------------------------------------
* PRO-PACK Unpack Source Code - MC68000, Method 1
*
* Copyright (c) 1991,92 Rob Northen Computing, U.K. All Rights Reserved.
*
* File: RNC_1.S
*
* Date: 24.3.92
*------------------------------------------------------------------------------
* Macros
*------------------------------------------------------------------------------
getrawREP1	MACRO
.getrawREP2\@
		move.b	(inputr)+,(outputr)
		IFNE PROTECTED
		eor.b	key,(outputr)+
		ENDC
		cmp.l	outputr_hi,outputr
		dbeq	d0,.getrawREP2\@
		cmp.w	#-1,d0
		bne.b	.unpack14
		IFNE PROTECTED
		ror.w	#1,key
		ENDC
		ENDM
*------------------------------------------------------------------------------
* PRO-PACK Unpack Routine - MC68000, Method 1
*
* on entry,
*	d0.w = packed data key, or 0 if file was not packed with a key
*	a0.l = start address of packed file
*	a1.l = start address to write unpacked file
* on exit,
*	d0.l = length of unpacked file in bytes OR error code
*		 0 = not a packed file
*		-1 = packed data CRC error
*		-2 = unpacked data CRC error
*		-3 = wrong key error
*
*	all other registers are preserved
*------------------------------------------------------------------------------
UnpackRNC1
		movem.l	d0-d7/a0-a6,-(sp)
		lea	-BUFSIZE(sp),sp
		move.l	sp,a2

		IFNE PROTECTED
		move.w	d0,key
		ENDC

		move.l	4(a0),d0
		move.l	d0,BUFSIZE(sp)
		move.w	UI_CrunchNum(a4),-(sp)
		lea	HEADER_LEN(a0),inputr
		move.l	a1,outputr
		lea	(outputr,d0.l),outputr_hi
		move.l	8(a0),d0
		lea	(inputr,d0.l),inputr_hi

		IFNE	CHECKSUMS
		move.l	inputr,a1
		bsr.w	crc_block
		move.l	-6(inputr),d0
		moveq	#PACKED_CRC,d1
		cmp.w	d2,d0
		bne.w	.unpack16
		swap	d0
		move.w	d0,-(sp)
		ENDC

.unpack7
		moveq	#0,bit_count
		move.b	1(inputr),bit_buffer
		rol.w	#8,bit_buffer
		move.b	(inputr),bit_buffer
		moveq	#2,d0
		moveq	#2,d1
		bsr.w	.input_bits
		cmp.w	#CN_PPRNC1K,2(sp)
		beq.b	.unpack7a
		cmp.w	#CN_PPRNC1VK,2(sp)
		beq.b	.unpack7a
		cmp.w	#CN_PPRNC168000K,2(sp)
		beq.b	.unpack7a
		cmp.w	#CN_PPRNC168000VK,2(sp)
		bne.b	.unpack8
.unpack7a	bsr.w	.input_bits0
		cmp.w	key,d0
		beq.b	.unpack8
		addq.l	#2,sp
		moveq	#WRONG_KEY,d1
		bra.w	.unpack16

.unpack8
		move.l	a2,a0
		bsr.w	.make_huftable
		lea	POS_TABLE(a2),a0
		bsr.w	.make_huftable
		lea	LEN_TABLE(a2),a0
		bsr.w	.make_huftable
.unpack9
		moveq	#-1,d0
		moveq	#16,d1
		bsr.w	.input_bits
		move.w	d0,counts
		subq.w	#1,counts
		bra.b	.unpack12
.unpack10
		lea	POS_TABLE(a2),a0
		moveq	#0,d0
		bsr.b	.input_value
		neg.l	d0
		lea	-1(outputr,d0.l),a1
		lea	LEN_TABLE(a2),a0
		bsr.b	.input_value
		move.b	(a1)+,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.b	.unpack14
.unpack11
		move.b	(a1)+,(outputr)+
		cmp.l	outputr_hi,outputr
		dbeq	d0,.unpack11
		cmp.w	#-1,d0
		bne.b	.unpack14
.unpack12
		move.l	a2,a0
		bsr.b	.input_value
		subq.w	#1,d0
		bmi.b	.unpack13
		getrawREP1
		move.b	1(inputr),d0
		rol.w	#8,d0
		move.b	(inputr),d0
		lsl.l	bit_count,d0
		moveq	#1,d1
		lsl.w	bit_count,d1
		subq.w	#1,d1
		and.l 	d1,bit_buffer
		or.l	d0,bit_buffer
.unpack13
		dbra	counts,.unpack10
		bra.b	.unpack8

.unpack14
		IFNE	CHECKSUMS
		move.l	BUFSIZE+4(sp),d0
		sub.l	d0,outputr
		move.l	outputr,a1
		bsr.w	crc_block
		moveq	#UNPACKED_CRC,d1
		cmp.w	(sp)+,d2
		beq.b	.unpack17
		ELSE
		bra.b	.unpack17
		ENDC
.unpack16
		move.l	d1,BUFSIZE+2(sp)
.unpack17
		lea	BUFSIZE+2(sp),sp
		movem.l	(sp)+,d0-d7/a0-a6
		rts

.input_value
		move.w	(a0)+,d0
		and.w	bit_buffer,d0
		sub.w	(a0)+,d0
		bne.b	.input_value
		move.b	16*4-4(a0),d1
		sub.b	d1,bit_count
		bge.b	.input_value2
		bsr.b	.input_bits3
.input_value2
		lsr.l	d1,bit_buffer
		move.b	16*4-3(a0),d0
		cmp.b	#2,d0
		blt.b	.input_value4
		subq.b	#1,d0
		move.b	d0,d1
		move.b	d0,d2
		move.w	16*4-2(a0),d0
		and.w	bit_buffer,d0
		sub.b	d1,bit_count
		bge.b	.input_value3
		bsr.b	.input_bits3
.input_value3
		lsr.l	d1,bit_buffer
		bset	d2,d0
.input_value4
		rts

.input_bits0	moveq	#-1,d0
		moveq	#16,d1

.input_bits
		and.w	bit_buffer,d0
		sub.b	d1,bit_count
		bge.b	.input_bits2
		bsr.b	.input_bits3
.input_bits2
		lsr.l	d1,bit_buffer
		rts

.input_bits3
		add.b	d1,bit_count
		lsr.l	bit_count,bit_buffer
		swap	bit_buffer
		addq.w	#4,inputr
		move.b	-(inputr),bit_buffer
		rol.w	#8,bit_buffer
		move.b	-(inputr),bit_buffer
		swap	bit_buffer
		sub.b	bit_count,d1
		moveq	#16,bit_count
		sub.b	d1,bit_count
		rts

.make_huftable
		moveq	#$1f,d0
		moveq	#5,d1
		bsr.b	.input_bits
		subq.w	#1,d0
		bmi.b	.make_huftable8
		move.w	d0,d2
		move.w	d0,d3
		lea	-16(sp),sp
		move.l	sp,a1
.make_huftable3
		moveq	#$f,d0
		moveq	#4,d1
		bsr.b	.input_bits
		move.b	d0,(a1)+
		dbra	d2,.make_huftable3
		moveq	#1,d0
		ror.l	#1,d0
		moveq	#1,d1
		moveq	#0,d2
		movem.l	d5-d7,-(sp)
.make_huftable4
		move.w	d3,d4
		lea	12(sp),a1
.make_huftable5
		cmp.b	(a1)+,d1
		bne.b	.make_huftable7
		moveq	#1,d5
		lsl.w	d1,d5
		subq.w	#1,d5
		move.w	d5,(a0)+
		move.l	d2,d5
		swap	d5
		move.w	d1,d7
		subq.w	#1,d7
.make_huftable6
		roxl.w	#1,d5
		roxr.w	#1,d6
		dbra	d7,.make_huftable6
		moveq	#16,d5
		sub.b	d1,d5
		lsr.w	d5,d6
		move.w	d6,(a0)+
		move.b	d1,16*4-4(a0)
		move.b	d3,d5
		sub.b	d4,d5
		move.b	d5,16*4-3(a0)
		moveq	#1,d6
		subq.b	#1,d5
		lsl.w	d5,d6
		subq.w	#1,d6
		move.w	d6,16*4-2(a0)
		add.l	d0,d2
.make_huftable7
		dbra	d4,.make_huftable5
		lsr.l	#1,d0
		addq.b	#1,d1
		cmp.b	#17,d1
		bne.b	.make_huftable4
		movem.l	(sp)+,d5-d7
		lea	16(sp),sp
.make_huftable8
		rts
;------------------------------------------------------------------------------
*------------------------------------------------------------------------------
* PRO-PACK Unpack Source Code - MC68000, Method 2
*
* Copyright (c) 1991,92 Rob Northen Computing, U.K. All Rights Reserved.
*
* File: RNC_2.S
*
* Date: 24.3.92
*------------------------------------------------------------------------------
* Macros
*------------------------------------------------------------------------------
getbit		MACRO
		add.b	bitbuf,bitbuf
		ENDM

reload		MACRO
		move.b	(inputr)+,bitbuf
		addx.b	bitbuf,bitbuf
		ENDM

getraw		MACRO
		IFEQ PROTECTED
		move.b	(inputr)+,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.b	.unpack9
		ELSE
		move.b	(inputr)+,d0
		eor.b	key,d0
		move.b	d0,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.b	.unpack9
		ror.w	#1,key
		ENDC
		ENDM

getrawREP2	MACRO
.getrawREP2\@
		IFEQ	PROTECTED
		move.b	(inputr)+,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		move.b	(inputr)+,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		move.b	(inputr)+,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		move.b	(inputr)+,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		ELSE
		move.b	(inputr)+,d0
		eor.b	key,d0
		move.b	d0,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		move.b	(inputr)+,d0
		eor.b	key,d0
		move.b	d0,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		move.b	(inputr)+,d0
		eor.b	key,d0
		move.b	d0,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		move.b	(inputr)+,d0
		eor.b	key,d0
		move.b	d0,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		ENDC
		dbra	pos,.getrawREP2\@
		IFNE	PROTECTED
		ror.w	#1,key
		ENDC
		ENDM
*------------------------------------------------------------------------------
* PRO-PACK Unpack Routine - MC68000, Method 2
*
* on entry,
*	d0.l = packed data key, or 0 if file was not packed with a key
*	a0.l = start address of packed file
*	a1.l = start address to write unpacked file
* on exit,
*	d0.l = length of unpacked file in bytes OR error code
*		 0 = not a packed file
*		-1 = packed data CRC error
*		-2 = unpacked data CRC error
*		-3 = wrong key error
*
*	all other registers are preserved
*------------------------------------------------------------------------------
UnpackRNC2
		movem.l	d0-d7/a0-a6,-(sp)
		lea	-$200(sp),sp
		move.l	sp,a2

		IFNE PROTECTED
		move.l	d0,key
		ENDC

		move.l	4(a0),d0
		move.l	d0,$200(sp)
		move.w	UI_CrunchNum(a4),-(sp)
		lea	HEADER_LEN(a0),inputr
		move.l	a1,outputr
		lea	(outputr,d0.l),outputr_hi
		move.l	8(a0),d0
		lea	(inputr,d0.l),inputr_hi

		IFNE	CHECKSUMS
		move.l	inputr,a1
		bsr.w	crc_block
		move.l	-6(inputr),d0
		moveq	#PACKED_CRC,d1
		cmp.w	d2,d0
		bne.w	.unpack10
		swap	d0
		move.w	d0,-(sp)
		ENDC

.unpack7
		moveq	#-$80,bitbuf
		add.b	bitbuf,bitbuf
		reload
		getbit

		cmp.w	#CN_PPRNC2K,2(sp)
		beq.b	.unpack7a
		cmp.w	#CN_PPRNC2VK,2(sp)
		beq.b	.unpack7a
		cmp.w	#CN_PPRNC268000K,2(sp)
		beq.b	.unpack7a
		cmp.w	#CN_PPRNC268000VK,2(sp)
		bne.w	.xLoop
.unpack7a	moveq	#15,d0
.unpack7b	getbit
		bne.b	.unpack7c
		reload
.unpack7c	addx.w	d1,d1
		dbra	d0,.unpack7b

		cmp.w	key,d1
		beq.w	.xLoop
		addq.l	#2,sp
		moveq	#WRONG_KEY,d1
		bra.w	.unpack10

.Fetch0
		reload
		bra.b	.Back0
.Fetch1
		reload
		bra.b	.Back1
.Fetch2
		reload
		bra.b	.Back2
.Fetch3
		reload
		bra.b	.Back3
.Fetch4
		reload
		bra.b	.Back4
.Fetch5
		reload
		bra.b	.Back5
.Fetch6
		reload
		bra.b	.Back6
.Fetch7
		reload
		bra.w	.Back7

.Raw
		moveq	#3,len
.x4Bits
		add.b	bitbuf,bitbuf
		beq.b	.Fetch0
.Back0
		addx.w	pos,pos
		dbra	len,.x4Bits
		addq.w	#2,pos
		getrawREP2
		bra.w	.xLoop

.GetLen
		getbit
		beq.b	.Fetch1
.Back1
		addx.w	len,len
		getbit
		beq.b	.Fetch2
.Back2
		bcc.b	.Copy
		subq.w	#1,len
		getbit
		beq.b	.Fetch3
.Back3
		addx.w	len,len

		cmp.b	#9,len
		beq.b	.Raw

.Copy
		getbit
		beq.b	.Fetch4
.Back4
		bcc.b	.ByteDisp2
		getbit
		beq.b	.Fetch5
.Back5
		addx.w	pos,pos
		getbit
		beq.b	.Fetch6
.Back6
		bcs.w	.BigDisp
		tst.w	pos
		bne.b	.ByteDisp
		addq.w	#1,pos
.Another
		getbit
		beq.w	.Fetch7
.Back7
		addx.w	pos,pos

.ByteDisp
		rol.w	#8,pos
.ByteDisp2
		move.b	(inputr)+,pos
		move.l	outputr,a0
		sub.w	pos,a0
		subq.w	#1,a0
		lsr.w	#1,len
		bcc.b	.ByteDisp3
		move.b	(a0)+,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
.ByteDisp3
		subq.w	#1,len
		tst.w	pos
		bne.b	.ByteDisp5
		move.b	(a0),pos
.ByteDisp4
		move.b	pos,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		move.b	pos,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		dbra	len,.ByteDisp4
		bra.b	.xLoop
.ByteDisp5
		move.b	(a0)+,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		move.b	(a0)+,(outputr)+
		cmp.l	outputr_hi,outputr
		beq.w	.unpack9
		dbra	len,.ByteDisp5
		bra.b	.xLoop

.GetBits
		reload
		bcs.b	.String
.xByte
		getraw
.xLoop
		getbit
		bcs.b	.Chkz
		getraw
		getbit
		bcc.b	.xByte
.Chkz
		beq.b	.GetBits

.String
		moveq	#2,len
		moveq	#0,pos
		getbit
		beq.b	.Fetch8
.Back8
		bcc.w	.GetLen

.Smalls
		getbit
		beq.b	.Fetch9
.Back9
		bcc.w	.ByteDisp2
		addq.w	#1,len
		getbit
		beq.b	.Fetch10
.Back10
		bcc.w	.Copy

		move.b	(inputr)+,len
		beq.b	.OverNout
		addq.w	#8,len
		bra.w	.Copy

.BigDisp
		getbit
		beq.b	.Fetch11
.Back11
		addx.w	pos,pos
		or.w	#4,pos
		getbit
		beq.b	.Fetch12
.Back12
		bcs.w	.ByteDisp
		bra.w	.Another

.Fetch8
		reload
		bra.b	.Back8
.Fetch9
		reload
		bra.b	.Back9
.Fetch10
		reload
		bra.b	.Back10
.Fetch11
		reload
		bra.b	.Back11
.Fetch12
		reload
		bra.b	.Back12
.OverNout
		getbit
		bne.b	.Check4end
		reload
.Check4end
		bcs.b	.xLoop

.unpack9
		IFNE	CHECKSUMS
		move.l	$200+4(sp),d0
		sub.l	d0,outputr
		move.l	outputr,a1
		bsr.b	crc_block
		moveq	#UNPACKED_CRC,d1
		cmp.w	(sp)+,d2
		beq.b	.unpack11
		ELSE
		bra.b	.unpack11
		ENDC
.unpack10
		move.l	d1,$200+2(sp)
.unpack11
		lea	$200+2(sp),sp
		movem.l	(sp)+,d0-d7/a0-a6
		rts
;------------------------------------------------------------------------------
; CRC Routines
;

		IFNE	CHECKSUMS
crc_block
		move.l	a2,a0
		moveq	#0,d3
.crc_block2
		move.l	d3,d1
		moveq	#7,d2
.crc_block3
		lsr.w	#1,d1
		bcc.b	.crc_block4
		eor.w	#CRC_POLY,d1
.crc_block4
		dbra	d2,.crc_block3
		move.w	d1,(a0)+
		addq.b	#1,d3
		bne.b	.crc_block2

		moveq	#0,d2
.crc_block5
		move.b	(a1)+,d1
		eor.b	d1,d2
		move.w	d2,d1
		and.w	#$ff,d2
		add.w	d2,d2
		move.w	(a2,d2.w),d2
		lsr.w	#8,d1
		eor.b	d1,d2
		subq.l	#1,d0
		bne.b	.crc_block5
		rts
		ENDC
;------------------------------------------------------------------------------
