;******************************************************************************
;* SyncroPacker                                                               *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 4.6

SYN46	dc.w	syn46p-syn46,syn46t-syn46,CN_Syncro46,typenum
	dc.b	CRU_Address,0
	dc.w	$190
	dc.l	0
	dc.w	syn46d-syn46,_syn46-syn46,0

SYN46T	PSNAME	"SyncroPacker 4.6"

SYN46D	dc.w	$10,12-1
SYN46D1	dc.l	$45fa0135,$14a0613e,$6734613a,$66287001
	dc.l	$61365405,$0c050005,$661c7001,$612a5a05
	dc.l	$0c050008,$66107002,$611e5005,$0c05000f

_SYN46
	move.b	$127(a0),d7
	lea	$158(a0),a6
	lea	$18c(a0),a0
	move.l	(a0)+,d0		;Crunched Length
	pea	sync46(pc)
	sf	d5
	bra.w	usyn46
;------------------------------------------------------------------------------
; 4.6 Professional

SYN46P	dc.w	syn46r-syn46p,syn46pt-syn46p,CN_Syncro46P,typenum
	dc.b	CRU_Address,0
	dc.w	$1d0
	dc.l	0
	dc.w	syn46pd-syn46p,_syn46p-syn46p,0

SYN46PT	PSNAME	"SyncroPacker 4.6 Pro"

SYN46PD	dc.w	$56,12-1
SYN46PD1 dc.l	$66f6225b,$1e201c20,$613e6734,$613a6628
	dc.l	$70016136,$54050c05,$0005661c,$7001612a
	dc.l	$5a050c05,$00086610,$7002611e,$50050c05

_SYN46P
	move.b	$167(a0),d7
	move.b	$169(a0),d6
	move.l	$72(a0),d0
	sub.l	$68(a0),d0
	subq.l	#4,d0			;Crunched Length
	lea	$198(a0),a6
	lea	$1cc(a0),a0
	pea	sync460(pc)
	st	d5
	bra.w	usyn46
;------------------------------------------------------------------------------
; 4.6 Raw

SYN46R	dc.w	syn46rp-syn46r,syn46rt-syn46r,CN_Syncro46R,typenum
	dc.b	CRU_Address,PSF_RecogFunc!PSF_NoHunk
	dc.w	$170
	dc.l	0
	dc.w	_syn46rt-syn46r,_syn46r-syn46r,0

SYN46RT	PSNAME	"SyncroPacker 4.6 Raw"

_SYN46RT
	moveq	#$10,d1
	moveq	#12-1,d2
	lea	syn46d1(pc),a1
	bra.w	chktabj

_SYN46R
	move.b	$107(a0),d7
	lea	$138(a0),a6
	lea	$16c(a0),a0
	move.l	(a0)+,d0		;Crunched Length
	pea	sync46(pc)
	sf	d5
	bra.b	usyn46
;------------------------------------------------------------------------------
; 4.6 Raw/Professional

SYN46RP	dc.w	tet102-syn46rp,syn46rpt-syn46rp,CN_Syncro46RP,typenum
	dc.b	CRU_Address,PSF_RecogFunc!PSF_NoHunk
	dc.w	$1b0
	dc.l	0
	dc.w	_syn46rpt-syn46rp,_syn46rp-syn46rp,0

SYN46RPT PSNAME	"SyncroPacker 4.6 Raw/Pro"

_SYN46RPT
	moveq	#$56,d1
	moveq	#12-1,d2
	lea	syn46pd1(pc),a1
	bra.w	chktabj


_SYN46RP
	move.b	$147(a0),d7
	move.b	$149(a0),d6
	move.l	$52(a0),d0
	sub.l	$48(a0),d0
	subq.l	#4,d0			;Crunched Length
	lea	$178(a0),a6
	lea	$1ac(a0),a0
	pea	sync460(pc)
	st	d5
;;	bra.b	usyn46
;------------------------------------------------------------------------------
; SyncroPacker 4.6 Initializing
;

USYN46	move.l	-4(a6),UI_JumpAdr(a4)

	move.l	a0,d2
	add.l	d0,a0
	sf	UI_Temp(a4)
	move.l	(sp),a2
	jsr	(a2)			;Count Pass 1 Length
	move.l	d3,d0
	bsr.w	alcmemj			;Allocate Pass 1 Memory
	beq.b	usyn46o
	move.l	(sp)+,a2
	move.l	d0,-(sp)
	move.l	d0,a1
	add.l	d3,a1
	st	UI_Temp(a4)
	jsr	(a2)			;Decrunch Pass 1

	move.l	(sp),a0			;Decrunched Start Address
	move.l	(a0),UI_Address(a4)
USYN46a	add.l	d3,a0
	lea	8(a1),a2
	move.b	d6,d4
	tst.b	d5
	bne.b	usyn46b
	move.b	(a2)+,d4
USYN46b	sf	UI_Temp(a4)
	bsr.w	sync246			;Count Pass 2 Length
	move.l	d3,UI_DecrunchLen(a4)
	sub.l	d3,UI_Address(a4)
	move.l	d3,d0
	bsr.w	alcdmemj		;Allocate Pass 2 Memory
	move.l	d0,UI_DecrunchAdr(a4)
	bne.b	usyn46c
	move.l	(sp)+,a1
	bsr.w	frememj			;Free Pass 1 Memory
	bra.b	usyn46o

USYN46c	move.l	d0,a1
	add.l	d3,a1
	st	UI_Temp(a4)
	bsr.w	sync246			;Decrunch Pass 2
	move.l	(sp)+,a1
	bsr.w	frememj			;Free Pass 1 Memory
	moveq	#-1,d0
USYN46O	rts
;------------------------------------------------------------------------------
; Syncro Packer 4.6 Decruncher
;

SYNC46	movem.l	d4-d7/a0/a3-a6,-(sp)
	move.b	-(a0),d7
	move.b	-(a0),d6
	lea	15(a6),a2
	move.b	-(a0),(a2)
	moveq	#0,d3
	bra.b	syn461

SYNC460	movem.l	d4-d7/a0/a3-a6,-(sp)
	move.b	-(a0),d7
	move.b	-(a0),d6
	moveq	#0,d3

SYN461	bsr.b	syn467
	beq.b	syn466
	bsr.b	syn467
	bne.b	syn462
	moveq	#1,d0
	bsr.b	syn468
	addq.b	#2,d5
	cmp.b	#5,d5
	bne.b	syn462
	moveq	#1,d0
	bsr.b	syn468
	addq.b	#5,d5
	cmp.b	#8,d5
	bne.b	syn462
	moveq	#2,d0
	bsr.b	syn468
	addq.b	#8,d5
	cmp.b	#15,d5
	bne.b	syn462
	moveq	#8,d0
	bsr.b	syn468
SYN462	subq.w	#1,d5
SYN463	tst.b	UI_Temp(a4)
	beq.b	syn464
	move.b	-(a0),-(a1)
	bra.b	syn465

SYN464	subq.l	#1,a0
SYN465	addq.l	#1,d3
	dbra	d5,syn463
SYN466	cmp.l	a0,d2
	blt.b	syn4611
	movem.l	(sp)+,d4-d7/a0/a3-a6
	rts

SYN467	clr.w	d0
SYN468	moveq	#0,d5
SYN469	tst.b	d7
	bne.b	syn4610
	moveq	#8,d7
	move.b	-(a0),d6
SYN4610	lsl.b	#1,d6
	roxl.l	#1,d5
	subq.b	#1,d7
	dbra	d0,syn469
	clr.w	d0
	tst.l	d5
	rts

SYN4611	bsr.b	syn467
	beq.b	syn4616
	moveq	#2,d4
	move.l	a6,a3
	lea	16(a6),a5
SYN4612	moveq	#2,d0
	bsr.b	syn468
	move.b	(a3,d5.w),d0
	asl.b	#1,d5
	move.w	(a5,d5.w),d1
	bsr.b	syn468
	add.w	d1,d5
	move.l	a1,a2
	add.l	d5,a2
	subq.w	#1,d4
SYN4613	tst.b	UI_Temp(a4)
	beq.b	syn4614
	move.b	-(a2),-(a1)
	bra.b	syn4615

SYN4614	subq.l	#1,a2
SYN4615	addq.l	#1,d3
	dbra	d4,syn4613
	bra.w	syn461

SYN4616	lea	8(a6),a3
	lea	32(a6),a5
	bsr.b	syn467
	bne.b	syn4617
	moveq	#3,d4
	bra.b	syn4612

SYN4617	moveq	#1,d0
	bsr.b	syn468
	addq.b	#4,d5
	cmp.b	#6,d5
	blt.b	syn4620
	bne.b	syn4618
	moveq	#1,d0
	bsr.b	syn468
	addq.b	#6,d5
	bra.b	syn4620

SYN4618	moveq	#4,d0
	bsr.b	syn468
	addq.b	#8,d5
	cmp.b	#9,d5
	beq.b	syn4619
	cmp.b	#8,d5
	bne.b	syn4620
	moveq	#4,d0
	bsr.w	syn468
	add.b	#$28,d5
	bra.b	syn4620

SYN4619	moveq	#8,d0
	bsr.w	syn468
	add.w	#$48,d5
SYN4620	move.w	d5,d4
	bra.b	syn4612

; Pass 2 Decruncher

SYNC246	movem.l	d4/d7/a0/a2/a6,-(sp)
	moveq	#0,d3
SYN2461	moveq	#0,d0
SYN2462	move.b	-(a0),d0
	cmp.b	d7,d0
	beq.b	syn2464
	cmp.b	d4,d0
	beq.b	syn2463
	addq.l	#1,d3
	tst.b	UI_Temp(a4)
	beq.b	syn2462
	move.b	d0,-(a1)
	bra.b	syn2462

SYN2463	move.b	-(a0),d0
	clr.b	d1
	bra.b	syn2465

SYN2464	move.b	-(a0),d0
	cmp.b	#1,d0
	beq.b	syn2467
	move.b	-(a0),d1
SYN2465	addq.l	#1,d3
	tst.b	UI_Temp(a4)
	beq.b	syn2466
	move.b	d1,-(a1)
SYN2466	dbra	d0,syn2465
	bra.b	syn2461

SYN2467	movem.l	(sp)+,d4/d7/a0/a2/a6
	rts
;------------------------------------------------------------------------------
