;******************************************************************************
;* TUC                                                                        *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.16d

TUC116D	dc.w	tuc116dd-tuc116d,tuc116dt-tuc116d,CN_TUC116d,typenum
	dc.b	CRU_Address,0
	dc.w	$500
	dc.l	0
	dc.w	tuc116da-tuc116d,_tuc116d-tuc116d,0

TUC116DT PSNAME	"TUC 1.16d"

TUC116DA dc.w	$62,4-1
	dc.l	$7000e385,$660a2a1a,$b78544fc,$0010e395

_TUC116D
	move.l	16(a0),d0
	sub.l	12(a0),d0
	move.l	d0,d1
	lsl.l	#2,d0
	lea	28(a0,d0.l),a0
	cmp.w	#$4e71,$130(a0)
	bne.b	.nojmp
	move.l	$138(a0),UI_JumpAdr(a4)
.NOJMP	move.l	(a0)+,d0
	lsl.l	#2,d0
	lea	24(a0,d0.l),a0
	subq.l	#1,d1
	mulu	#12,d1
	lea	8(a0,d1.l),a5		;Start Of Crunched Data

	move.b	1(a5),d0
	addq.b	#1,d0
	and.w	#$fe,d0
	move.l	2(a5,d0.w),UI_Address(a4)
	bra.b	utuc
;------------------------------------------------------------------------------
; 1.16d Data

TUC116DD dc.w	squez61-tuc116dd,tuc116ddt-tuc116dd,CN_TUC116dD,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	$40
	dc.l	0
	dc.w	_tuc116ddt-tuc116dd,_tuc116dd-tuc116dd,0

TUC116DDT PSNAME "TUC 1.16d Data"

_TUC116DDT
	moveq	#0,d0			;Unknown
	move.b	1(a0),d1
	addq.b	#1,d1
	and.w	#$fe,d1
	lea	6(a0,d1.w),a0
	cmp.l	#"M.F.",(a0)
	bne.b	.out
	moveq	#-1,d0
.OUT	rts
	

_TUC116DD
	move.l	a0,a5
;;	bra.b	utuc
;------------------------------------------------------------------------------
; TUC Decruncher Routine
;

UTUC	moveq	#0,d7
	move.b	(a5)+,d7
	swap	d7
	move.b	(a5)+,d7		;Number Of Hunks
	move.l	#"rich",d3
	move.w	d7,d0
	addq.w	#1,d0
	and.w	#$fe,d0
	lea	(a5,d0.w),a1
	move.w	d7,d0
	lsl.w	#2,d0
	lea	$10(a1,d0.w),a2
	move.l	(a2)+,d6
	eor.l	d6,d3
	swap	d6
	neg.l	d6
	eor.l	#$9c978d97,d6

	movem.l	d3/d6-d7/a1-a2/a5,-(sp)
	sub.l	a0,a0
	st	UI_Temp(a4)
	bsr.b	utuc1			;Count Decrunched Size
	clr.l	UI_Temp(a4)
	movem.l	(sp)+,d3/d6-d7/a1-a2/a5

	move.l	a0,d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	utuco
	move.l	d0,a3
	bsr.b	utuc1			;Decrunch Data
UTUCO	rts

UTUC1	moveq	#0,d5
	move.w	(a2)+,d0
	beq.w	utuc12
	move.l	a2,a6
	lea	(a2,d0.w),a2
	move.w	d6,d0
	moveq	#0,d1
	move.b	(a5,d0.w),d1
	bsr.w	utuc13
	move.l	d0,d4
	add.l	a3,d4			;End Of Decrunched Data

UTUC2	moveq	#0,d0
UTUC3	asl.l	#1,d5
	bne.b	utuc4
	move.l	(a2)+,d5
	eor.l	d3,d5
	move.w	#$10,ccr
	roxl.l	#1,d5
UTUC4	bcc.b	utuc5
	addq.w	#2,d0
UTUC5	move.w	(a6,d0.w),d0
	bpl.b	utuc3
	not.w	d0
	cmp.w	#$100,d0
	bcs.w	utuc10
	bne.b	utuc6
	move.l	d7,d1
	swap	d1
	bsr.w	utuc13
	moveq	#0,d1
	move.b	(a5,d0.w),d1
	asl.w	#2,d0
	move.l	(a1,d0.w),d2
	bsr.w	utuc13
	add.l	d2,d0
	tst.b	UI_Temp(a4)
	bne.b	utuc5a
	move.l	d0,(a3)+
	bra.w	utuc11

UTUC5a	addq.l	#4,a0
	addq.l	#4,a3
	bra.w	utuc11

UTUC6	cmp.w	#$110,d0
	bhi.b	utuc8
	sub.w	#$101,d0
	move.w	d0,d1
	bsr.w	utuc13
	move.w	d0,d2
	moveq	#7,d1
	bsr.w	utuc13
	tst.b	UI_Temp(a4)
	bne.b	utuc7b
UTUC7	move.b	d0,(a3)+
	cmp.l	d4,a3
	dbeq	d2,utuc7
	cmp.w	#-1,d2
	beq.b	utuc10
UTUC7a	move.w	#UERR_Corrupt,UI_ErrorNum(a4)
	moveq	#0,d0			;Error
	rts

UTUC7b	addq.l	#1,a0
	addq.l	#1,a3
	cmp.l	d4,a3
	dbeq	d2,utuc7b
	cmp.w	#-1,d2
	beq.b	utuc10
	bra.b	utuc7a

UTUC8	move.w	d0,d2
	move.w	d0,d1
	and.w	#15,d1
	bsr.b	utuc13
	addq.w	#3,d0
	move.w	d2,d1
	move.w	d0,d2
	lsr.w	#4,d1
	and.w	#15,d1
	addq.w	#2,d1
	bsr.b	utuc13
	neg.l	d0
	tst.b	UI_Temp(a4)
	bne.b	utuc9a
UTUC9	move.b	(a3,d0.l),(a3)+
	cmp.l	d4,a3
	dbeq	d2,utuc9
	cmp.w	#-1,d2
	beq.b	utuc11
	bra.b	utuc7a

UTUC9a	addq.l	#1,a0
	addq.l	#1,a3
	cmp.l	d4,a3
	dbeq	d2,utuc9a
	cmp.w	#-1,d2
	beq.b	utuc11
	bra.b	utuc7a

UTUC10	tst.b	UI_Temp(a4)
	bne.b	utuc10a
	move.b	d0,(a3)+
	bra.b	utuc11

UTUC10a	addq.l	#1,a0
	addq.l	#1,a3
UTUC11	cmp.l	d4,a3
	bne.w	utuc2
UTUC12	addq.w	#1,d6
	cmp.w	d7,d6
	bcs.w	utuc1
	moveq	#-1,d0			;Ok
	rts

UTUC13	moveq	#0,d0
UTUC14	asl.l	#1,d5
	bne.b	utuc15
	move.l	(a2)+,d5
	eor.l	d3,d5
	move.w	#$10,ccr
	roxl.l	#1,d5
UTUC15	roxl.l	#1,d0
	dbra	d1,utuc14
	rts
;------------------------------------------------------------------------------
