;******************************************************************************
;* TurboSqueezer                                                              *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 6.1

SQUEZ61	dc.w	squez80-squez61,squez61t-squez61,CN_TSqueeze61,typenum
	dc.b	CRU_Object,0
	dc.w	$238
	dc.l	0
	dc.w	squez61d-squez61,_squez61-squez61,0

SQUEZ61T PSNAME	"TurboSqueezer 6.1"

SQUEZ61D dc.w	$e0,12-1
	dc.l	$e28f6602,$61446462,$e28f6602,$613c6504
	dc.l	$74006026,$e28f6602,$61306506,$74017200
	dc.l	$6012e28f,$66026122,$64067407,$72056004

_SQUEZ61
	lea	$208(a0),a3
	moveq	#$14,d0
	add.l	(a3),d0			;Decrunched Length
	move.l	8(a3),d1		;Number Of Hunks
	lsl.l	#2,d1
	lea	$18(a3,d1.l),a2
	add.l	d1,d0
	add.l	d1,d0
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out

	move.l	d0,a1
	move.l	#$3f3,(a1)+
	clr.l	(a1)+
	move.l	8(a3),d0
	move.l	d0,(a1)+
	clr.l	(a1)+
	subq.l	#1,d0
	move.l	d0,(a1)+
	move.l	a1,-(sp)

	lea	12(a3),a0
	move.l	8(a3),d0
.COPY	move.l	(a0)+,d1
	subq.l	#2,d1
	move.l	d1,(a1)+
	subq.l	#1,d0
	bne.b	.copy

	move.l	a2,a0
	move.l	a1,a2
	add.l	(a3),a1
	move.l	a1,a5
	add.l	4(a3),a0
	bsr.w	utsq61

	move.l	8(a3),d2
	move.l	a2,a1
	move.l	(sp)+,a2
	bsr.w	rtsq			;Make Reloc File
.OUT	rts
;------------------------------------------------------------------------------
; 8.0

SQUEZ80	dc.w	squez80s-squez80,squez80t-squez80,CN_TSqueeze80,typenum
	dc.b	CRU_Object,0
	dc.w	$230
	dc.l	0
	dc.w	squez80d-squez80,_squez80-squez80,0

SQUEZ80T PSNAME	"TurboSqueezer 8.0"

SQUEZ80D dc.w	$de,12-1
	dc.l	$de876602,$6150646e,$de876602,$61486504
	dc.l	$74006026,$de876602,$613c6506,$74017200
	dc.l	$6012de87,$6602612e,$64067407,$72056004

_SQUEZ80
	lea	$210(a0),a3
	bra.b	usque80
;------------------------------------------------------------------------------
; 8.0 Small

SQUEZ80S dc.w	turt141-squez80s,squez80st-squez80s,CN_TSqueeze80S,typenum
	dc.b	CRU_Object,0
	dc.w	$200
	dc.l	0
	dc.w	squez80sd-squez80s,_squez80s-squez80s,0

SQUEZ80ST PSNAME "TurboSqueezer 8.0 Small"

SQUEZ80SD dc.w	$de,12-1
	dc.l	$613e6456,$613a6504,$7400601e,$61326506
	dc.l	$74017200,$600e6128,$64067407,$72056004
	dc.l	$72017403,$61283600,$d4407207,$61201300

_SQUEZ80S
	lea	$1e0(a0),a3
;;	bra.b	usque80
;------------------------------------------------------------------------------
; TurboSqueezer 8.0 Unpacking

USQUE80	moveq	#$14,d0
	add.l	4(a3),d0		;Decrunched Length
	move.l	8(a3),d1		;Number Of Hunks
	lsl.l	#2,d1
	add.l	d1,d0
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.w	rtsqo

	move.l	d0,a1
	move.l	#$3f3,(a1)+
	clr.l	(a1)+
	move.l	8(a3),d0
	move.l	d0,(a1)+
	clr.l	(a1)+
	subq.l	#1,d0
	move.l	d0,(a1)+

	move.l	a3,a0
	move.l	a1,a2
	add.l	4(a3),a1
	move.l	a1,a5
	add.l	(a0)+,a0
	addq.l	#8,a0
	bsr.w	utsq80

	move.l	8(a3),d2
	move.l	a2,a1
	move.l	d2,d0

.COPY	move.l	(a1),d1
	subq.l	#2,d1
	move.l	d1,(a1)+
	subq.l	#1,d0
	bne.b	.copy
;------------------------------------------------------------------------------
; Make Reloc File

RTSQ	move.l	(a1)+,d0		;Hunk
	cmp.w	#$3eb,d0
	beq.b	rtsq2
	move.l	(a1)+,d0
	lsl.l	#2,d0
	add.l	d0,a1
	addq.l	#4,a2
	move.l	(a1)+,d0
	cmp.w	#$3ec,d0
	bne.b	rtsq5
RTSQ1	move.l	(a1)+,d0
	beq.b	rtsq4
	move.l	(a1),d1
	lsr.l	#2,d1
	move.l	d1,(a1)+
	lsl.l	#2,d0
	add.l	d0,a1
	bra.b	rtsq1

RTSQ2	move.l	a5,a0
	addq.l	#4,a5
RTSQ3	move.l	-(a0),4(a0)
	cmp.l	a1,a0
	bne.b	rtsq3
	move.l	(a2)+,d0
	and.l	#$3fffffff,d0
	move.l	d0,(a1)+
RTSQ4	addq.l	#4,a1
RTSQ5	subq.l	#1,d2
	bne.b	rtsq

	sub.l	UI_DecrunchAdr(a4),a5
	move.l	a5,UI_DecrunchLen(a4)
	moveq	#-1,d0
RTSQO	rts
;------------------------------------------------------------------------------
; TurboSqueeze 6.1 Unpacker
;
; IN :	A0 = End Of Crunched Data
;	A1 = End Of Decruncher Buffer
;	A2 = Start Of Decruncher Buffer
;

UTSQ61	moveq	#-1,d5
	moveq	#$3f,d6
	moveq	#0,d7
UTS611	moveq	#0,d3
	lsr.l	#1,d7
	bne.b	uts612
	bsr.b	uts6116
UTS612	bcc.b	uts6111
	lsr.l	#1,d7
	bne.b	uts613
	bsr.b	uts6116
UTS613	bcs.b	uts614
	moveq	#0,d2
	bra.b	uts6110

UTS614	lsr.l	#1,d7
	bne.b	uts615
	bsr.b	uts6116
UTS615	bcs.b	uts616
	moveq	#1,d2
	moveq	#0,d1
	bra.b	uts619

UTS616	lsr.l	#1,d7
	bne.b	uts617
	bsr.b	uts6116
UTS617	bcc.b	uts618
	moveq	#7,d2
	moveq	#5,d1
	bra.b	uts619

UTS618	moveq	#1,d1
	moveq	#3,d2
UTS619	bsr.b	uts6117
	move.w	d0,d3
	add.w	d0,d2
UTS6110	moveq	#7,d1
	bsr.b	uts6117
	move.b	d0,-(a1)
	cmp.l	a2,a1
	dbeq	d2,uts6110
	cmp.w	d5,d2
	bne.b	uts6115

UTS6111	cmp.w	d6,d3
	beq.b	uts611
	lsr.l	#1,d7
	bne.b	uts6112
	bsr.b	uts6116
UTS6112	bcs.b	uts6120
	moveq	#11,d1
	bsr.b	uts6117
	move.w	d0,d3
	moveq	#2,d1
UTS6113	bsr.b	uts6117
	addq.w	#2,d0
UTS6114	move.b	(a1,d3.w),-(a1)
	cmp.l	a2,a1
	dbeq	d0,uts6114
	cmp.w	d5,d0
	beq.b	uts611
UTS6115	rts				;Get Out

UTS6116	move.l	-(a0),d7
	move.w	#$0010,ccr
	roxr.l	#1,d7
	rts

UTS6117	moveq	#0,d0
UTS6118	lsr.l	#1,d7
	bne.b	uts6119
	move.l	-(a0),d7
	move.w	#$0010,ccr
	roxr.l	#1,d7
UTS6119	roxl.w	#1,d0
	dbra	d1,uts6118
	rts

UTS6120	lsr.l	#1,d7
	bne.b	uts6121
	bsr.b	uts6116
UTS6121	bcs.b	uts6122
	moveq	#5,d1
	bsr.b	uts6117
	move.w	d0,d3
	moveq	#1,d1
	bra.b	uts6113

UTS6122	lsr.l	#1,d7
	bne.b	uts6123
	bsr.b	uts6116
UTS6123	bcs.b	uts6125
	moveq	#9,d1
	moveq	#64,d2
UTS6124	bsr.b	uts6117
	add.w	d2,d0
	move.b	(a1,d0.w),-(a1)
	cmp.l	a2,a1
	beq.b	uts6115
	move.b	(a1,d0.w),-(a1)
	cmp.l	a2,a1
	bne.w	uts611
	rts				;Get Out

UTS6125	lsr.l	#1,d7
	bne.b	uts6126
	bsr.b	uts6116
UTS6126	bcs.b	uts6127
	moveq	#5,d1
	moveq	#0,d2
	bra.b	uts6124

UTS6127	lsr.l	#1,d7
	bne.b	uts6128
	bsr.b	uts6116
UTS6128	bcs.b	uts6130
	moveq	#7,d1
	bsr.b	uts6117
	moveq	#4,d1
UTS6129	move.w	d0,d3
	bsr.b	uts6117
	add.w	#10,d0
	bra.w	uts6114

UTS6130	moveq	#11,d1
	bsr.b	uts6117
	moveq	#6,d1
	bra.b	uts6129
;------------------------------------------------------------------------------
; TurboSqueeze 8.0 Unpacker
;
; IN :	A0 = End Of Crunched Data
;	A1 = End Of Decruncher Buffer
;	A2 = Start Of Decruncher Buffer
;

UTSQ80	moveq	#-1,d5
	moveq	#$3f,d6
	moveq	#0,d7
UTS801	moveq	#0,d3
	add.l	d7,d7
	bne.b	uts802
	bsr.b	uts8016
UTS802	bcc.b	uts8011
	add.l	d7,d7
	bne.b	uts803
	bsr.b	uts8016
UTS803	bcs.b	uts804
	moveq	#0,d2
	bra.b	uts8010

UTS804	add.l	d7,d7
	bne.b	uts805
	bsr.b	uts8016
UTS805	bcs.b	uts806
	moveq	#1,d2
	moveq	#0,d1
	bra.b	uts809

UTS806	add.l	d7,d7
	bne.b	uts807
	bsr.b	uts8016
UTS807	bcc.b	uts808
	moveq	#7,d2
	moveq	#5,d1
	bra.b	uts809

UTS808	moveq	#1,d1
	moveq	#3,d2
UTS809	bsr.b	uts8017
	move.w	d0,d3
	add.w	d0,d2
UTS8010	moveq	#7,d1
	bsr.b	uts8017
	move.b	d0,-(a1)
	cmp.l	a2,a1
	dbeq	d2,uts8010
	cmp.w	d5,d2
	bne.b	uts8015

UTS8011	cmp.w	d6,d3
	beq.b	uts801
	add.l	d7,d7
	bne.b	uts8012
	bsr.b	uts8016
UTS8012	bcs.b	uts8020
	moveq	#11,d1
	bsr.b	uts8017
	move.w	d0,d3
	moveq	#2,d1
UTS8013	bsr.b	uts8017
	addq.w	#2,d0
UTS8014	move.b	(a1,d3.w),-(a1)
	cmp.l	a2,a1
	dbeq	d0,uts8014
	cmp.w	d5,d0
	beq.b	uts801
UTS8015	rts				;Get Out

UTS8016	move.l	-(a0),d7
	move.w	#$0010,ccr
	addx.l	d7,d7
	rts

UTS8017	moveq	#0,d0
UTS8018	add.l	d7,d7
	bne.b	uts8019
	move.l	-(a0),d7
	move.w	#$0010,ccr
	addx.l	d7,d7
UTS8019	roxl.w	#1,d0
	dbra	d1,uts8018
	rts

UTS8020	add.l	d7,d7
	bne.b	uts8021
	bsr.b	uts8016
UTS8021	bcs.b	uts8022
	moveq	#5,d1
	bsr.b	uts8017
	move.w	d0,d3
	moveq	#1,d1
	bra.b	uts8013

UTS8022	add.l	d7,d7
	bne.b	uts8023
	bsr.b	uts8016
UTS8023	bcs.b	uts8025
	moveq	#9,d1
	moveq	#64,d2
UTS8024	bsr.b	uts8017
	add.w	d2,d0
	move.b	(a1,d0.w),-(a1)
	cmp.l	a2,a1
	beq.b	uts8015
	move.b	(a1,d0.w),-(a1)
	cmp.l	a2,a1
	bne.w	uts801
	rts				;Get Out

UTS8025	add.l	d7,d7
	bne.b	uts8026
	bsr.b	uts8016
UTS8026	bcs.b	uts8027
	moveq	#5,d1
	moveq	#0,d2
	bra.b	uts8024

UTS8027	add.l	d7,d7
	bne.b	uts8028
	bsr.b	uts8016
UTS8028	bcs.b	uts8030
	moveq	#7,d1
	bsr.b	uts8017
	moveq	#4,d1
UTS8029	move.w	d0,d3
	bsr.b	uts8017
	add.w	#10,d0
	bra.w	uts8014

UTS8030	moveq	#11,d1
	bsr.b	uts8017
	moveq	#6,d1
	bra.b	uts8029
;------------------------------------------------------------------------------
