;******************************************************************************
;* Turtle Smasher                                                             *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.3-1.41

TURT141	dc.w	turt200-turt141,turt141t-turt141,CN_Turtle141,typenum
	dc.b	CRU_Address,0
	dc.w	$182
	dc.l	0
	dc.w	turt141d-turt141,_turt141-turt141,0

TURT141T PSNAME "Turtle Smasher 1.3-1.41"

TURT141D dc.w	$e0,12-1
	dc.l	$36026000,$00107208,$e2886602,$6132651a
	dc.l	$720e6016,$7210e288,$66026124,$640c7208
	dc.l	$e2886602,$611a6502,$720c611e,$53431532

_TURT141
	lea	$16a(a0),a0
	move.l	(a0)+,UI_Address(a4)
	move.l	(a0)+,UI_JumpAdr(a4)

	move.l	(a0),d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	.out
	move.l	d0,a1
	move.l	a1,a2
	add.l	(a0)+,a2
	add.l	(a0),a0
	lea	-12(a0),a0
	bsr.w	umega0
.OUT	rts
;------------------------------------------------------------------------------
; 2.00

TURT200	dc.w	turt200d-turt200,turt200t-turt200,CN_Turtle200,typenum
	dc.b	CRU_Address,0
	dc.w	$432
	dc.l	0
	dc.w	turt200da-turt200,_turt200-turt200,0

TURT200T PSNAME "Turtle Smasher 2.00"

TURT200DA dc.w	$e0,12-1
	dc.l	$00143e33,$70025bcd,$fff46b00,$00127a0f
	dc.l	$3c1860e8,$3e337000,$5bcdffe2,$6af051cd
	dc.l	$00063c18,$7a0f0c6d,$800004f0,$67000056

_TURT200
	move.l	$41a(a0),UI_Address(a4)
	move.l	$41e(a0),UI_JumpAdr(a4)

	lea	$42a(a0),a0
	bra.b	uturt
;------------------------------------------------------------------------------
; 2.00 Data

TURT200D dc.w	ulti11-turt200d,turt200dt-turt200d,CN_Turtle200D,typenum
	dc.b	CRU_Data,PSF_RecogFunc
	dc.w	12
	dc.l	0
	dc.w	_turt200dt-turt200d,_turt200d-turt200d,0

TURT200DT PSNAME "Turtle Smasher 2.00 Data"

_TURT200DT
	moveq	#0,d0
	cmp.l	#"T.S ",(a0)		;Turtle Smasher 2.00 D
	bne.b	.out
	cmp.l	#"2.00",4(a0)
	bne.b	.out
	moveq	#-1,d0
.OUT	rts


_TURT200D
	addq.l	#8,a0
;;	bra.b	uturt
;------------------------------------------------------------------------------
; Turtle Smasher Decrunching Routine
;

UTURT	move.l	a0,-(sp)
	sub.l	a1,a1
	moveq	#0,d1
	moveq	#0,d5
	bsr.b	lhdecode		;Get Decrunched Size
	move.l	(sp)+,a0
	tst.l	d0
	beq.b	uturto

	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmemj
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	uturto

	move.l	d0,a1
	moveq	#0,d1
	moveq	#-1,d5
	bsr.b	lhdecode		;Decrunch
	beq.b	uturto
	moveq	#-1,d0
UTURTO	rts
;------------------------------------------------------------------------------
; Lh.library Decode - Decode data previously encoded by LhEncode
;
; Inputs:  d1 - size of source region (Unused)
;          a0 - pointer to source region
;          a1 - pointer to destination region
;          d5 - decrunch mark (0=no write)
;
; Outputs: d0 - size of destination region (after decompression)
;
; Note:    Previous contents of d0/d1, a0/a1 must be considered
;          gone.
;

LhDecode
	move.w	#UERR_Memory,UI_ErrorNum(a4)
	move.l	#4534,d0
	bsr.w	alcmemj			;Allocate Auxilary Buffer
	beq.b	lhdecoo

	move.l	d0,d7
	clr.l	-(sp)			;Size of auxilary buffer (unused)
	move.l	d0,-(sp)		;Auxilary buffer

	clr.l	-(sp)			;Size of destination buffer (unused)
	move.l	a1,-(sp)		;lh_Dst

	move.l	d1,-(sp)		;lh_SrcSize
	move.l	a0,-(sp)		;lh_Src

	move.l	sp,a0			;At this point we have created a
					;properly initialized LhBuffer-
					;sized structure right on the stack.

	bsr.b	lhdec			;Decompress data...

	lea	6*4(sp),sp		;Restore previous stack pointer
	move.l	d7,a1
	bsr.w	frememj			;Free Auxilary Buffer

LHDECOO	tst.l	d0
	rts

; Decrunch Routine

LHDEC	movem.l	d1-d7/a0-a6,-(sp)
	move.l	d0,a2
	move.w	d5,4532(a2)
	pea	(a0)
	bsr.b	lhdec1
	move.l	a1,d0
	move.l	(sp)+,a0
	sub.l	8(a0),d0
	move.l	d0,12(a0)
	movem.l	(sp)+,d1-d7/a0-a6
	rts

LHDEC1	pea	(a0)
	move.l	16(a0),a6
	move.l	a6,a0
	lea	$c60(a6),a1
	lea	$76e(a6),a2
	moveq	#-2,d0
	moveq	#0,d3
	moveq	#1,d1
	moveq	#2,d2
	move.w	#$13c,d7
LHDEC2	move.w	d1,(a0)+
	move.w	d0,(a1)+
	move.w	d3,-(a2)
	sub.w	d2,d0
	add.w	d2,d3
	dbra	d7,lhdec2

	moveq	#0,d6
	move.l	#$27a,d7
	move.l	a6,a0
	lea	$27a(a6),a1
	lea	$eda(a6),a2
	lea	$76e(a6),a3
	moveq	#4,d4
	moveq	#2,d2
	move.w	#$13b,d1
LHDEC3	move.w	(a0)+,d0
	add.w	(a0)+,d0
	move.w	d0,(a1)+
	move.w	d6,(a2)+
	move.w	d7,(a3)+
	move.w	d7,(a3)+
	add.w	d4,d6
	add.w	d2,d7
	dbra	d1,lhdec3

	move.w	d1,(a1)
	clr.w	$c5e(a6)
	move.l	(sp)+,a5
	move.l	(a5),a0
	move.l	8(a5),a1
	move.l	16(a5),a6
	move.l	a6,a5
	lea	$76e(a6),a4
	lea	$c60(a6),a3
	moveq	#1,d4
	moveq	#15,d5
	move.w	(a0)+,d6
	bra.b	lhdec6

LHDEC4	neg.w	d7
	lsr.w	d4,d7
	sub.w	d4,d7
	tst.w	4532(a5)
	beq.b	lhdec5
	move.b	d7,(a1)
LHDEC5	addq.l	#1,a1
LHDEC6	move.w	$4f0(a3),d7
LHDEC7	add.w	d6,d6
	bcc.b	lhdec9
	move.w	2(a3,d7.w),d7
	dbmi	d5,lhdec7
	bmi.b	lhdec10

LHDEC8	moveq	#15,d5
	move.w	(a0)+,d6
	bra.b	lhdec7

LHDEC9	move.w	(a3,d7.w),d7
	dbmi	d5,lhdec7
	bpl.b	lhdec8
LHDEC10	dbra	d5,lhdec11
	move.w	(a0)+,d6
	moveq	#15,d5
LHDEC11	cmp.w	#$8000,$4f0(a5)
	beq.b	lhdec16
	move.w	(a4,d7.w),d0
LHDEC12	lea	(a5,d0.w),a2
	move.w	(a2),d1
	add.w	d4,d1
	move.w	d1,(a2)+
	cmp.w	(a2)+,d1
	bls.b	lhdec16
LHDEC13	cmp.w	(a2)+,d1
	bhi.b	lhdec13
	subq.l	#4,a2
	move.l	a2,d2
	sub.l	a5,d2
	move.w	(a2),(a5,d0.w)
	move.w	d1,(a2)
	move.w	(a3,d0.w),d1
	bmi.b	lhdec14
	move.w	d2,2(a4,d1.w)
LHDEC14	move.w	d2,(a4,d1.w)
	move.w	(a3,d2.w),d3
	bmi.b	lhdec15
	move.w	d0,2(a4,d3.w)
LHDEC15	move.w	d1,(a3,d2.w)
	move.w	d0,(a4,d3.w)
	move.w	d3,(a3,d0.w)
	move.w	(a4,d2.w),d0
	bne.b	lhdec12
	bra.b	lhdec17

LHDEC16	move.w	(a4,d0.w),d0
	bne.b	lhdec12
LHDEC17	cmp.w	#$fe00,d7
	bge.w	lhdec4
	cmp.w	#$fd86,d7
	bgt.b	lhdec18
	rts				;Get Out

LHDEC18	rol.w	#8,d6
	subq.w	#7,d5
	bcc.b	lhdec19
	moveq	#0,d3
	move.w	(a0)+,d3
	swap	d3
	neg.w	d5
	rol.l	d5,d3
	move.w	d3,d1
	or.b	d6,d1
	swap	d3
	move.w	d3,d6
	neg.w	d5
	moveq	#15,d2
	add.w	d2,d5
	bra.b	lhdec20

LHDEC19	moveq	#0,d1
	move.b	d6,d1
	clr.b	d6
	dbra	d5,lhdec20
	move.w	(a0)+,d6
	moveq	#15,d5
LHDEC20	move.w	d1,d3
	add.w	d3,d3
	move.l	a0,-(sp)
	lea	lhtab,a0
	move.w	(a0,d3.w),d3
	move.l	(sp)+,a0
	clr.w	d2
	move.b	d3,d2
	clr.b	d3
	lsr.w	#2,d3
LHDEC21	add.w	d6,d6
	addx.w	d1,d1
	dbra	d5,lhdec22
	moveq	#15,d5
	move.w	(a0)+,d6
LHDEC22	dbra	d2,lhdec21
	and.w	#$003f,d1
	or.w	d3,d1
	lea	(a1),a2
	sub.w	d1,a2
	neg.w	d7
	sub.w	#$0201,d7
	lsr.w	#1,d7
	tst.w	4532(a5)
	beq.b	lhdec24
LHDEC23	move.b	(a2)+,(a1)+
	dbra	d7,lhdec23
	bra.w	lhdec6

LHDEC24	lea	1(a2,d7.w),a2
	lea	1(a1,d7.w),a1
	bra.w	lhdec6
;------------------------------------------------------------------------------
