;******************************************************************************
;* Ultimate Packer                                                            *
;******************************************************************************
TYPENUM	SET	TYPENUM+1
;------------------------------------------------------------------------------
; 1.1

ULTI11	dc.w	xpk-ulti11,ulti11t-ulti11,CN_Ultimate11,typenum
	dc.b	CRU_Object,0
	dc.w	$2ec
	dc.l	0
	dc.w	ulti11d-ulti11,_ulti11-ulti11,0

ULTI11T	PSNAME	"Ultimate Packer 1.1"

ULTI11D	dc.w	$6a,12-1
	dc.l	$76ff4eae,$ffbe2c78,$000447ed,$021443ed
	dc.l	$021045ed,$02147a00,$74006142,$41faff94
	dc.l	$48d06000,$2f6d0004,$003c4cdf,$7fff4e75

_ULTI11
	move.l	#$e18,d0
	bsr.w	alcmemj			;Allocate Buffer Memory
	move.l	d0,UI_Temp(a4)
	beq.w	uultio

	move.l	d0,a5
	lea	$2d8(a0),a1
	move.l	a1,$e14(a5)

	lea	$214(a5),a3
	lea	$210(a5),a1
	move.l	a3,a2
	moveq	#0,d5
	moveq	#0,d2
	bsr.w	uulti26
	bsr.w	uulti19
	move.l	d4,d6
	move.l	d6,8(a5)
	bsr.w	uulti19
	moveq	#$34,d0
	move.l	d4,12(a5)
	bne.b	uulti1
	moveq	#$24,d0
UULTI1	add.l	d6,d0
	lsl.l	#2,d4
	add.l	d4,d0
	move.l	d0,UI_DecrunchLen(a4)
	bsr.w	alcdmemj		;Allocate Decrunch Buffer
	move.l	d0,UI_DecrunchAdr(a4)
	beq.b	uultio

	move.l	d0,a6
	move.l	#$3f3,(a6)+
	clr.l	(a6)+
	move.l	#1,(a6)+
	clr.l	(a6)+
	clr.l	(a6)+
	move.l	d6,d0
	lsr.l	#2,d0
	move.l	d0,(a6)+

	move.l	#$3e9,(a6)+
	move.l	d0,(a6)+
	move.l	a6,4(a5)
	add.l	a6,d6

	lea	$210(a5),a1
	bsr.w	uulti17
	move.b	d3,(a5)
	bsr.w	uulti17
	move.b	d3,1(a5)
	bsr.w	uulti17
	move.b	d3,2(a5)
	bsr.w	uulti17
	move.b	d3,3(a5)

UULTI2	bsr.b	uulti7
	cmp.l	d6,a6
	bcs.b	uulti2

	move.l	#$3ec,(a6)+
	move.l	12(a5),d7
	beq.b	uulti4
	move.l	d7,(a6)+
	clr.l	(a6)+
UULTI3	bsr.w	uulti19
	move.l	d4,(a6)+
	subq.l	#1,d7
	bne.b	uulti3
	clr.l	(a6)+
	move.l	#$3f2,(a6)+
	bra.b	uulti5

UULTI4	move.l	#$3f2,-(a6)

UULTI5	moveq	#-1,d0
UULTIO	move.l	UI_Temp(a4),a1
	bsr.w	frememj			;Free Buffer Memory
	clr.l	UI_Temp(a4)
	rts

UULTI7	bsr.b	uulti17
	cmp.b	1(a5),d3
	beq.b	uulti8
	cmp.b	(a5),d3
	beq.b	uulti10
	cmp.b	2(a5),d3
	beq.b	uulti12
	cmp.b	3(a5),d3
	beq.b	uulti14
	move.b	d3,(a6)+
	rts

UULTI8	bsr.b	uulti17
	moveq	#0,d0
UULTI9	move.b	d0,(a6)+
	dbra	d3,uulti9
	rts

UULTI10	bsr.b	uulti17
	move.w	d3,d7
	bsr.b	uulti17
UULTI11	move.b	d3,(a6)+
	dbra	d7,uulti11
	rts

UULTI12	bsr.b	uulti17
	ext.l	d3
	addq.l	#1,d3
	asl.l	#8,d3
	movem.l	d3/a6,-(sp)
	add.l	d3,a6
	bsr.b	uulti7
	movem.l	(sp)+,d3/a0
	move.b	-(a6),d0
	subq.l	#1,d3
UULTI13	move.b	d0,(a0)+
	dbra	d3,uulti13
	rts

UULTI14	bsr.b	uulti17
	move.w	d3,d7
	bsr.b	uulti19
	move.l	4(a5),a0
	add.l	d4,a0
UULTI15	move.b	(a0)+,(a6)+
	dbra	d7,uulti15
UULTI16	rts

UULTI17	moveq	#0,d3
UULTI18	move.l	(a2,d3.w),d3
	bmi.b	uulti16
	bsr.b	uulti20
	bne.b	uulti18
	swap	d3
	bra.b	uulti18

UULTI19	moveq	#0,d4
	bsr.b	uulti17
	move.b	d3,d4
	lsl.l	#8,d4
	bsr.b	uulti17
	move.b	d3,d4
	lsl.l	#8,d4
	bsr.b	uulti17
	move.b	d3,d4
	rts

UULTI20	subq.w	#1,d2
	bcc.b	uulti23
	cmp.l	a1,a3
	bls.b	uulti21
	addq.w	#8,d2
	lea	$214(a5),a0
	cmp.l	a0,a3
	bne.b	uulti22
	subq.w	#8,d2
	bsr.b	uulti24
UULTI21	add.w	#$20,d2
	move.b	(a3)+,d5
	lsl.w	#8,d5
	move.b	(a3)+,d5
	swap	d5
	move.b	(a3)+,d5
	lsl.w	#8,d5
UULTI22	move.b	(a3)+,d5
UULTI23	btst	d2,d5
	rts

UULTI24	movem.l	d0/a0-a1,-(sp)
	move.l	$e14(a5),a0
	lea	$14(a5),a1
	move.w	#512-1,d0
UULTI25	move.b	(a0)+,(a1)+
	dbra	d0,uulti25
	move.l	a0,$e14(a5)
	movem.l	(sp)+,d0/a0-a1
	lea	$14(a5),a3
	rts

UULTI26	lea	$214(a5),a6
	moveq	#0,d4
	move.w	d4,-(sp)
	addq.l	#4,d4
	bsr.b	uulti28
	addq.l	#2,sp
	rts

UULTI27	bsr.b	uulti29
	move.w	4(sp),d1
	move.w	#-1,(a6,d1.w)
	move.b	d0,3(a6,d1.w)
	rts

UULTI28	bsr.b	uulti20
	bne.b	uulti27
	move.w	4(sp),d0
	move.w	d4,(a6,d0.w)
	move.w	d4,-(sp)
	addq.l	#4,d4
	bsr.b	uulti28
	addq.l	#2,sp
	move.w	4(sp),d0
	move.w	d4,2(a6,d0.w)
	move.w	d4,-(sp)
	addq.l	#4,d4
	bsr.b	uulti28
	addq.l	#2,sp
	rts

UULTI29	subq.w	#8,d2
	bcc.b	uulti31
	lea	$214(a5),a0
	cmp.l	a0,a3
	bne.b	uulti30
	bsr.b	uulti24
UULTI30	lsl.w	#8,d5
	move.b	(a3)+,d5
	addq.w	#8,d2
UULTI31	move.l	d5,d0
	lsr.l	d2,d0
	rts
;------------------------------------------------------------------------------
